// Batch DVD Streams Converter Source Code
// Created in Delphi 7
// Copyright by Aleksandr Ignatov
// http://beginwithsoftware.com/videoguides/batchdvdstreamsconverter.html


unit BatchDVDStreamsConverterUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,CommCtrl,ShellApi,ShlObj,Menus, StdCtrls, ComCtrls, CheckLst,
  ExtCtrls;

const
  WM_NOTIFYICON  = WM_USER+333;
  // How many files to convert maximum
  // 1000 is enough I suppose
  MediaFilesQ = 1000;

type
  TAppForm = class(TForm)
    AppMenu: TMainMenu;
    N1: TMenuItem;
    OnlineHelp1: TMenuItem;
    VideoAudioFilesGroupBox: TGroupBox;
    VideoStreamsGroupBox: TGroupBox;
    VideoAudioFilesListBox: TListBox;
    AddFileButton: TButton;
    RemoveButton: TButton;
    OutputFolderGroupBox: TGroupBox;
    ChangeButton: TButton;
    AudioStreamsGroupBox: TGroupBox;
    FileInfoGroupBox: TGroupBox;
    OutputFolderEdit: TEdit;
    VideoSettingsGroupBox: TGroupBox;
    AudioSettingsGroupBox: TGroupBox;
    ConversionProgressGroupBox: TGroupBox;
    ConversionProgressBar: TProgressBar;
    ProgressPercentLabel: TLabel;
    CommandGroupBox: TGroupBox;
    MinimizeButton: TButton;
    RunButton: TButton;
    VideoStreamsCheckListBox: TCheckListBox;
    AudioStreamsCheckListBox: TCheckListBox;
    VideoBitrateLabel: TLabel;
    VideoBitrateComboBox: TComboBox;
    CustomVideoBitrateEdit: TEdit;
    VideoFormatLabel: TLabel;
    VideoFormatComboBox: TComboBox;
    ChangeVideoFormatCheckBox: TCheckBox;
    VideoSourceAspectRatio: TLabel;
    VideoSourceAspectRatioComboBox: TComboBox;
    CustomVideoSourceAspectRatioEdit: TEdit;
    ChangeSourceAspectRatioCheckBox: TCheckBox;
    VideoTargetAspectRatioComboBox: TComboBox;
    VideoTargetAspectRatioLabel: TLabel;
    TwoPassConversionCheckBox: TCheckBox;
    HalfD1FrameSizeCheckBox: TCheckBox;
    AudioFormatLabel: TLabel;
    AC3AudioFormatCheckBox: TCheckBox;
    WAVAudioFormatCheckBox: TCheckBox;
    AudioBitrateLabel: TLabel;
    AudioBitrate128CheckBox: TCheckBox;
    AudioBitrate160CheckBox: TCheckBox;
    AudioBitrate192CheckBox: TCheckBox;
    AudioBitrate224CheckBox: TCheckBox;
    AudioBitrate256CheckBox: TCheckBox;
    AudioBitrate320CheckBox: TCheckBox;
    AudioBitrate384CheckBox: TCheckBox;
    AudioBitrate448CheckBox: TCheckBox;
    AudioChannelsLabel: TLabel;
    AudioChannels1CheckBox: TCheckBox;
    AudioChannels2CheckBox: TCheckBox;
    AudioChannels6CheckBox: TCheckBox;
    VideoCopyCheckBox: TCheckBox;
    AudioCopyCheckBox: TCheckBox;
    FileInfoLabel: TLabel;
    ools1: TMenuItem;
    JoinVOBFilesTool1: TMenuItem;
    MuxManDVDAuthoring1: TMenuItem;
    AddFileDialog: TOpenDialog;
    Preferences1: TMenuItem;
    AVIScanDelay1: TMenuItem;
    N2sec1: TMenuItem;
    N3sec1: TMenuItem;
    N5sec1: TMenuItem;
    N7sec1: TMenuItem;
    N10sec1: TMenuItem;
    N15sec1: TMenuItem;
    CancelConversionButton: TButton;
    CreateFolderCheckBox: TCheckBox;
    InterlacedFlag: TCheckBox;
    DVDProgressBar: TProgressBar;
    FreeHDDSpaceProgressBar: TProgressBar;
    HDDNameLabel: TLabel;
    DVDSizeComboBox: TComboBox;
    DVDSizeLabel: TLabel;
    ConversionTimer: TTimer;
    ShutdownPCwhenfinished: TMenuItem;
    SkipPulldownMenu: TMenuItem;
    procedure MinimizeButtonClick(Sender: TObject);
    procedure OnlineHelp1Click(Sender: TObject);
    procedure AddFileButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure JoinVOBFilesTool1Click(Sender: TObject);
    procedure MuxManDVDAuthoring1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ChangeButtonClick(Sender: TObject);
    procedure RemoveButtonClick(Sender: TObject);
    procedure N3sec1Click(Sender: TObject);
    procedure N2sec1Click(Sender: TObject);
    procedure N5sec1Click(Sender: TObject);
    procedure N7sec1Click(Sender: TObject);
    procedure N10sec1Click(Sender: TObject);
    procedure N15sec1Click(Sender: TObject);
    procedure VideoAudioFilesListBoxClick(Sender: TObject);
    procedure AudioStreamsCheckListBoxClickCheck(Sender: TObject);
    procedure VideoStreamsCheckListBoxClickCheck(Sender: TObject);
    procedure AudioStreamsCheckListBoxClick(Sender: TObject);
    procedure VideoStreamsCheckListBoxClick(Sender: TObject);
    procedure VideoBitrateComboBoxChange(Sender: TObject);
    procedure CustomVideoBitrateEditChange(Sender: TObject);
    procedure ChangeVideoFormatCheckBoxClick(Sender: TObject);
    procedure VideoFormatComboBoxChange(Sender: TObject);
    procedure InterlacedFlagClick(Sender: TObject);
    procedure ChangeSourceAspectRatioCheckBoxClick(Sender: TObject);
    procedure VideoSourceAspectRatioComboBoxChange(Sender: TObject);
    procedure CustomVideoSourceAspectRatioEditChange(Sender: TObject);
    procedure VideoTargetAspectRatioComboBoxChange(Sender: TObject);
    procedure TwoPassConversionCheckBoxClick(Sender: TObject);
    procedure HalfD1FrameSizeCheckBoxClick(Sender: TObject);
    procedure VideoCopyCheckBoxClick(Sender: TObject);
    procedure AC3AudioFormatCheckBoxClick(Sender: TObject);
    procedure WAVAudioFormatCheckBoxClick(Sender: TObject);
    procedure AudioBitrate128CheckBoxClick(Sender: TObject);
    procedure AudioBitrate160CheckBoxClick(Sender: TObject);
    procedure AudioBitrate192CheckBoxClick(Sender: TObject);
    procedure AudioBitrate224CheckBoxClick(Sender: TObject);
    procedure AudioBitrate256CheckBoxClick(Sender: TObject);
    procedure AudioBitrate320CheckBoxClick(Sender: TObject);
    procedure AudioBitrate384CheckBoxClick(Sender: TObject);
    procedure AudioBitrate448CheckBoxClick(Sender: TObject);
    procedure AudioCopyCheckBoxClick(Sender: TObject);
    procedure DVDSizeComboBoxChange(Sender: TObject);
    procedure RunButtonClick(Sender: TObject);
    procedure CancelConversionButtonClick(Sender: TObject);
    procedure ConversionTimerTimer(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure ShutdownPCwhenfinishedClick(Sender: TObject);
    procedure SkipPulldownMenuClick(Sender: TObject);
  private
    { Private declarations }
    tnid: TNotifyIconData;
    HMainIcon: HICON;
    procedure CMClickIcon(var msg: TMessage); message WM_NOTIFYICON;
    procedure DisableAllVideoSettings();
    procedure DisableAllAudioSettings();
    procedure DisableVideoSettings4Copy();
    procedure DisableVideoSettings4RemoveFromMediaList();
    procedure DisableAudioSettings4RemoveFromMediaList();
    procedure EnableAllVideoSettings();
    procedure EnableAllAudioSettings();
    procedure EnableVideoSettings4Copy(InputMediaFile,InputVideoStreamNumber:Integer);
    procedure UncheckAllAudioSettings();
    procedure UncheckAllAudioChannels();
    procedure UncheckAudioBitrate();
    procedure EnableAudioBitrateSettings();
    procedure DisableAudioBitrateSettings();
    procedure DisableAudioSettings4Copy();
    procedure EnableAudioSettings4Copy(InputMediaFile,InputAudioStreamNumber:Integer);
    procedure FileInfoTextShow();
    procedure RefreshVideoSettings(SelectedMediaFileNum:Integer);
    procedure RefreshAudioSettings(SelectedMediaFileNum:Integer);
    procedure DefineCurrentVideoOrAudioStream(var WhatStream,CurrentMediaFile,CurrentStreamNum:Integer);
    procedure CalculateDiskSpace();
    procedure VideoCopyCMD(var MediaFileVideoCopyCMD:string; var VideoStreamCopyCMD: Integer; var ResultVideoCopyCMD:string);
    procedure AudioCopyCMD(var MediaFileAudioCopyCMD:string; var AudioStreamCopyCMD: Integer; var ResultAudioCopyCMD:string);
    procedure VideoConvertCMD(var MediaFileVideoConvertCMD: string; var MediaFileVideoConvertRealNum, VideoStreamConvertCMD: Integer; var PassVideoConvertCMD, ResultVideoConvertCMD:string);
    procedure AudioCopyFFMPEGCMD(var MediaFileAudioCopyFFMPEGCMD: string; var MediaFileAudioCopyFFMPEGRealNum, AudioStreamCopyFFMPEGCMD: Integer; var ResultAudioCopyFFMPEGCMD:string);
    procedure AudioConvertFFMPEGCMD(var MediaFileAudioConvertCMD: string; var MediaFileAudioConvertRealNum, AudioStreamConvertCMD: Integer; var ResultAudioConvertCMD:string);
    procedure CreateOrNotFolder();
    procedure ConversionFinished();
    procedure ClearVideoAudioStreamsRename();
    procedure ClearDGStaticBufer();

  public
    { Public declarations }
  end;

var
  AppForm: TAppForm;

  // AMG Variables
  AMGScript:TextFile;
  AMGhProc,AMGhBut,AMGhWin,AMGhList,AMGhTree: THandle;
  AMGsi: STARTUPINFO;
  AMGpi: PROCESS_INFORMATION;
  AMGSecurity : TSecurityAttributes;
  AMGStartCMD:string;

  // DGIndex variables

  DGhProc,DGAspect,DGInfoWindow,DGMFDhProc: THandle;
  DGsi,DGMFDsi: STARTUPINFO;
  DGpi,DGMFDpi: PROCESS_INFORMATION;
  DGMediaName,DGProjectName,DGAspectRatio,
  DGFrameRate,DG_Ext,DGFrameType,DGVideoType,
  DG_AR_CalcText,
  DGMFDString,DGMFDShortString,DGMFDTextBlock,
  DGMFDbs,DGMFDLastSymbol:string;
  DGStaticBuffer: array [0..255] of Char;
  DGStaticBufferRead,FPSPos:Integer;
  SearchRec:TSearchRec;
  DGProc,DGMFDProc:DWORD;
  DGFiles: array [1..MediaFilesQ] of string;
  m,DGCount,DG_I,ARStopPos,
  DG_AC3_Count,DG_DTS_Count,DG_MPA_Count,
  DG_AAC_Count,DG_WAV_Count,DG_AR_Code,DG_FindInfoRepeat,
  S0,S1,S2,S3,NumFrames,DGFrameRateValueErrCode,D2VPercent:Integer;
  DelRes:Boolean;
  DG_AC3_Index,DG_DTS_Index,DG_MPA_Index,DG_AAC_Index,DG_WAV_Index: array [1..20] of Integer;
  DG_AR_Value,DG_SAR,DGFrameRateValue:real;
  DGMFDTextFile:TextFile;

  // Main Variables

  AppPath,AppName,AppVersion,st,OutputPath,OldOutputPath,CurrMediaFile,
  MediaInfoText,ClearBlock,FFMPEGPath,
  ParsedTextBlock,MediaStreamNumber,
  RightFrameSizeBlock,LeftFrameSizeBlock,
  YFrameSizeBlock,XFrameSizeBlock,
  AMGFilePath,AMGScriptPath,TreeNodeText,
  AMGDelay,SwapText,DGDelayText,DGWorkFileText,
  ActiveAudioFormatProcedure,ActiveAudioBitrateProcedure,
  MediaFileName4DiskSpace,DiskDriveName,DGVideoBitrateTextValue,
  CurrentConversionOutputPath,CurrentConversionMediaFile,CopyVideoStream4PulldownFileName:string;
  MediaListFilesQ,AllMediaFilesQ,i,j,StartPos,StopPos,CurrMediaFileIndex,
  CurrAudioCount,CurrVideoCount,SelectedMediaFileIndex,
  BufferCounter,DurationTimeDigit,DurationErrCode,
  AudioInputBitrateStopPos,AudioInputBitrateErrCode,
  AudioInputBitrateValue,AudioInputBitrateStartPos,
  CalcTimeMSec,CalcMediaStreams,CurrStreamStringPos,OldStreamStringPos,
  InsideStreamBlockAudioPos,InsideStreamBlockVideoPos,VideoFrameSizeXPos,
  VideoFrameXValue,VideoFrameYValue,FrameSizeCode,SMS,TreeNodesCount,
  AMGAudioCount,FFMPEG_AC3_Count,FFMPEG_DTS_Count,FFMPEG_MP2_Count,FFMPEG_AAC_Count,FFMPEG_PCM_Count,
  Audio_Scan_I,AVIScanTime,MediaUserNum,ChangedMediaFilesPos,WhatStreamToSelect,
  CurrMediaFileInList,AspectIndex,SAR_Code,CurrSV,CurrSA,ReDefineChannelsPos,
  VideoBitrateSelectedIndex,AudioStreamNumber,VideoStreamNumber,ProcQ,
  MediaUserNum4DiskSpace,AudioStreamBitrateValue,VideoStreamBitrateValue,
  AudioStreamBitrateValueErrCode,VideoStreamBitrateValueErrCode,
  DGMPEGFileBitrate,DGVideoBitrateValue,VideoBitrateTextStartPos,VideoBitrateTextStopPos,
  CurrentMediaConversionNum,CurrentVideoConversionNum,
  CurrentAudioConversionNum,RealConversionMediaNum,CurrentVideoConversionPassNum,
  ProcRunState,ConversionTimePercent:Integer;
  AudioStreamCheckedFlag,VideoStreamCheckedFlag,
  RefreshVideoBitrateChanged,ReDefineChannelsFound,
  WhatAudioFormat,CopyProgress,ConversionProgress,
  AudioConversionProcess,VideoConversionProcess,NeedToBeRenamed,
  AudioStreamsFinished,VideoStreamsFinished,
  PulldownNeeded,Pulldown23_98,Pulldown24_00,
  SkipPulldown:boolean;
  DiskSpaceBytes,MediaFileSize4DiskSpace,AudioSpaceSegment,VideoSpaceSegment,
  AudioSpaceFromTime,VideoSpaceFromTime,FreeDriveSpace,DriveSize,
  DGMPEGFileSize,D2VFileSize,DGAudioSpaceSegment,DGVideoSpaceSegment:Int64;
  DiskSpaceTS,DGMPEGTS,DeleteRenameSearch,CopyProgressTS:TSearchRec;
  CurrentDriveCode:Byte;
  // Conversion Process Variables
  hProc,ConversionhWnd,PulldownhProc: THandle;
  ConversionSA : TSecurityAttributes;
  ConversionStartupInfo : TStartupInfo;
  ConversionProcessInfo : TProcessInformation;

  // Audio and Video Streams Input Arrays
  MediaFullInfo,MediaFileType,MediaFileDurationInfo,MediaFileBitrateInfo: array [1..MediaFilesQ] of string;
  StreamBlock: array [0..19] of string;
  AudioStreamCount,VideoStreamCount: array [1..MediaFilesQ] of Integer;
  AudioStreamInfo,VideoStreamInfo,
  AudioStreamMap,VideoStreamMap: array [1..MediaFilesQ,1..20] of string;
  MediaFileDuration: array [1..MediaFilesQ] of Integer;
  AudioStreamType, VideoStreamType: array [1..MediaFilesQ,1..20] of string;
  AudioStreamInputChannels,VideoStreamFrameRate: array [1..MediaFilesQ,1..20] of string;
  AudioStreamInputFrequency: array [1..MediaFilesQ,1..20] of string;
  AudioStreamInputBitrate: array [1..MediaFilesQ,1..20] of Integer;
  VideoStreamFrameSizeX,VideoStreamFrameSizeY: array [1..MediaFilesQ,1..20] of Integer;
  AudioStreamDelay: array [1..MediaFilesQ,1..20] of string;
  AudioStream_DG_Copy_Index: array [1..MediaFilesQ,1..20] of Integer;
  AudioStreamChecked,VideoStreamChecked: array [1..MediaFilesQ,1..20] of boolean;
  FFMPEG_AC3_Index,FFMPEG_DTS_Index,FFMPEG_MP2_Index,FFMPEG_AAC_Index,FFMPEG_PCM_Index: array [1..20] of Integer;
  VideoType,FrameType: array [1..MediaFilesQ,1..20] of string;
  SAR_Value,FrameRealValue,FilmFrame,Film24Frame,PALFrame,NTSCFrame:real;
  NonStandardFrameCode:Integer;


  // Video Conversion Settings Arrays
  VideoStreamBitrate,VideoStreamFormat,
  VideoStreamSourceAR,VideoStreamTargetAR,VideoStreamDG_AR,
  CopyVideoStreamPulldownMode:array [1..MediaFilesQ,1..20] of string;
  ChangeFormatChecked,Interlaced,InterlacedEnabled,
  ChangeSourceAspectRatioChecked,TwoPass,HalfD1,CopyVideoStream,
  CopyVideoStreamEnabled:array [1..MediaFilesQ,1..20] of boolean;

  // Form Objects Conditions for Video Copy
  ChangeSourceAspectRatioCheckBoxObjectState,
  ChangeVideoFormatCheckBoxObjectState,
  CustomVideoBitrateEditObjectState,
  CustomVideoSourceAspectRatioEditObjectState,
  InterlacedFlagObjectState,
  HalfD1FrameSizeCheckBoxObjectState,
  TwoPassConversionCheckBoxObjectState,
  VideoBitrateComboBoxObjectState,
  VideoCopyCheckBoxObjectState,
  VideoFormatComboBoxObjectState,
  VideoSourceAspectRatioComboBoxObjectState,
  VideoTargetAspectRatioComboBoxObjectState:array [1..MediaFilesQ,1..20] of boolean;

  // Audio Conversion Settings Arrays
  AC3Format,WAVFormat,WAVFormatEnabled:array [1..MediaFilesQ,1..20] of boolean;
  AudioStreamBitrate,AudioStreamChannels:array [1..MediaFilesQ,1..20] of string;
  CopyAudioStream,CopyAudioStreamEnabled:array [1..MediaFilesQ,1..20] of boolean;

  // Current Audio and Video Streams State Arrays
  CurrVideoStream,CurrAudioStream: array  [1..MediaFilesQ] of Integer;
  // Real Position in Media Arrays
  RealPosition,BufferForPosition: array [1..MediaFilesQ] of Integer;
  // Video and Audio Streams Conversion Names
  AudioStreamsRename,VideoStreamsRename: array [1..20] of string;
  // AppLog.txt Variables
  AppLogTextFile:TextFile;
  AppLogDateTime:TDateTime;
  AppLogTimeString:string;
  AppLogFileClosed:boolean;

implementation

{$R *.dfm}

function DefineDriveCode(DrivePath:String):Byte;
var
DiskNameSymbol:string;
begin
Result:=255;
DiskNameSymbol:=Copy(DrivePath,1,1);
if (DiskNameSymbol='a') or (DiskNameSymbol='A') then
Result:=1;
if (DiskNameSymbol='b') or (DiskNameSymbol='B') then
Result:=2;
if (DiskNameSymbol='c') or (DiskNameSymbol='C') then
Result:=3;
if (DiskNameSymbol='d') or (DiskNameSymbol='D') then
Result:=4;
if (DiskNameSymbol='e') or (DiskNameSymbol='E') then
Result:=5;
if (DiskNameSymbol='f') or (DiskNameSymbol='F') then
Result:=6;
if (DiskNameSymbol='g') or (DiskNameSymbol='G') then
Result:=7;
if (DiskNameSymbol='h') or (DiskNameSymbol='H') then
Result:=8;
if (DiskNameSymbol='i') or (DiskNameSymbol='I') then
Result:=9;
if (DiskNameSymbol='j') or (DiskNameSymbol='J') then
Result:=10;
if (DiskNameSymbol='k') or (DiskNameSymbol='K') then
Result:=11;
if (DiskNameSymbol='l') or (DiskNameSymbol='L') then
Result:=12;
if (DiskNameSymbol='m') or (DiskNameSymbol='M') then
Result:=13;
if (DiskNameSymbol='n') or (DiskNameSymbol='N') then
Result:=14;
if (DiskNameSymbol='o') or (DiskNameSymbol='O') then
Result:=15;
if (DiskNameSymbol='p') or (DiskNameSymbol='P') then
Result:=16;
if (DiskNameSymbol='q') or (DiskNameSymbol='Q') then
Result:=17;
if (DiskNameSymbol='r') or (DiskNameSymbol='R') then
Result:=18;
if (DiskNameSymbol='s') or (DiskNameSymbol='S') then
Result:=19;
if (DiskNameSymbol='t') or (DiskNameSymbol='T') then
Result:=20;
if (DiskNameSymbol='u') or (DiskNameSymbol='U') then
Result:=21;
if (DiskNameSymbol='v') or (DiskNameSymbol='V') then
Result:=22;
if (DiskNameSymbol='w') or (DiskNameSymbol='W') then
Result:=23;
if (DiskNameSymbol='x') or (DiskNameSymbol='X') then
Result:=24;
if (DiskNameSymbol='y') or (DiskNameSymbol='Y') then
Result:=25;
if (DiskNameSymbol='z') or (DiskNameSymbol='Z') then
Result:=26;
end;


function GetMediaData(GetMediaDataRunCMD:string):string;
var
  GetMediaDataSA : TSecurityAttributes;
  GetMediaDatahScreen : THandle;
  GetMediaDataStartupInfo : TStartupInfo;
  GetMediaDataProcessInfo : TProcessInformation;
  GetMediaDataAll:array [0..8000] of char;
  GetMediaDataBuffCoord,GetMediaDataReg : TCoord;
  GetMediaDataS : String;
  GetMediaDatahWnd: THandle;
  GetMediaDataRes:DWORD;

begin
  Result:='';
  GetMediaDataSA.nLength := SizeOf(GetMediaDataSA);
  GetMediaDataSA.bInheritHandle := True;
  GetMediaDataSA.lpSecurityDescriptor := nil;
  FillChar(GetMediaDataStartupInfo, SizeOf(GetMediaDataStartupInfo),0);
  GetMediaDataStartupInfo.cb := SizeOf(GetMediaDataStartupInfo);
  GetMediaDataStartupInfo.dwFlags:=STARTF_USESHOWWINDOW;
  GetMediaDataStartupInfo.wShowWindow:=SW_SHOWNORMAL;
  AllocConsole;
  SetConsoleTitle(PChar('BatchDVDStreamsConverterGetMediaInfo'));
  CreateProcess( nil,
                            PChar(GetMediaDataRunCMD),
                            nil,
                            nil,
                            false,
                            0,
                            nil,
                            nil,
                            GetMediaDataStartupInfo,
                            GetMediaDataProcessInfo);
  CloseHandle(GetMediaDataProcessInfo.hThread);
  WaitForSingleObject(GetMediaDataProcessInfo.hProcess,INFINITE);
  GetMediaDatahWnd := FindWindow(nil,'BatchDVDStreamsConverterGetMediaInfo');
  ShowWindow(GetMediaDatahWnd,SW_HIDE);
  GetMediaDatahScreen := GetStdHandle(STD_OUTPUT_HANDLE);
  if GetMediaDatahScreen <> INVALID_HANDLE_VALUE then begin
  GetMediaDataReg.X:=80;
  GetMediaDataReg.Y:=100;
  SetConsoleScreenBufferSize(GetMediaDatahScreen,GetMediaDataReg);
  GetMediaDataBuffCoord.X := 0;
  GetMediaDataBuffCoord.Y := 0;
  GetMediaDataS := '';

  ReadConsoleOutputCharacter(GetMediaDatahScreen,GetMediaDataAll,8000,GetMediaDataBuffCoord,GetMediaDataRes);

  if GetMediaDatahScreen > 0 then
  CloseHandle(GetMediaDatahScreen);
  CloseHandle(GetMediaDataProcessInfo.hProcess);
  FreeConsole;
  SendMessage(GetMediaDatahWnd,WM_CLOSE,0,0);
  GetMediaDataS:=string(GetMediaDataAll);
  OemtoChar(PChar(GetMediaDataS),PChar(GetMediaDataS));
  Result:=GetMediaDataS;
  end;
end;

function ReadConversionData():string;
var
  ReadConversionDatahScreen : THandle;
  ReadConversionDataAll:array [0..8000] of char;
  ReadConversionDataBuffCoord,ReadConversionDataReg : TCoord;
  ReadConversionDataS : String;
  ReadConversionDataRes:DWORD;

begin
  Result:='';
  ReadConversionDatahScreen := GetStdHandle(STD_OUTPUT_HANDLE);
  if ReadConversionDatahScreen <> INVALID_HANDLE_VALUE then
        begin
        ReadConversionDataReg.X:=80;
        ReadConversionDataReg.Y:=100;
        SetConsoleScreenBufferSize(ReadConversionDatahScreen,ReadConversionDataReg);
        ReadConversionDataBuffCoord.X := 0;
        ReadConversionDataBuffCoord.Y := 0;
        ReadConversionDataS:= '';

        ReadConsoleOutputCharacter(ReadConversionDatahScreen,ReadConversionDataAll,8000,ReadConversionDataBuffCoord,ReadConversionDataRes);

        ReadConversionDataS:=string(ReadConversionDataAll);
        OemtoChar(PChar(ReadConversionDataS),PChar(ReadConversionDataS));
        Result:=ReadConversionDataS;
        end;
end;

function TextReverse(directstring:string):string;
var
kd:Integer;
begin
Result:='';
for kd:=length(directstring) downto 1 do
  begin
  Result:=Result+Copy(directstring,kd,1);
  end;
end;


function CheckForeignSymbols(UserString:string):boolean;
var FrgnIndex:Integer;
begin
Result:=False;
for FrgnIndex:=1 to length(UserString) do
  begin
  if ord(UserString[FrgnIndex])>126 then
    begin
    Result:=True;
    Break;
    end;
  end;
end;

function FindFirstZeroCode(SendString:String):Integer;
var z:Integer;
begin
Result:=0;
For z:=1 to Length(SendString) do
  begin
  If ord(SendString[z])=0 then
    begin
    Result:=z;
    Break;
    end;
  end;
end;

function ExtractTextBlock(FullString,StartTextBlock,StopTextBlock:string):string;
var
ExtractStartPos,ExtractStopPos:Integer;
RightTextBlock:string;
begin
Result:='';
ExtractStartPos:=Pos(StartTextBlock,FullString);
If ExtractStartPos>0 then
  RightTextBlock:=Copy(FullString,ExtractStartPos+Length(StartTextBlock),(Length(FullString)-Length(StartTextBlock)-ExtractStartPos+1))
  else
  Exit;
ExtractStopPos:=Pos(StopTextBlock,RightTextBlock);
If ExtractStopPos>0 then
  Result:=Copy(RightTextBlock,1,ExtractStopPos-1)
  else
  Exit;
end;



function GetTreeNodesText(const TreeHand: HWND;  nodenum:Integer):string;
var
  hCurItem: HTREEITEM;
  ltvItem: TTVItem;
  TreeBuff: PChar;
  PID: THandle;
  PRC: THandle;
  R: Cardinal;
  MemoryBuffer : Pointer;
  ItemPos:Thandle;
  n:integer;
begin
  Result := '';
  ItemPos:=SendMessage( TreeHand, TVM_GETNEXTITEM, TVGN_FIRSTVISIBLE, 0 );
  if nodenum>1 then
    begin
    for n:=1 to nodenum-1 do begin
      ItemPos:=SendMessage( TreeHand, TVM_GETNEXTITEM, TVGN_NEXT,ItemPos);
    end;
  end;
  hCurItem := HTREEITEM(ItemPos);

  if (hCurItem = nil) then Exit;

  GetWindowThreadProcessId(TreeHand, @PID);
  PRC := OpenProcess(PROCESS_VM_OPERATION or PROCESS_VM_READ or PROCESS_VM_WRITE, False, PID);
  TreeBuff := VirtualAllocEx(PRC, nil, 4096, MEM_RESERVE or MEM_COMMIT, PAGE_READWRITE);

  FillChar(ltvItem, SizeOf(ltvItem), 0);
  with ltvItem do
  begin
    mask := TVIF_TEXT;
    hItem := hCurItem;
    cchTextMax := 2048;
    pszText := PChar(integer(TreeBuff) + SizeOf(ltvItem) * 4);
  end;

  WriteProcessMemory(PRC, TreeBuff, @ltvItem, Sizeof(ltvItem), R);
  SendMessage(TreeHand, TVM_GETITEM, 0, LongInt(TreeBuff));

  ReadProcessMemory(PRC, TreeBuff, @ltvItem, Sizeof(ltvItem), R);
  GetMem(MemoryBuffer,1024);
  ReadProcessMemory(PRC, PChar(integer(TreeBuff) + SizeOf(TTVItem) * 4), MemoryBuffer, 1024, R);
  Result := Trim(StrPas(MemoryBuffer));
  FreeMem(MemoryBuffer);
  VirtualFreeEx(PRC, TreeBuff, 0, MEM_RELEASE);
  CloseHandle(PRC);
end;


function ExtractFileNameNoExt(fullfilestr:string):string;
var
InFileExt,FileNameBlock,ExtBlock:string;
begin
InFileExt:=ExtractFileExt(fullfilestr);
If Length(InFileExt)=0 then
  begin
  // No extension in a file name
  Result:=ExtractFileName(fullfilestr)
  end
  else
  begin
  FileNameBlock:=ExtractFileName(fullfilestr);
  ExtBlock:=ExtractFileExt(fullfilestr);
        If FileNameBlock=ExtBlock then
              begin
              // Only extension for file name exists
              Result:='';
              end
              else
              begin
              Result:=Copy(FileNameBlock,1,Length(FileNameBlock)-Length(ExtBlock));
              end;

  end;

end;

function ExtractStringAfterSpacePos(InSt:string; SpaceNum:Integer):string;
var
InternalSpaceCount:Integer;
ExtractLetter:string;
begin
Result:='';
InternalSpaceCount:=0;
For i:=1 To Length(InSt) do
      begin
      ExtractLetter:=Copy(InSt, i, 1);
      If InternalSpaceCount>=SpaceNum then
            begin
            Result:=Result+ExtractLetter;
            end;
      If (ExtractLetter=' ') and (InternalSpaceCount<SpaceNum) then
            begin
            inc(InternalSpaceCount);
            end;
      end;
end;


function ConvertMSecsToDurationInfo(InpMSecs:Integer):string;
var
HoursInfo,MinsInfo,SecsInfo,TenSecsParts:Integer;
HoursInfoText,MinsInfoText,SecsInfoText,TenSecsPartsText:string;
TimeBlockInfo:real;
begin
Result:='';
// Hours
TimeBlockInfo:=InpMSecs;
HoursInfo:=Trunc(Abs(TimeBlockInfo*0.001/3600));
if HoursInfo<10 then
HoursInfoText:='0'+inttostr(HoursInfo)
else
HoursInfoText:=inttostr(HoursInfo);

// Minutes
TimeBlockInfo:=InpMSecs-HoursInfo*3600*1000;
MinsInfo:=Trunc(Abs(TimeBlockInfo*0.001/60));
if MinsInfo<10 then
MinsInfoText:='0'+inttostr(MinsInfo)
else
MinsInfoText:=inttostr(MinsInfo);

// Seconds
TimeBlockInfo:=TimeBlockInfo-MinsInfo*60*1000;
SecsInfo:=Trunc(Abs(TimeBlockInfo*0.001));
if SecsInfo<10 then
SecsInfoText:='0'+inttostr(SecsInfo)
else
SecsInfoText:=inttostr(SecsInfo);

// Ten's of Seconds
TimeBlockInfo:=TimeBlockInfo-SecsInfo*1000;
TenSecsParts:=Trunc(Abs(TimeBlockInfo*0.01));
TenSecsPartsText:=inttostr(TenSecsParts);

// Result
Result:=HoursInfoText+':'+MinsInfoText+':'+SecsInfoText+'.'+TenSecsPartsText;

end;


function FileFolderText(FileFolderNum:integer):string;
begin
If FileFolderNum<=9 then
Result:='000'+inttostr(FileFolderNum);
If (FileFolderNum>=10) and (FileFolderNum<=99) then
Result:='00'+inttostr(FileFolderNum);
If (FileFolderNum>=100) and (FileFolderNum<=999) then
Result:='0'+inttostr(FileFolderNum);
If (FileFolderNum>=1000) and (FileFolderNum<=9999) then
Result:=''+inttostr(FileFolderNum);
end;

function AspectRatioRealValue(AspectRatioStringValue:string):Real;
var
DPointPos,DPointErrCode:Integer;
FirstDPoint,SecondDPoint:string;
FirstDPointValue,SecondDPointValue:Real;
begin
DPointPos:=Pos(':',AspectRatioStringValue);
If DPointPos>0 then
      begin
      FirstDPoint:=Copy(AspectRatioStringValue,1,DPointPos-1);
      val(FirstDPoint,FirstDPointValue,DPointErrCode);
      If FirstDPointValue=0 then
      FirstDPointValue:=1;
            if DPointPos=Length(AspectRatioStringValue) then
            begin
            SecondDPointValue:=1;
            end
            else
            begin
            SecondDPoint:=Copy(AspectRatioStringValue,
            DPointPos+1,Length(AspectRatioStringValue)-DPointPos);
            val(SecondDPoint,SecondDPointValue,DPointErrCode);
            If SecondDPointValue=0 then
            SecondDPointValue:=1;
            end;
      Result:=FirstDPointValue/SecondDPointValue;                        
      end
      else
      begin
      val(AspectRatioStringValue,FirstDPointValue,DPointErrCode);
      If FirstDPointValue=0 then
      FirstDPointValue:=1;
      Result:=FirstDPointValue;
      end;

end;

function NearestTo4(InputIntSize,MaxIntSize:Integer):Integer;
var
Part4th:Real;
Quad,TruncPart:Integer;
begin
Part4th:=Abs(InputIntSize/4);
TruncPart:=Trunc(Part4th);
Quad:=Round((Part4th-TruncPart)*100);
If Quad>=50 then
      begin
      Result:=Round(TruncPart*4)+4;
      end;
If Quad<50 then
      begin
      Result:=Round(TruncPart*4);
      end;
If Result>MaxIntSize then
Result:=MaxIntSize;
end;

// Exit from Window to shutdown

function MyExitWindows(RebootParam: Longword): Boolean;  
var  
  TTokenHd: THandle;  
  TTokenPvg: TTokenPrivileges;  
  cbtpPrevious: DWORD;  
  rTTokenPvg: TTokenPrivileges;  
  pcbtpPreviousRequired: DWORD;  
  tpResult: Boolean;
const  
  SE_SHUTDOWN_NAME = 'SeShutdownPrivilege';  
begin  
  if Win32Platform = VER_PLATFORM_WIN32_NT then  
  begin  
    tpResult := OpenProcessToken(GetCurrentProcess(),  
      TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY,  
      TTokenHd);  
    if tpResult then  
    begin  
      tpResult := LookupPrivilegeValue(nil,  
                                       SE_SHUTDOWN_NAME,  
                                       TTokenPvg.Privileges[0].Luid);  
      TTokenPvg.PrivilegeCount := 1;  
      TTokenPvg.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;  
      cbtpPrevious := SizeOf(rTTokenPvg);  
      pcbtpPreviousRequired := 0;  
      if tpResult then  
        Windows.AdjustTokenPrivileges(TTokenHd,  
                                      False,  
                                      TTokenPvg,  
                                      cbtpPrevious, 
                                      rTTokenPvg,
                                      pcbtpPreviousRequired); 
    end; 
  end; 
  Result := ExitWindowsEx(RebootParam, 0); 
end;


function ClearCommandString(InputCommand:string):string;
var
CCS_Index:Integer;
First_CCS_Space,ResultWasChanged:Boolean;
CCS_Out:string;
begin
First_CCS_Space:=False;
CCS_Out:='';
for CCS_Index:=1 to Length(InputCommand) do
      begin
      ResultWasChanged:=False;
      if Ord(InputCommand[CCS_Index])<=32 then
            begin
            if (First_CCS_Space=False) and (ResultWasChanged=False) then
                  begin
                  CCS_Out:=CCS_Out+InputCommand[CCS_Index];
                  First_CCS_Space:=True;
                  ResultWasChanged:=True;
                  end;

            end
            else
            begin
            // Non-space symbol
            CCS_Out:=CCS_Out+InputCommand[CCS_Index];
            First_CCS_Space:=False;
            ResultWasChanged:=True;
            end;

      end;
Result:=CCS_Out;
end;


// Disable procedures

procedure TAppForm.DisableAllVideoSettings();
begin

// Code

ChangeSourceAspectRatioCheckBox.Enabled:=False;
ChangeSourceAspectRatioCheckBox.Checked:=False;

ChangeVideoFormatCheckBox.Enabled:=False;
ChangeVideoFormatCheckBox.Checked:=False;

CustomVideoBitrateEdit.Enabled:=False;
CustomVideoBitrateEdit.Color:=clScrollBar;
CustomVideoBitrateEdit.Text:='';

CustomVideoSourceAspectRatioEdit.Enabled:=False;
CustomVideoSourceAspectRatioEdit.Color:=clScrollBar;
CustomVideoSourceAspectRatioEdit.Text:='';

InterlacedFlag.Enabled:=False;
InterlacedFlag.Checked:=False;

HalfD1FrameSizeCheckBox.Enabled:=False;
HalfD1FrameSizeCheckBox.Checked:=False;

TwoPassConversionCheckBox.Enabled:=False;
TwoPassConversionCheckBox.Checked:=False;

VideoBitrateComboBox.Enabled:=False;
VideoBitrateComboBox.ItemIndex:=8;

VideoBitrateLabel.Enabled:=False;

VideoCopyCheckBox.Enabled:=False;
VideoCopyCheckBox.Checked:=False;

VideoFormatComboBox.Enabled:=False;
VideoFormatComboBox.ItemIndex:=0;

VideoFormatLabel.Enabled:=False;

VideoSourceAspectRatio.Enabled:=False;

VideoSourceAspectRatioComboBox.Enabled:=False;
VideoSourceAspectRatioComboBox.ItemIndex:=0;

VideoTargetAspectRatioComboBox.Enabled:=False;
VideoTargetAspectRatioComboBox.ItemIndex:=0;

VideoTargetAspectRatioLabel.Enabled:=False;

end;


procedure TAppForm.DisableAllAudioSettings();
begin

AC3AudioFormatCheckBox.Enabled:=False;
AudioBitrate128CheckBox.Enabled:=False;
AudioBitrate160CheckBox.Enabled:=False;
AudioBitrate192CheckBox.Enabled:=False;
AudioBitrate224CheckBox.Enabled:=False;
AudioBitrate256CheckBox.Enabled:=False;
AudioBitrate320CheckBox.Enabled:=False;
AudioBitrate384CheckBox.Enabled:=False;
AudioBitrate448CheckBox.Enabled:=False;
AudioBitrateLabel.Enabled:=False;
AudioChannels1CheckBox.Enabled:=False;
AudioChannels2CheckBox.Enabled:=False;
AudioChannels6CheckBox.Enabled:=False;
AudioChannelsLabel.Enabled:=False;
AudioCopyCheckBox.Enabled:=False;
AudioFormatLabel.Enabled:=False;
WAVAudioFormatCheckBox.Enabled:=False;
end;

// Enable procedures

procedure TAppForm.EnableAllVideoSettings();
begin

// Code

ChangeSourceAspectRatioCheckBox.Enabled:=True;
ChangeVideoFormatCheckBox.Enabled:=True;
CustomVideoBitrateEdit.Enabled:=True;
CustomVideoSourceAspectRatioEdit.Enabled:=True;
InterlacedFlag.Enabled:=True;
HalfD1FrameSizeCheckBox.Enabled:=True;
TwoPassConversionCheckBox.Enabled:=True;
VideoBitrateComboBox.Enabled:=True;
VideoBitrateLabel.Enabled:=True;
VideoCopyCheckBox.Enabled:=True;
VideoFormatComboBox.Enabled:=True;
VideoFormatLabel.Enabled:=True;
VideoSourceAspectRatio.Enabled:=True;
VideoSourceAspectRatioComboBox.Enabled:=True;
VideoTargetAspectRatioComboBox.Enabled:=True;
VideoTargetAspectRatioLabel.Enabled:=True;

end;


procedure TAppForm.EnableAllAudioSettings();
begin

AC3AudioFormatCheckBox.Enabled:=True;
AudioBitrate128CheckBox.Enabled:=True;
AudioBitrate160CheckBox.Enabled:=True;
AudioBitrate192CheckBox.Enabled:=True;
AudioBitrate224CheckBox.Enabled:=True;
AudioBitrate256CheckBox.Enabled:=True;
AudioBitrate320CheckBox.Enabled:=True;
AudioBitrate384CheckBox.Enabled:=True;
AudioBitrate448CheckBox.Enabled:=True;
AudioBitrateLabel.Enabled:=True;
AudioChannels1CheckBox.Enabled:=True;
AudioChannels2CheckBox.Enabled:=True;
AudioChannels6CheckBox.Enabled:=True;
AudioChannelsLabel.Enabled:=True;
AudioCopyCheckBox.Enabled:=True;
AudioFormatLabel.Enabled:=True;
WAVAudioFormatCheckBox.Enabled:=True;
end;

// Uncheck All Audio Settings

procedure TAppForm.UncheckAllAudioSettings();
begin

AC3AudioFormatCheckBox.Checked:=False;
AudioBitrate128CheckBox.Checked:=False;
AudioBitrate160CheckBox.Checked:=False;
AudioBitrate192CheckBox.Checked:=False;
AudioBitrate224CheckBox.Checked:=False;
AudioBitrate256CheckBox.Checked:=False;
AudioBitrate320CheckBox.Checked:=False;
AudioBitrate384CheckBox.Checked:=False;
AudioBitrate448CheckBox.Checked:=False;
AudioChannels1CheckBox.Checked:=False;
AudioChannels2CheckBox.Checked:=False;
AudioChannels6CheckBox.Checked:=False;
AudioCopyCheckBox.Checked:=False;
WAVAudioFormatCheckBox.Checked:=False;
end;



procedure TAppForm.FileInfoTextShow();
begin
ChangedMediaFilesPos:=VideoAudioFilesListBox.ItemIndex;
FileInfoLabel.Caption:=
'Duration: '+MediaFileDurationInfo[RealPosition[ChangedMediaFilesPos+1]];
end;


procedure TAppForm.CMClickIcon(var msg: TMessage);
begin
  if msg.lparam=WM_LBUTTONDBLCLK then
      begin
        Show;
        Shell_NotifyIcon(NIM_DELETE, @tnid);
      end;
end;



procedure TAppForm.MinimizeButtonClick(Sender: TObject);
begin
HMainIcon:= LoadIcon(MainInstance, 'MAINICON');

  Shell_NotifyIcon(NIM_DELETE, @tnid);

  tnid.cbSize              := sizeof(TNotifyIconData);
  tnid.Wnd                 := handle;
  tnid.uID                 := 123;
  tnid.uFlags              := NIF_MESSAGE or NIF_ICON or NIF_TIP;
  tnid.uCallbackMessage    := WM_NOTIFYICON;
  tnid.hIcon               := HMainIcon;
  tnid.szTip               := 'Batch DVD Streams Converter';

  Shell_NotifyIcon(NIM_ADD, @tnid);
  AppForm.Hide;
end;

procedure TAppForm.OnlineHelp1Click(Sender: TObject);
begin
ShellExecute(0, nil, PChar('http://beginwithsoftware.com/videoguides/batchdvdstreamsconverter.html'), nil, nil, SW_SHOWNORMAL);
end;

procedure TAppForm.AddFileButtonClick(Sender: TObject);
begin

if AddFileDialog.Execute then
  begin
  AddFileButton.Enabled:=False;
  AddFileButton.Caption:='Loading...';

  CurrMediaFile:=AddFileDialog.FileName;
  // Check Foreign Symbols in File Path
  If CheckForeignSymbols(CurrMediaFile)=True then
    begin
    ShowMessage('Error! Please don''t use foreign symbols in file''s and folder names');
    AddFileButton.Caption:='Add File';
    AddFileButton.Enabled:=True;
    Exit;
    end;

  DisableVideoSettings4RemoveFromMediaList;
  DisableAudioSettings4RemoveFromMediaList;

  // Read file info using FFMPEG console window
  StartPos:=0;
  StopPos:=0;
  MediaInfoText:='';
  MediaInfoText:=GetMediaData(FFMPEGPath+' -i "'+CurrMediaFile+'"');
  StartPos:=Pos('Input #0',MediaInfoText);
  StopPos:=Length(MediaInfoText)-Pos(TextReverse('Must supply at least one output file'),
  TextReverse(MediaInfoText));
  if (StartPos<>0) and (StopPos<>0) then
    begin
    ClearBlock:=Copy(MediaInfoText,StartPos,StopPos-StartPos+2-Length('Must supply at least one output file'));

    // Increase Media File Counters
    inc(MediaListFilesQ);
    inc(AllMediaFilesQ);
    RealPosition[MediaListFilesQ]:=AllMediaFilesQ;

    // Parsing Media Info to Arrays

    // Media Full Info
    MediaFullInfo[AllMediaFilesQ]:=ClearCommandString(ClearBlock);

    // Media File Type
    ParsedTextBlock:=ExtractTextBlock(ClearBlock,', ',', from');
    MediaFileType[AllMediaFilesQ]:=ParsedTextBlock;

    // Duration
    ParsedTextBlock:=ExtractTextBlock(ClearBlock,'Duration: ',',');
    MediaFileDurationInfo[AllMediaFilesQ]:=ParsedTextBlock;
    CalcTimeMSec:=0;
    // Ten Hours
    val(ParsedTextBlock[1],DurationTimeDigit,DurationErrCode);
    CalcTimeMSec:=CalcTimeMSec+DurationTimeDigit*10*3600*1000;
    // Hours
    val(ParsedTextBlock[2],DurationTimeDigit,DurationErrCode);
    CalcTimeMSec:=CalcTimeMSec+DurationTimeDigit*3600*1000;
    // Ten Minutes
    val(ParsedTextBlock[4],DurationTimeDigit,DurationErrCode);
    CalcTimeMSec:=CalcTimeMSec+DurationTimeDigit*600*1000;
    // Minutes
    val(ParsedTextBlock[5],DurationTimeDigit,DurationErrCode);
    CalcTimeMSec:=CalcTimeMSec+DurationTimeDigit*60*1000;
    // Ten Seconds
    val(ParsedTextBlock[7],DurationTimeDigit,DurationErrCode);
    CalcTimeMSec:=CalcTimeMSec+DurationTimeDigit*10*1000;
    // Seconds
    val(ParsedTextBlock[8],DurationTimeDigit,DurationErrCode);
    CalcTimeMSec:=CalcTimeMSec+DurationTimeDigit*1000;
    // MilliSeconds
    val(ParsedTextBlock[10],DurationTimeDigit,DurationErrCode);
    CalcTimeMSec:=CalcTimeMSec+DurationTimeDigit*100;
    MediaFileDuration[AllMediaFilesQ]:=CalcTimeMSec;

    // Bitrate
    ParsedTextBlock:=ExtractTextBlock(ClearBlock,'bitrate: ','Stream');
    MediaFileBitrateInfo[AllMediaFilesQ]:=TrimRight(ParsedTextBlock);

    // Detecting All Media Streams Blocks
    OldStreamStringPos:=Pos('Stream #0.0',ClearBlock);
    CalcMediaStreams:=1;
    for i:=1 to 20 do
      begin
      CurrStreamStringPos:=Pos('Stream #0.'+inttostr(i),ClearBlock);
      If CurrStreamStringPos>0 then
        begin
        Inc(CalcMediaStreams);
        StreamBlock[i-1]:=Copy(ClearBlock,OldStreamStringPos,
        CurrStreamStringPos-OldStreamStringPos);
        OldStreamStringPos:=CurrStreamStringPos;
        end;
      If CurrStreamStringPos=0 then
        begin
        StreamBlock[i-1]:=Copy(ClearBlock,OldStreamStringPos,
        Length(ClearBlock)-OldStreamStringPos);
        Break;
        end;

      end;


      // Scanning each stream info block
      // to fill out video and audio arrays
      CurrAudioCount:=0;
      CurrVideoCount:=0;
      AudioStreamsCheckListBox.Clear;
      VideoStreamsCheckListBox.Clear;

      for i:=1 to CalcMediaStreams do
        begin
        InsideStreamBlockAudioPos:=0;
        InsideStreamBlockVideoPos:=0;
        InsideStreamBlockAudioPos:=Pos('Audio:',StreamBlock[i-1]);
        InsideStreamBlockVideoPos:=Pos('Video:',StreamBlock[i-1]);
        if InsideStreamBlockAudioPos>0 then
              // Parsing info from Audio Stream
              begin
              inc(CurrAudioCount);

              // Summary Audio Info
              AudioStreamInfo[AllMediaFilesQ,CurrAudioCount]:=
              TrimRight(Copy(StreamBlock[i-1],Pos('Audio:',StreamBlock[i-1])+7,
              Length(StreamBlock[i-1])-Pos('Audio:',StreamBlock[i-1])-7));

              // Audio Stream Map
              AudioStreamMap[AllMediaFilesQ,CurrAudioCount]:=
              '0:'+inttostr(i-1);

              // Audio Stream Type
              AudioStreamType[AllMediaFilesQ,CurrAudioCount]:=
              ExtractTextBlock(StreamBlock[i-1],'Audio: ',',');
              // Change dca to dts
              If AudioStreamType[AllMediaFilesQ,CurrAudioCount]='dca' then
                    begin
                    AudioStreamType[AllMediaFilesQ,CurrAudioCount]:='dts';
                    // Change summary info
                    SwapText:=AudioStreamInfo[AllMediaFilesQ,CurrAudioCount];
                    SwapText:='dts, '+Copy(SwapText,6,Length(SwapText)-5);
                    AudioStreamInfo[AllMediaFilesQ,CurrAudioCount]:=SwapText;
                    end;

              // Audio Stream Input Channels
              AudioStreamInputChannels[AllMediaFilesQ,CurrAudioCount]:='';
              AudioStreamInputChannels[AllMediaFilesQ,CurrAudioCount]:=
              ExtractTextBlock(StreamBlock[i-1],'Hz, ',',');

              // If Audio Stream Input Channels Are not detected
              If AudioStreamInputChannels[AllMediaFilesQ,CurrAudioCount]='' then
                    begin
                    SwapText:=StreamBlock[i-1];
                    ReDefineChannelsPos:=0;
                    ReDefineChannelsFound:=False;
                    // Mono
                    ReDefineChannelsPos:=Pos('mono',SwapText);
                    if (ReDefineChannelsPos>0) and (ReDefineChannelsFound=False) then
                          begin
                          ReDefineChannelsFound:=True;
                          AudioStreamInputChannels[AllMediaFilesQ,CurrAudioCount]:='mono';
                          end;
                    // Stereo
                    ReDefineChannelsPos:=Pos('stereo',SwapText);
                    if (ReDefineChannelsPos>0) and (ReDefineChannelsFound=False) then
                          begin
                          ReDefineChannelsFound:=True;
                          AudioStreamInputChannels[AllMediaFilesQ,CurrAudioCount]:='stereo';
                          end;
                    // 5:1
                    ReDefineChannelsPos:=Pos('5:1',SwapText);
                    if (ReDefineChannelsPos>0) and (ReDefineChannelsFound=False) then
                          begin
                          ReDefineChannelsFound:=True;
                          AudioStreamInputChannels[AllMediaFilesQ,CurrAudioCount]:='5:1';
                          end;
                    // 5 channels
                    ReDefineChannelsPos:=Pos('5 channels',SwapText);
                    if (ReDefineChannelsPos>0) and (ReDefineChannelsFound=False) then
                          begin
                          ReDefineChannelsFound:=True;
                          AudioStreamInputChannels[AllMediaFilesQ,CurrAudioCount]:='5 channels';
                          end;
                    // 6 channels
                    ReDefineChannelsPos:=Pos('6 channels',SwapText);
                    if (ReDefineChannelsPos>0) and (ReDefineChannelsFound=False) then
                          begin
                          ReDefineChannelsFound:=True;
                          AudioStreamInputChannels[AllMediaFilesQ,CurrAudioCount]:='6 channels';
                          end;
                    end;

              // Audio Stream Input Frequency
              AudioStreamInputFrequency[AllMediaFilesQ,CurrAudioCount]:=
              ExtractTextBlock(StreamBlock[i-1],', ',' Hz');
              
              // Audio Stream Input Bitrate
              AudioStreamInputBitrate[AllMediaFilesQ,CurrAudioCount]:=0;
              AudioInputBitrateValue:=0;
              AudioInputBitrateStopPos:=Pos('kb/s',StreamBlock[i-1]);
              If AudioInputBitrateStopPos>0 then
                    begin
                    SwapText:=Copy(StreamBlock[i-1],1,AudioInputBitrateStopPos-2);
                    AudioInputBitrateStartPos:=AudioInputBitrateStopPos-2-Pos(',',TextReverse(SwapText))+1;
                    SwapText:=Copy(StreamBlock[i-1],AudioInputBitrateStartPos+2,
                    AudioInputBitrateStopPos-AudioInputBitrateStartPos-3);
                    Val(SwapText,AudioInputBitrateValue,AudioInputBitrateErrCode);

                    If AudioInputBitrateErrCode=0 then
                    AudioStreamInputBitrate[AllMediaFilesQ,CurrAudioCount]:=AudioInputBitrateValue;

                    end;

              end;

        if InsideStreamBlockVideoPos>0 then
              // Parsing info from Video Stream
              begin
              inc(CurrVideoCount);

              // Summary Video Info
              VideoStreamInfo[AllMediaFilesQ,CurrVideoCount]:=
              TrimRight(Copy(StreamBlock[i-1],Pos('Video:',StreamBlock[i-1])+7,
              Length(StreamBlock[i-1])-Pos('Video:',StreamBlock[i-1])-7));
              
              // Video Stream Map
              VideoStreamMap[AllMediaFilesQ,CurrVideoCount]:=
              '0:'+inttostr(i-1);

              // Video Stream Type
              VideoStreamType[AllMediaFilesQ,CurrVideoCount]:=
              ExtractTextBlock(StreamBlock[i-1],'Video: ',',');

              // Video Stream Frame Rate
              VideoStreamFrameRate[AllMediaFilesQ,CurrVideoCount]:=
              TextReverse(ExtractTextBlock(TextReverse(StreamBlock[i-1]),
              TextReverse(' fps(r)'),TextReverse(', ')));

              // Video Stream Frame X*Y Sizes

              VideoFrameSizeXPos:=
              Length(VideoStreamInfo[AllMediaFilesQ,CurrVideoCount])-
              Pos('x',TextReverse(VideoStreamInfo[AllMediaFilesQ,CurrVideoCount]))+1;

              RightFrameSizeBlock:=Copy(VideoStreamInfo[AllMediaFilesQ,CurrVideoCount],
              VideoFrameSizeXPos,
              Length(VideoStreamInfo[AllMediaFilesQ,CurrVideoCount])-
              VideoFrameSizeXPos+1);

              LeftFrameSizeBlock:=TextReverse(Copy(VideoStreamInfo[AllMediaFilesQ,CurrVideoCount],
              1,VideoFrameSizeXPos));

              XFrameSizeBlock:=TextReverse(ExtractTextBlock(LeftFrameSizeBlock,
              'x',' ,'));

              YFrameSizeBlock:=ExtractTextBlock(RightFrameSizeBlock,'x',',');

              val(XFrameSizeBlock,VideoFrameXValue,FrameSizeCode);
              val(YFrameSizeBlock,VideoFrameYValue,FrameSizeCode);

              VideoStreamFrameSizeX[AllMediaFilesQ,CurrVideoCount]:=
              VideoFrameXValue;
              VideoStreamFrameSizeY[AllMediaFilesQ,CurrVideoCount]:=
              VideoFrameYValue;

              // Video Stream Source Aspect Ratio
              VideoStreamSourceAR[AllMediaFilesQ,CurrVideoCount]:='1:1';

              // Change Format Checkbox
              ChangeFormatChecked[AllMediaFilesQ,CurrVideoCount]:=False;

              // Change Source Aspect Ratio Checked
              ChangeSourceAspectRatioChecked[AllMediaFilesQ,CurrVideoCount]:=False;

              // Default Interlaced CheckBox State
              InterlacedEnabled[AllMediaFilesQ,CurrVideoCount]:=True;

              // Copy Video Stream Enabled CheckBox State
              CopyVideoStreamEnabled[AllMediaFilesQ,CurrVideoCount]:=False;

              // Copy Video Stream Pulldown Mode
              CopyVideoStreamPulldownMode[AllMediaFilesQ,CurrVideoCount]:='';

              // Frame Type
              If VideoStreamType[AllMediaFilesQ,CurrVideoCount]='dvvideo' then
              FrameType[AllMediaFilesQ,CurrVideoCount]:='Interlaced'
              else
              FrameType[AllMediaFilesQ,CurrVideoCount]:='';

              // Video Type
              VideoType[AllMediaFilesQ,CurrVideoCount]:='';

              end;



        end;

        // Saving Audio and Video Streams Count
        AudioStreamCount[AllMediaFilesQ]:=CurrAudioCount;
        VideoStreamCount[AllMediaFilesQ]:=CurrVideoCount;



        // Detecting Audio Delay for AVI files using AVI-MUX GUI

        if MediaFileType[AllMediaFilesQ]='avi' then
              begin

                // Creating amg.asc file
                AssignFile(AMGScript,AMGScriptPath);
                Rewrite(AMGScript);
                Writeln(AMGScript,'CLEAR');
                Writeln(AMGScript,'LOAD '+CurrMediaFile);
                CloseFile(AMGScript);

                // Running AVI-MUX GUI in minimized state
                // with amg.asc command line
                AMGStartCMD:=AMGFilePath+Chr(32)+'"'+AMGScriptPath+'"';

                With AMGSecurity do
                  begin
                  nlength := SizeOf(TSecurityAttributes);
                  binherithandle := true;
                  lpsecuritydescriptor := nil;
                  end;
                ZeroMemory(@AMGsi, sizeof(AMGsi));
                AMGsi.cb := sizeof(AMGsi);
                AMGsi.dwFlags:=STARTF_USESHOWWINDOW or STARTF_USESTDHANDLES;
                AMGsi.wShowWindow:=SW_MINIMIZE;
                CreateProcess(nil,
                PChar(AMGStartCMD),
                @AMGSecurity,
                @AMGSecurity,
                true,
                0, nil, nil, AMGsi, AMGpi);
                AMGhProc:= AMGpi.hProcess;

                 // Pressing AVI-MUX GUI Button

                 repeat
                 AMGhWin:=FindWindow(nil,'AVI-Mux GUI 1.17.7');
                 Sleep(10);
                 until AMGhWin<>0;
                 AMGhBut:=GetDlgItem(AMGhWin,1042);
                 AMGhList:=GetDlgItem(AMGhWin,1000);
                 Sleep(Round(AVIScanTime*1000));
                 SMS:=SendMessage(AMGhList,LB_SELITEMRANGE,1,0);
                 SendMessage(AMGhBut,WM_LBUTTONDOWN, 1, 1);
                 SendMessage(AMGhBut,WM_LBUTTONUP, 1, 1);


                 // Let's read from SysTreeView32
                 // to detect audio stream delay

                 AMGhTree:=GetDlgItem(AMGhWin,1204);
                 TreeNodesCount:=SendMessage(AMGhTree,TVM_GETCOUNT,0,0);
                 AMGAudioCount:=0;


                 for i:=1 to Round(TreeNodesCount/3) do
	                  begin
                        AMGDelay:='';
                        TreeNodeText:=GetTreeNodesText(AMGhTree,i);
                        if Pos('audio:',TreeNodeText)>0 then
                              begin
                              // Extract delay value as string
                              inc(AMGAudioCount);
                              AMGDelay:=ExtractTextBlock(TreeNodeText,'delay: ',',');
                              AudioStreamDelay[AllMediaFilesQ,AMGAudioCount]:=AMGDelay;
                                if Length(AMGDelay)>0 then
                                      begin
                                      SwapText:=AudioStreamInfo[AllMediaFilesQ,AMGAudioCount];
                                      SwapText:=SwapText+' delay '+AMGDelay;
                                      AudioStreamInfo[AllMediaFilesQ,AMGAudioCount]:=SwapText;
                                      end;
                              end;        

                    end;

                 // Close AVI-MUX-GUI

                 TerminateProcess(AMGhProc,0);

              end;

        // Detecting Audio Delay for MPEG files using DGIndex


        if (MediaFileType[AllMediaFilesQ]='mpeg') or  (MediaFileType[AllMediaFilesQ]='mpegvideo') then
              begin
              DGProjectName:=ExtractFileNameNoExt(CurrMediaFile)+'_mpeg';
              DGAspectRatio:='';
              DGFrameRate:='';
              DGFrameType:='';
              DGVideoType:='';
              DG_AR_CalcText:='';
              DG_FindInfoRepeat:=0;
              // Starting DGIndex Process
              ZeroMemory(@DGsi, sizeof(DGsi));
              DGsi.cb := sizeof(DGsi);
              DGsi.dwFlags:=STARTF_USESHOWWINDOW;
              DGsi.wShowWindow:=SW_HIDE;
              CreateProcess(nil,PChar(AppPath+'DGINDEX\DGIndex.exe -IF=['+
              CurrMediaFile+'] -OM=2 -OF=['+OutputPath+DGProjectName+'] -HIDE')
              ,nil, nil, false, 0, nil, nil, DGsi, DGpi);
              DGhProc:= DGpi.hProcess;
              CloseHandle(DGpi.hThread);
              DGCount:=0;

              // Running Timer similar process for scanning hidden
              // DGIndex windows
              repeat
              DGProc:=WaitForSingleObject(DGhProc,100);
              DGInfoWindow:=FindWindow(nil,PChar('Information'));
              Sleep(50);
              until ((DGProc<>0) and (DGInfoWindow<>0));

              If (DGProc<>0) and (DGInfoWindow<>0) then
                  begin
                      repeat
                      inc(DG_FindInfoRepeat);
                      ClearDGStaticBufer();
                      DGStaticBufferRead:=GetDlgItemText(DGInfoWindow,1023,DGStaticBuffer,255);
                      DGAspectRatio:=string(DGStaticBuffer);
                      ClearDGStaticBufer();
                      DGStaticBufferRead:=GetDlgItemText(DGInfoWindow,1018,DGStaticBuffer,255);
                      DGFrameRate:=string(DGStaticBuffer);
                      ClearDGStaticBufer();
                      DGStaticBufferRead:=GetDlgItemText(DGInfoWindow,1022,DGStaticBuffer,255);
                      DGFrameType:=string(DGStaticBuffer);
                      ClearDGStaticBufer();
                      DGStaticBufferRead:=GetDlgItemText(DGInfoWindow,1021,DGStaticBuffer,255);
                      DGVideoType:=string(DGStaticBuffer);
                      Sleep(50);
                                // Break for m1v and m2v still images
                                if DG_FindInfoRepeat>Round(AVIScanTime*20) then break;
                      until ((Length(DGAspectRatio)>0) and (Length(DGFrameRate)>0) and
                      (Length(DGFrameType)>0) and (Length(DGVideoType)>0));
                  DG_AC3_Count:=0;
                  DG_DTS_Count:=0;
                  DG_MPA_Count:=0;
                  DG_AAC_Count:=0;
                  DG_WAV_Count:=0;
                  // Search Files
                  If FindFirst(OutputPath+DGProjectName+'*.*', faAnyFile, SearchRec)=0 then
                    repeat
                    inc(DGCount);
                    DGFiles[DGCount]:=SearchRec.Name;
                    DG_Ext:=ExtractFileExt(DGFiles[DGCount]);
                        if DG_Ext='.ac3' then
                                begin
                                inc(DG_AC3_Count);
                                DG_AC3_Index[DG_AC3_Count]:=DGCount;
                                end;
                        if DG_Ext='.dts' then
                                begin
                                inc(DG_DTS_Count);
                                DG_DTS_Index[DG_DTS_Count]:=DGCount;
                                end;
                        if DG_Ext='.mpa' then
                                begin
                                inc(DG_MPA_Count);
                                DG_MPA_Index[DG_MPA_Count]:=DGCount;
                                end;
                        if DG_Ext='.aac' then
                                begin
                                inc(DG_AAC_Count);
                                DG_AAC_Index[DG_AAC_Count]:=DGCount;
                                end;
                        if DG_Ext='.wav' then
                                begin
                                inc(DG_WAV_Count);
                                DG_WAV_Index[DG_WAV_Count]:=DGCount;
                                end;

                    until FindNext(SearchRec) <> 0;
                  FindClose(SearchRec);
                  TerminateProcess(DGhProc,0);
                  // Removing Temporary Files from Hard drive
                  For DG_I:=1 to DGCount do
                    begin
                      repeat
                      Sleep(10);
                      DelRes:=DeleteFile(OutputPath+DGFiles[DG_I]);
                      until DelRes<>False;
                    end;

                  // Clear Aspect ratio string value for MPEG-1 files
                  // from 525 and 625 lines information
                  ARStopPos:=0;
                  ARStopPos:=Pos(',',DGAspectRatio);
                  if ARStopPos>0 then
                  DGAspectRatio:=Copy(DGAspectRatio,1,ARStopPos-1);


                  // Change detected Aspect Ratio for MPEG video
                        for AspectIndex:=1 to VideoStreamCount[AllMediaFilesQ] do
                            begin
                            VideoStreamDG_AR[AllMediaFilesQ,AspectIndex]:=DGAspectRatio;
                            if (DGAspectRatio<>'4:3') and (DGAspectRatio<>'16:9') and
                            (DGAspectRatio<>'2.21:1') and (DGAspectRatio<>'1:1') then
                                  begin
                                  val(DGAspectRatio,DG_AR_Value,DG_AR_Code);
                                  DG_SAR:=VideoStreamFrameSizeX[AllMediaFilesQ,AspectIndex]/
                                  (VideoStreamFrameSizeY[AllMediaFilesQ,AspectIndex]*DG_AR_Value);
                                  str(DG_SAR,DG_AR_CalcText);
                                  DG_AR_CalcText:=TrimLeft(DG_AR_CalcText);
                                  DG_AR_CalcText:=Copy(DG_AR_CalcText,1,8);
                                  VideoStreamSourceAR[AllMediaFilesQ,AspectIndex]:=DG_AR_CalcText;
                                  end
                                  else
                                  begin
                                  VideoStreamSourceAR[AllMediaFilesQ,AspectIndex]:=DGAspectRatio;
                                  end;
                            // Frame Type
                            FrameType[AllMediaFilesQ,AspectIndex]:=DGFrameType;
                            // Video Type
                            VideoType[AllMediaFilesQ,AspectIndex]:=DGVideoType;
                            end;

                  // Sort audio stream delays by file type
                  FFMPEG_AC3_Count:=0;
                  FFMPEG_DTS_Count:=0;
                  FFMPEG_MP2_Count:=0;
                  FFMPEG_AAC_Count:=0;
                  FFMPEG_PCM_Count:=0;

                  for Audio_Scan_I:=1 to CurrAudioCount do
                        begin
                        DGDelayText:='';
                        DGWorkFileText:='';
                            if AudioStreamType[AllMediaFilesQ,Audio_Scan_I]='ac3' then
                                  begin
                                  inc(FFMPEG_AC3_Count);
                                  FFMPEG_AC3_Index[FFMPEG_AC3_Count]:=Audio_Scan_I;
                                  DGWorkFileText:=DGFiles[DG_AC3_Index[FFMPEG_AC3_Count]];
                                  AudioStream_DG_Copy_Index[AllMediaFilesQ,Audio_Scan_I]:=DG_AC3_Index[FFMPEG_AC3_Count];
                                  DGDelayText:=
                                  TextReverse(ExtractTextBlock(TextReverse(DGWorkFileText),'.',TextReverse('DELAY ')));
                                  If DGDelayText<>'0ms' then
                                        begin
                                        AudioStreamDelay[AllMediaFilesQ,Audio_Scan_I]:=DGDelayText;
                                        SwapText:=AudioStreamInfo[AllMediaFilesQ,Audio_Scan_I];
                                        SwapText:=SwapText+' delay '+DGDelayText;
                                        AudioStreamInfo[AllMediaFilesQ,Audio_Scan_I]:=SwapText;
                                        end;
                                  end;
                            if AudioStreamType[AllMediaFilesQ,Audio_Scan_I]='dts' then
                                  begin
                                  inc(FFMPEG_DTS_Count);
                                  FFMPEG_DTS_Index[FFMPEG_DTS_Count]:=Audio_Scan_I;
                                  DGWorkFileText:=DGFiles[DG_DTS_Index[FFMPEG_DTS_Count]];
                                  AudioStream_DG_Copy_Index[AllMediaFilesQ,Audio_Scan_I]:=DG_DTS_Index[FFMPEG_DTS_Count];
                                  DGDelayText:=
                                  TextReverse(ExtractTextBlock(TextReverse(DGWorkFileText),'.',TextReverse('DELAY ')));
                                  If DGDelayText<>'0ms' then
                                        begin
                                        AudioStreamDelay[AllMediaFilesQ,Audio_Scan_I]:=DGDelayText;
                                        SwapText:=AudioStreamInfo[AllMediaFilesQ,Audio_Scan_I];
                                        SwapText:=SwapText+' delay '+DGDelayText;
                                        AudioStreamInfo[AllMediaFilesQ,Audio_Scan_I]:=SwapText;
                                        end;
                                  end;
                            if AudioStreamType[AllMediaFilesQ,Audio_Scan_I]='mp2' then
                                  begin
                                  inc(FFMPEG_MP2_Count);
                                  FFMPEG_MP2_Index[FFMPEG_MP2_Count]:=Audio_Scan_I;
                                  DGWorkFileText:=DGFiles[DG_MPA_Index[FFMPEG_MP2_Count]];
                                  AudioStream_DG_Copy_Index[AllMediaFilesQ,Audio_Scan_I]:=DG_MPA_Index[FFMPEG_MP2_Count];
                                  DGDelayText:=
                                  TextReverse(ExtractTextBlock(TextReverse(DGWorkFileText),'.',TextReverse('DELAY ')));
                                  If DGDelayText<>'0ms' then
                                        begin
                                        AudioStreamDelay[AllMediaFilesQ,Audio_Scan_I]:=DGDelayText;
                                        SwapText:=AudioStreamInfo[AllMediaFilesQ,Audio_Scan_I];
                                        SwapText:=SwapText+' delay '+DGDelayText;
                                        AudioStreamInfo[AllMediaFilesQ,Audio_Scan_I]:=SwapText;
                                        end;
                                  end;
                            if AudioStreamType[AllMediaFilesQ,Audio_Scan_I]='aac' then
                                  begin
                                  inc(FFMPEG_AAC_Count);
                                  FFMPEG_AAC_Index[FFMPEG_AAC_Count]:=Audio_Scan_I;
                                  DGWorkFileText:=DGFiles[DG_AAC_Index[FFMPEG_AAC_Count]];
                                  AudioStream_DG_Copy_Index[AllMediaFilesQ,Audio_Scan_I]:=DG_AAC_Index[FFMPEG_AAC_Count];
                                  DGDelayText:=
                                  TextReverse(ExtractTextBlock(TextReverse(DGWorkFileText),'.',TextReverse('DELAY ')));
                                  If DGDelayText<>'0ms' then
                                        begin
                                        AudioStreamDelay[AllMediaFilesQ,Audio_Scan_I]:=DGDelayText;
                                        SwapText:=AudioStreamInfo[AllMediaFilesQ,Audio_Scan_I];
                                        SwapText:=SwapText+' delay '+DGDelayText;
                                        AudioStreamInfo[AllMediaFilesQ,Audio_Scan_I]:=SwapText;
                                        end;
                                  end;
                            if  (AudioStreamType[AllMediaFilesQ,Audio_Scan_I]='pcm_s16le') or
                                (AudioStreamType[AllMediaFilesQ,Audio_Scan_I]='pcm_s16be') or
                                (AudioStreamType[AllMediaFilesQ,Audio_Scan_I]='pcm_s24le') or
                                (AudioStreamType[AllMediaFilesQ,Audio_Scan_I]='pcm_s24be') then
                                      begin
                                      inc(FFMPEG_PCM_Count);
                                      FFMPEG_PCM_Index[FFMPEG_PCM_Count]:=Audio_Scan_I;
                                      DGWorkFileText:=DGFiles[DG_WAV_Index[FFMPEG_PCM_Count]];
                                      AudioStream_DG_Copy_Index[AllMediaFilesQ,Audio_Scan_I]:=DG_WAV_Index[FFMPEG_PCM_Count];
                                      end;

                        end;


              // Correct frame rate for MPEG files

              for i:=1 to CurrVideoCount do
                    begin
                          if Copy(DGFrameRate,1,5)='23.97' then
                          VideoStreamFrameRate[AllMediaFilesQ,i]:='23.98';
                          if Copy(DGFrameRate,1,5)='29.97' then
                          VideoStreamFrameRate[AllMediaFilesQ,i]:='29.97';
                          if Copy(DGFrameRate,1,5)='25.00' then
                          VideoStreamFrameRate[AllMediaFilesQ,i]:='25.00';
                          if Copy(DGFrameRate,1,5)='24.00' then
                          VideoStreamFrameRate[AllMediaFilesQ,i]:='24.00';
                          // Change Frame Rate in the Summary Info
                          SwapText:=VideoStreamInfo[AllMediaFilesQ,i];
                          FPSPos:=Pos('fps',SwapText);
                          SwapText:=Copy(SwapText,1,FPSPos-7)+
                          VideoStreamFrameRate[AllMediaFilesQ,i]+' fps(r)';
                          VideoStreamInfo[AllMediaFilesQ,i]:=SwapText;

                    end;


              // Correct Media File Duration for MPEG files
              FindFirst(CurrMediaFile,faAnyFile,DGMPEGTS);
              DGMPEGFileSize:=DGMPEGTS.FindData.nFileSizeHigh*4294967296+DGMPEGTS.FindData.nFileSizeLow;
              if MediaFileDuration[AllMediaFilesQ]>0 then
              DGMPEGFileBitrate:=Round(Abs(DGMPEGFileSize*8/MediaFileDuration[AllMediaFilesQ]))
              else
              DGMPEGFileBitrate:=100000;

              if DGMPEGFileBitrate>8000 then
                    begin
                    // Run DGINDEX one more time to re-calculate
                    ZeroMemory(@DGMFDsi, sizeof(DGMFDsi));
                    DGMFDsi.cb := sizeof(DGMFDsi);
                    DGMFDsi.dwFlags:=STARTF_USESHOWWINDOW;
                    DGMFDsi.wShowWindow:=SW_HIDE;
                    CreateProcess(nil,PChar(AppPath+'DGINDEX\DGIndex.exe -IF=['+
                    CurrMediaFile+'] -OM=0 -FO=0 -OF=['+OutputPath+DGProjectName+'] -HIDE -EXIT')
                    ,nil, nil, false, 0, nil, nil, DGMFDsi, DGMFDpi);
                    DGMFDhProc:= DGMFDpi.hProcess;
                    CloseHandle(DGMFDpi.hThread);
                    // Wait for D2V file creation
                    repeat
                    DGMFDProc:=WaitForSingleObject(DGMFDhProc,100);
                    Sleep(50);
                    until (DGMFDProc=0);
                    // Reading D2V file
                    NumFrames:=0;
                    S0:=0;
                    S1:=0;
                    S2:=0;
                    S3:=0;
                    AssignFile(DGMFDTextFile,OutputPath+DGProjectName+'.d2v');
                    Reset(DGMFDTextFile);
                    repeat
                          begin
                          Readln(DGMFDTextFile,DGMFDString);
                          DGMFDShortString:=ExtractStringAfterSpacePos(DGMFDString,7);
                          DGMFDTextBlock:='';
                          If Length(DGMFDShortString)>0 then
                                begin
                                For j:=1 To Length(DGMFDShortString) do
                                      begin
                                      DGMFDbs:=Copy(DGMFDShortString, j, 1);
                                      If DGMFDbs<>' ' then
                                            begin
                                            DGMFDTextBlock:=DGMFDTextBlock+DGMFDbs;
                                            end
                                            else
                                            begin
                                            If Length(DGMFDTextBlock)>1 then
                                                  begin
                                                  DGMFDLastSymbol:=Copy(DGMFDTextBlock,
                                                  Length(DGMFDTextBlock),1)
                                                  end
                                                  else
                                                  begin
                                                  DGMFDLastSymbol:='';
                                                  end;
                                            If DGMFDLastSymbol='0' then
                                                  begin
                                                  S0:=S0+1;
                                                  end;
                                            If DGMFDLastSymbol='1' then
                                                  begin
                                                  S1:=S1+1;
                                                  end;
                                            If DGMFDLastSymbol='2' then
                                                  begin
                                                  S2:=S2+1;
                                                  end;
                                            If DGMFDLastSymbol='3' then
                                                  begin
                                                  S3:=S3+1;
                                                  end;
                                            DGMFDTextBlock:='';
                                            end;


                                      if j=Length(DGMFDShortString) then
                                            begin
                                            If Length(DGMFDTextBlock)>1 then
                                                  begin
                                                  DGMFDLastSymbol:=Copy(DGMFDTextBlock,
                                                  Length(DGMFDTextBlock),1)
                                                  end
                                                  else
                                                  begin
                                                  DGMFDLastSymbol:='';
                                                  end;
                                            If DGMFDLastSymbol='0' then
                                                  begin
                                                  S0:=S0+1;
                                                  end;
                                            If DGMFDLastSymbol='1' then
                                                  begin
                                                  S1:=S1+1;
                                                  end;
                                            If DGMFDLastSymbol='2' then
                                                  begin
                                                  S2:=S2+1;
                                                  end;
                                            If DGMFDLastSymbol='3' then
                                                  begin
                                                  S3:=S3+1;
                                                  end;
                                            DGMFDTextBlock:='';
                                            end;
                                      end;
                                end;
                          end;
                    until (EOF(DGMFDTextFile)=True);
                    CloseFile(DGMFDTextFile);
                    FindClose(DGMPEGTS);
                    // Delete D2V file
                    DelRes:=DeleteFile(OutputPath+DGProjectName+'.d2v');
                    NumFrames:=Round(Abs((S0+S2)*1+(S1+S3)*1.5));
                    val(Copy(DGFrameRate,1,6),DGFrameRateValue,DGFrameRateValueErrCode);
                    // Change Media File Duration
                    MediaFileDuration[AllMediaFilesQ]:=Round(Abs(1000*NumFrames/DGFrameRateValue));
                    // Change Media File Duration Info
                    MediaFileDurationInfo[AllMediaFilesQ]:=ConvertMSecsToDurationInfo(MediaFileDuration[AllMediaFilesQ]);

                    end;



              // Change Video Bitrate Information
              DGAudioSpaceSegment:=0;
              DGVideoSpaceSegment:=0;
              for j:=1 to AudioStreamCount[AllMediaFilesQ] do
                    begin
                    DGAudioSpaceSegment:=DGAudioSpaceSegment+
                    Round(AudioStreamInputBitrate[AllMediaFilesQ,j]*0.125*MediaFileDuration[AllMediaFilesQ]);
                    end;
              DGVideoSpaceSegment:=DGMPEGFileSize-DGAudioSpaceSegment;
              DGVideoBitrateValue:=Round(Abs(DGVideoSpaceSegment*8/MediaFileDuration[AllMediaFilesQ]));

              // Change bitrate information for Video stream
              VideoBitrateTextStopPos:=Pos('kb/s',VideoStreamInfo[AllMediaFilesQ,1]);
              if VideoBitrateTextStopPos>0 then
                    begin
                    SwapText:=Copy(VideoStreamInfo[AllMediaFilesQ,1],1,VideoBitrateTextStopPos-2);
                    VideoBitrateTextStartPos:=VideoBitrateTextStopPos-2-Pos(',',TextReverse(SwapText))+1;
                    SwapText:=Copy(VideoStreamInfo[AllMediaFilesQ,1],1,VideoBitrateTextStartPos)+
                    ' '+inttostr(DGVideoBitrateValue)+' '+
                    Copy(VideoStreamInfo[AllMediaFilesQ,1],VideoBitrateTextStopPos,
                    Length(VideoStreamInfo[AllMediaFilesQ,1])-VideoBitrateTextStopPos+1);
                    VideoStreamInfo[AllMediaFilesQ,1]:=SwapText;
                    end;              

              end;

        end;


    // Displaying Media File in a ListBox
    If MediaListFilesQ>0 then
          begin
          RemoveButton.Enabled:=True;
          RunButton.Enabled:=True;
          end;
    CurrMediaFileIndex:=VideoAudioFilesListBox.Items.Add(CurrMediaFile);
    VideoAudioFilesListBox.ItemIndex:=CurrMediaFileIndex;
    CurrMediaFileInList:=CurrMediaFileIndex+1;

    // Displaying Summary Media File Information
    FileInfoTextShow;


              // Define Video and Audio Settings

              if CurrVideoCount>0 then
                    begin
                    for i:=1 to CurrVideoCount do
                          begin
                          // Video Stream Bitrate Array
                          VideoStreamBitrate[AllMediaFilesQ,i]:='9000';
                          // Reset Video Format
                          VideoStreamFormat[AllMediaFilesQ,i]:='';
                          // Detect Video Format
                          If (VideoStreamFrameRate[AllMediaFilesQ,i]='23.98') or
                          (VideoStreamFrameRate[AllMediaFilesQ,i]='23.97') or
                          (VideoStreamFrameRate[AllMediaFilesQ,i]='24.00') then
                                begin
                                VideoStreamFormat[AllMediaFilesQ,i]:='NTSC Film';
                                InterlacedEnabled[AllMediaFilesQ,i]:=False;
                                Interlaced[AllMediaFilesQ,i]:=False;
                                end;


                          If (VideoStreamFrameRate[AllMediaFilesQ,i]='29.97') or
                          (VideoStreamFrameRate[AllMediaFilesQ,i]='29.98') or
                          (VideoStreamFrameRate[AllMediaFilesQ,i]='59.94') or
                          (VideoStreamFrameRate[AllMediaFilesQ,i]='30.00') or
                          (VideoStreamFrameRate[AllMediaFilesQ,i]='60.00') or
                          (VideoStreamFrameRate[AllMediaFilesQ,i]='15.00') then
                                begin
                                VideoStreamFormat[AllMediaFilesQ,i]:='NTSC';
                                      if FrameType[AllMediaFilesQ,i]='Interlaced' then
                                            Interlaced[AllMediaFilesQ,i]:=True
                                            else
                                            Interlaced[AllMediaFilesQ,i]:=False;

                                // Change for NTSC-Film pulldowned files
                                If (VideoStreamFrameRate[AllMediaFilesQ,i]='29.97') and
                                (VideoType[AllMediaFilesQ,i]='Film') then
                                      begin
                                      VideoStreamFormat[AllMediaFilesQ,i]:='NTSC Film';
                                      Interlaced[AllMediaFilesQ,i]:=False;
                                      end;

                                end;



                          If (VideoStreamFrameRate[AllMediaFilesQ,i]='25.00') or
                          (VideoStreamFrameRate[AllMediaFilesQ,i]='50.00') then
                                begin
                                VideoStreamFormat[AllMediaFilesQ,i]:='PAL';
                                      if FrameType[AllMediaFilesQ,i]='Interlaced' then
                                            Interlaced[AllMediaFilesQ,i]:=True
                                            else
                                            Interlaced[AllMediaFilesQ,i]:=False;
                                            
                                end;




                          // Non-standard frame rate
                          if VideoStreamFormat[AllMediaFilesQ,i]='' then
                                begin
                                FilmFrame:=0;
                                Film24Frame:=0;
                                PALFrame:=0;
                                NTSCFrame:=0;
                                SwapText:=VideoStreamFrameRate[AllMediaFilesQ,i];
                                val(SwapText,FrameRealValue,NonStandardFrameCode);
                                FilmFrame:=Abs(FrameRealValue*10000-239800);
                                Film24Frame:=Abs(FrameRealValue*10000-240000);
                                PALFrame:=Abs(FrameRealValue*10000-250000);
                                NTSCFrame:=Abs(FrameRealValue*10000-299700);
                                // May be NTSC-Film 23.976 FPS
                                If (FilmFrame<PALFrame) and (FilmFrame<NTSCFrame) and (FilmFrame<Film24Frame) then
                                      begin
                                      VideoStreamFormat[AllMediaFilesQ,i]:='NTSC Film';
                                      VideoStreamFrameRate[AllMediaFilesQ,i]:='23.98';
                                      Interlaced[AllMediaFilesQ,i]:=False;
                                      end;
                                // May be NTSC-Film 24 FPS
                                If (Film24Frame<PALFrame) and (Film24Frame<NTSCFrame) and (Film24Frame<FilmFrame) then
                                      begin
                                      VideoStreamFormat[AllMediaFilesQ,i]:='NTSC Film';
                                      VideoStreamFrameRate[AllMediaFilesQ,i]:='24.00';
                                      Interlaced[AllMediaFilesQ,i]:=False;
                                      end;
                                // May be PAL
                                If (PALFrame<FilmFrame) and (PALFrame<NTSCFrame) and (PALFrame<Film24Frame) then
                                      begin
                                      VideoStreamFormat[AllMediaFilesQ,i]:='PAL';
                                      VideoStreamFrameRate[AllMediaFilesQ,i]:='25.00';
                                      Interlaced[AllMediaFilesQ,i]:=False;
                                      end;
                                // May be NTSC
                                If (NTSCFrame<FilmFrame) and (NTSCFrame<PALFrame) and (NTSCFrame<Film24Frame) then
                                      begin
                                      VideoStreamFormat[AllMediaFilesQ,i]:='NTSC';
                                      VideoStreamFrameRate[AllMediaFilesQ,i]:='29.97';
                                      Interlaced[AllMediaFilesQ,i]:=False;
                                      end;


                                end;                                                  


                          

                          // Source And Target Aspect Ratio
                          If VideoStreamSourceAR[AllMediaFilesQ,i]='4:3' then
                                begin
                                VideoStreamTargetAR[AllMediaFilesQ,i]:='4:3'
                                end;

                          If VideoStreamSourceAR[AllMediaFilesQ,i]='16:9' then
                                begin
                                VideoStreamTargetAR[AllMediaFilesQ,i]:='16:9'
                                end;

                          If VideoStreamSourceAR[AllMediaFilesQ,i]='2.21:1' then
                                begin
                                VideoStreamTargetAR[AllMediaFilesQ,i]:='16:9'
                                end;

                          If (VideoStreamSourceAR[AllMediaFilesQ,i]='1:1') then
                                begin
                                      If (VideoStreamFrameSizeX[AllMediaFilesQ,i]/
                                      VideoStreamFrameSizeY[AllMediaFilesQ,i])>1.34 then
                                             begin
                                             VideoStreamTargetAR[AllMediaFilesQ,i]:='16:9'
                                             end
                                             else
                                             begin
                                             VideoStreamTargetAR[AllMediaFilesQ,i]:='4:3'
                                             end;

                                end;


                          If (VideoStreamSourceAR[AllMediaFilesQ,i]<>'4:3') and
                          (VideoStreamSourceAR[AllMediaFilesQ,i]<>'16:9') and
                          (VideoStreamSourceAR[AllMediaFilesQ,i]<>'1:1') and
                          (VideoStreamSourceAR[AllMediaFilesQ,i]<>'2.21:1') then
                                begin
                                val(VideoStreamSourceAR[AllMediaFilesQ,i],SAR_Value,SAR_Code);
                                      if SAR_Value>1.34 then
                                      VideoStreamTargetAR[AllMediaFilesQ,i]:='16:9'
                                      else
                                      VideoStreamTargetAR[AllMediaFilesQ,i]:='4:3';
                                end;



                          // 2-pass conversion
                          TwoPass[AllMediaFilesQ,i]:=True;

                          // Half-D1
                          HalfD1[AllMediaFilesQ,i]:=False;

                          // Copy Video Stream Enabled or Not

                          If (VideoStreamType[AllMediaFilesQ,i]='mpeg1video') then
                                begin
                                      // PAL
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=352) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=288) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='25.00') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='4:3') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=704) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=576) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='25.00') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='4:3') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=720) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=576) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='25.00') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='4:3') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            end;
                                      // NTSC
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=352) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=240) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='29.97') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='4:3') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=352) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=240) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='29.97') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='16:9') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=704) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=480) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='29.97') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='4:3') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=704) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=480) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='29.97') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='16:9') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=720) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=480) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='29.97') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='4:3') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=720) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=480) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='29.97') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='16:9') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            end;

                                end;

                          If (VideoStreamType[AllMediaFilesQ,i]='mpeg2video') then
                                begin
                                      // PAL
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=352) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=288) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='25.00') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='4:3') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=352) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=288) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='25.00') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='16:9') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=352) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=576) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='25.00') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='4:3') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=352) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=576) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='25.00') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='16:9') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=704) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=576) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='25.00') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='4:3') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=704) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=576) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='25.00') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='16:9') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=720) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=576) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='25.00') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='4:3') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=720) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=576) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='25.00') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='16:9') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            end;
                                      
                                      // NTSC Film - 23.98 fps (pulldown needed)
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=352) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=240) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='23.98') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='4:3') and
                                      (FrameType[AllMediaFilesQ,i]='Progressive') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            CopyVideoStreamPulldownMode[AllMediaFilesQ,i]:='23.98';
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=352) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=240) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='23.98') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='16:9') and
                                      (FrameType[AllMediaFilesQ,i]='Progressive') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            CopyVideoStreamPulldownMode[AllMediaFilesQ,i]:='23.98';
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=352) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=480) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='23.98') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='4:3') and
                                      (FrameType[AllMediaFilesQ,i]='Progressive') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            CopyVideoStreamPulldownMode[AllMediaFilesQ,i]:='23.98';
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=352) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=480) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='23.98') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='16:9') and
                                      (FrameType[AllMediaFilesQ,i]='Progressive') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            CopyVideoStreamPulldownMode[AllMediaFilesQ,i]:='23.98';
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=704) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=480) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='23.98') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='4:3') and
                                      (FrameType[AllMediaFilesQ,i]='Progressive') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            CopyVideoStreamPulldownMode[AllMediaFilesQ,i]:='23.98';
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=704) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=480) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='23.98') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='16:9') and
                                      (FrameType[AllMediaFilesQ,i]='Progressive') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            CopyVideoStreamPulldownMode[AllMediaFilesQ,i]:='23.98';
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=720) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=480) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='23.98') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='4:3') and
                                      (FrameType[AllMediaFilesQ,i]='Progressive') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            CopyVideoStreamPulldownMode[AllMediaFilesQ,i]:='23.98';
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=720) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=480) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='23.98') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='16:9') and
                                      (FrameType[AllMediaFilesQ,i]='Progressive') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            CopyVideoStreamPulldownMode[AllMediaFilesQ,i]:='23.98';
                                            end;

                                       // Film - 24 fps (pulldown needed)
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=352) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=240) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='24.00') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='4:3') and
                                      (FrameType[AllMediaFilesQ,i]='Progressive') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            CopyVideoStreamPulldownMode[AllMediaFilesQ,i]:='24.00';
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=352) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=240) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='24.00') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='16:9') and
                                      (FrameType[AllMediaFilesQ,i]='Progressive') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            CopyVideoStreamPulldownMode[AllMediaFilesQ,i]:='24.00';
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=352) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=480) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='24.00') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='4:3') and
                                      (FrameType[AllMediaFilesQ,i]='Progressive') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            CopyVideoStreamPulldownMode[AllMediaFilesQ,i]:='24.00';
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=352) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=480) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='24.00') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='16:9') and
                                      (FrameType[AllMediaFilesQ,i]='Progressive') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            CopyVideoStreamPulldownMode[AllMediaFilesQ,i]:='24.00';
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=704) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=480) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='24.00') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='4:3') and
                                      (FrameType[AllMediaFilesQ,i]='Progressive') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            CopyVideoStreamPulldownMode[AllMediaFilesQ,i]:='24.00';
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=704) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=480) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='24.00') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='16:9') and
                                      (FrameType[AllMediaFilesQ,i]='Progressive') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            CopyVideoStreamPulldownMode[AllMediaFilesQ,i]:='24.00';
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=720) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=480) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='24.00') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='4:3') and
                                      (FrameType[AllMediaFilesQ,i]='Progressive') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            CopyVideoStreamPulldownMode[AllMediaFilesQ,i]:='24.00';
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=720) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=480) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='24.00') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='16:9') and
                                      (FrameType[AllMediaFilesQ,i]='Progressive') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            CopyVideoStreamPulldownMode[AllMediaFilesQ,i]:='24.00';
                                            end;

                                      // NTSC  - 29.97 fps
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=352) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=240) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='29.97') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='4:3') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=352) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=240) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='29.97') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='16:9') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=352) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=480) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='29.97') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='4:3') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=352) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=480) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='29.97') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='16:9') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=704) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=480) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='29.97') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='4:3') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=704) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=480) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='29.97') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='16:9') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=720) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=480) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='29.97') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='4:3') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            end;
                                      if (VideoStreamFrameSizeX[AllMediaFilesQ,i]=720) and
                                      (VideoStreamFrameSizeY[AllMediaFilesQ,i]=480) and
                                      (VideoStreamFrameRate[AllMediaFilesQ,i]='29.97') and
                                      (VideoStreamSourceAR[AllMediaFilesQ,i]='16:9') then
                                            begin
                                            CopyVideoStreamEnabled[AllMediaFilesQ,i]:=True;
                                            end;
                                

                                end;

                          // Adding Video Streams To Video Streams List
                          VideoStreamsCheckListBox.Items.Add('#'+inttostr(i)+
                          ': '+VideoStreamInfo[AllMediaFilesQ,i]);
                          VideoStreamsCheckListBox.Checked[i-1]:=True;
                          VideoStreamChecked[AllMediaFilesQ,i]:=True;
                          end;

                          // Select the first video stream
                          CurrVideoStream[AllMediaFilesQ]:=1;
                          VideoStreamsCheckListBox.ItemIndex:=0;
                          // Refresh video settings for curent video stream
                          RefreshVideoSettings(AllMediaFilesQ);

                    end;

              if CurrAudioCount>0 then
                    begin
                    for i:=1 to CurrAudioCount do
                          begin

                          // Define default settings for audio stream

                          // AC3 Format
                          AC3Format[AllMediaFilesQ,i]:=True;

                          // WAV Format Enabled, WAV Format, Channels
                          If AudioStreamInputChannels[AllMediaFilesQ,i]='mono' then
                                begin
                                      WAVFormatEnabled[AllMediaFilesQ,i]:=True;
                                      WAVFormat[AllMediaFilesQ,i]:=False;
                                      AudioStreamChannels[AllMediaFilesQ,i]:='mono';
                                end;
                          If AudioStreamInputChannels[AllMediaFilesQ,i]='stereo' then
                                begin
                                      WAVFormatEnabled[AllMediaFilesQ,i]:=True;
                                      WAVFormat[AllMediaFilesQ,i]:=False;
                                      AudioStreamChannels[AllMediaFilesQ,i]:='stereo';
                                end;
                          If ((AudioStreamInputChannels[AllMediaFilesQ,i]<>'mono') and
                          (AudioStreamInputChannels[AllMediaFilesQ,i]<>'stereo')) then
                                begin
                                      WAVFormatEnabled[AllMediaFilesQ,i]:=False;
                                      WAVFormat[AllMediaFilesQ,i]:=False;
                                      AudioStreamChannels[AllMediaFilesQ,i]:='5:1';
                                end;


                          // Bitrate
                          AudioStreamBitrate[AllMediaFilesQ,i]:='448k';

                          // Copy Audio Stream Enabled

                                // Default
                                CopyAudioStreamEnabled[AllMediaFilesQ,i]:=False;

                                // For MPEG-1,2 media files,
                                // will be copied by DGIndex
                                If (MediaFileType[AllMediaFilesQ]='mpeg') and
                                (AudioStreamInputFrequency[AllMediaFilesQ,i]='48000') then
                                CopyAudioStreamEnabled[AllMediaFilesQ,i]:=True;

                                // DTS Audio 96kHz
                                If (MediaFileType[AllMediaFilesQ]='mpeg') and
                                (AudioStreamInputFrequency[AllMediaFilesQ,i]='96000') and
                                (AudioStreamType[AllMediaFilesQ,i]='dts') then
                                CopyAudioStreamEnabled[AllMediaFilesQ,i]:=True;

                                // PCM Audio 96kHz - LPCM 16 bit
                                If (MediaFileType[AllMediaFilesQ]='mpeg') and
                                (AudioStreamInputFrequency[AllMediaFilesQ,i]='96000') and
                                (AudioStreamType[AllMediaFilesQ,i]='pcm_s16be') then
                                CopyAudioStreamEnabled[AllMediaFilesQ,i]:=True;

                                // PCM Audio 96kHz - PCM 16 bit
                                If (MediaFileType[AllMediaFilesQ]='mpeg') and
                                (AudioStreamInputFrequency[AllMediaFilesQ,i]='96000') and
                                (AudioStreamType[AllMediaFilesQ,i]='pcm_s16le') then
                                CopyAudioStreamEnabled[AllMediaFilesQ,i]:=True;

                                // PCM Audio 96kHz - LPCM 24 bit
                                If (MediaFileType[AllMediaFilesQ]='mpeg') and
                                (AudioStreamInputFrequency[AllMediaFilesQ,i]='96000') and
                                (AudioStreamType[AllMediaFilesQ,i]='pcm_s24be') then
                                CopyAudioStreamEnabled[AllMediaFilesQ,i]:=True;

                                // PCM Audio 96kHz - PCM 24 bit
                                If (MediaFileType[AllMediaFilesQ]='mpeg') and
                                (AudioStreamInputFrequency[AllMediaFilesQ,i]='96000') and
                                (AudioStreamType[AllMediaFilesQ,i]='pcm_s24le') then
                                CopyAudioStreamEnabled[AllMediaFilesQ,i]:=True;

                                // PCM (WAV) format
                                if (AudioStreamType[AllMediaFilesQ,i]='pcm_s16le') and
                                (AudioStreamInputFrequency[AllMediaFilesQ,i]='48000') then
                                CopyAudioStreamEnabled[AllMediaFilesQ,i]:=True;

                                // AC3 format
                                if (AudioStreamType[AllMediaFilesQ,i]='ac3') and
                                (AudioStreamInputFrequency[AllMediaFilesQ,i]='48000') then
                                CopyAudioStreamEnabled[AllMediaFilesQ,i]:=True;


                          // Adding Audio Streams To Audio Streams List
                          AudioStreamsCheckListBox.Items.Add('#'+inttostr(i)+
                          ': '+AudioStreamInfo[AllMediaFilesQ,i]);
                          AudioStreamsCheckListBox.Checked[i-1]:=True;
                          AudioStreamChecked[AllMediaFilesQ,i]:=True;
                          end;

                          // Select the first audio stream
                          CurrAudioStream[AllMediaFilesQ]:=1;
                          AudioStreamsCheckListBox.ItemIndex:=0;
                          // Refresh audio settings for current audio stream
                          RefreshAudioSettings(AllMediaFilesQ);

                    end;



    end;


  AddFileButton.Caption:='Add File';
  AddFileButton.Enabled:=True;


  // Media not supported
  If (StartPos=0) then ShowMessage('Error! Selected File is not supported');
  end;

  // Calculate Disk Space
  CalculateDiskSpace;

end;

procedure TAppForm.FormCreate(Sender: TObject);
begin
// Application version
AppVersion:='1.0';
// Application .exe name
AppName:='BatchDVDStreamsConverter.exe';
// Define Path to the Application
AppPath:=Copy(ParamStr(0),1,Length(ParamStr(0))-Length(AppName));
// FFMPEG Path
FFMPEGPath:=AppPath+'FFMPEG\ffmpeg.exe';
// Default Output Path
OutputPath:='D:\Video\';
OldOutputPath:='D:\Video\';
If DirectoryExists(OutputPath)=False then
begin
OutputPath:=AppPath;
OldOutputPath:=AppPath;
end;
OutputFolderEdit.Text:=OutputPath;
// Drive Code
CurrentDriveCode:=DefineDriveCode(OutputPath);
// Drive Size
DriveSize:=DiskSize(CurrentDriveCode);
// Media Files Counter
AllMediaFilesQ:=0;
// AMG File path
AMGFilePath:=AppPath+'AVIMUX_GUI\AVIMux_GUI.exe';
// AMG Script Path
AMGScriptPath:=AppPath+'AVIMUX_GUI\amg.asc';
// AVI Scan Time (in seconds)
AVIScanTime:=2;
// Disable All Video Settings
DisableAllVideoSettings;
// Disable All Audio Settings
DisableAllAudioSettings;
// Calculate Disk Space
CalculateDiskSpace;
// Change Free HDD Space ProgressBar Color
SendMessage(FreeHDDSpaceProgressBar.Handle, PBM_SETBARCOLOR, 0, TColor($408000));
// Change DVD ProgressBar Color
SendMessage(DVDProgressBar.Handle, PBM_SETBARCOLOR, 0, TColor($4080FF));
// AppLog.txt file is not exists
AppLogFileClosed:=True;
// Skip Pulldown
SkipPulldown:=False;
end;

procedure TAppForm.JoinVOBFilesTool1Click(Sender: TObject);
begin
ShellExecute(0, nil, PChar(AppPath+'JoinVOBFilesTool\JoinVobFiles.exe'), nil, nil, SW_SHOWNORMAL);
end;

procedure TAppForm.MuxManDVDAuthoring1Click(Sender: TObject);
begin
ShellExecute(0, nil, PChar(AppPath+'MuxMan_0_15R\MuxMan.exe'), nil, nil, SW_SHOWNORMAL);
end;

procedure TAppForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
if MessageDlg('Are you sure to exit from Batch DVD Streams Converter?',
mtConfirmation, [mbYes, mbCancel], 0) = mrCancel then
  begin
  CanClose := False;
  end
  else
  begin
  // Conversion Timer Terminating
  ConversionTimer.Enabled:=False;
  // AppLog.txt file - Close
  if AppLogFileClosed=False then
        begin
        AppLogDateTime:=Time;
        AppLogTimeString:=TimeToStr(AppLogDateTime);
        Writeln(AppLogTextFile,'');
        Writeln(AppLogTextFile,AppLogTimeString+' *** Exiting during processing ***');
        CloseFile(AppLogTextFile);
        AppLogFileClosed:=True;
        end;
  // EXE Terminating
  if hProc<>0 then
        begin
        TerminateProcess(hProc,0);
        FreeConsole;
        end;
  CanClose := True;
  end;
end;

procedure TAppForm.ChangeButtonClick(Sender: TObject);
var
  Bro        : BROWSEINFO;
  ItemID     : PITEMIDLIST;
  Result     : array[1..MAX_PATH] of Char;
  begin
  FillChar(Result,MAX_PATH,0);
  Bro.hwndOwner      := Handle  ;
  Bro.pidlRoot       := nil     ;
  Bro.pszDisplayName := @Result ;
  Bro.lpszTitle      := 'Select A Folder';
  Bro.ulFlags        := 0        ;
  Bro.lpfn           := nil      ;
  Bro.lParam         := 0        ;
  Bro.iImage         := 0        ;
  ItemID := SHBrowseForFolder(Bro);
  if ItemID<>nil then
  begin
    if SHGetPathFromIDList(ItemID, @Result)=True then begin
    OutputPath:=string(Result);
    OutputPath:=Copy(OutputPath,1,FindFirstZeroCode(OutputPath));
    // Check foreign symbols in selected output path
    If (CheckForeignSymbols(OutputPath))=True then
      begin
      ShowMessage('Error! Please don''t use foreign symbols in folder names');
      OutputPath:=OldOutputPath;
      Exit;
      end
      else
      begin
      OutputFolderEdit.Text:=OutputPath;
      If Copy(OutputFolderEdit.Text,Length(OutputFolderEdit.Text),1)<>'\' then
      OutputFolderEdit.Text:=OutputFolderEdit.Text+'\';
      OutputPath:=OutputFolderEdit.Text;
      OldOutputPath:=OutputPath;
      // Change current drive code
      CurrentDriveCode:=DefineDriveCode(OutputPath);
      // Drive Size
      DriveSize:=DiskSize(CurrentDriveCode);
      // Calculate Disk Space
      CalculateDiskSpace;
      end;
    end;
  end;
end;


procedure TAppForm.RemoveButtonClick(Sender: TObject);
begin

if MessageDlg('Are you sure to remove selected file from the list?',
mtWarning, [mbYes, mbCancel], 0) = mrCancel then
  begin
  Exit;
  end
  else
  begin
  BufferCounter:=0;
  SelectedMediaFileIndex:=VideoAudioFilesListBox.ItemIndex;
  // Copy to BufferForPosition and Removing Selected Item
  For i:=1 to MediaListFilesQ do
        begin
        if i<>SelectedMediaFileIndex+1 then
              begin
              inc(BufferCounter);
              BufferForPosition[BufferCounter]:=RealPosition[i];
              end
              else
              begin
              VideoAudioFilesListBox.Items.Delete(SelectedMediaFileIndex);
              dec(MediaListFilesQ);
              end;
        end;


  If MediaListFilesQ=0 then
        begin
        RemoveButton.Enabled:=False;
        RunButton.Enabled:=False;
        // Disable All Audio Settings
        DisableAllAudioSettings;
        // Uncheck All Audio Settings
        UncheckAllAudioSettings;
        // Disable All Video Settings
        DisableAllVideoSettings;
        end
        else
        begin
        // Refreshing RealPosition Array
        For i:=1 to MediaListFilesQ do
              begin
              RealPosition[i]:=BufferForPosition[i];
              end;
        end;
  // Clear Audio Streams ListBox
  AudioStreamsCheckListBox.Clear;
  // Clear Video Streams ListBox
  VideoStreamsCheckListBox.Clear;

  // Change active Position in Media List after Removing

  // Last
  If (SelectedMediaFileIndex=MediaListFilesQ) and (MediaListFilesQ>0) then
          begin
          VideoAudioFilesListBox.ItemIndex:=MediaListFilesQ-1;
          VideoAudioFilesListBoxClick(AppForm);
          end;

  // First and Others Not Last
  If (SelectedMediaFileIndex<MediaListFilesQ) then
          begin
          VideoAudioFilesListBox.ItemIndex:=SelectedMediaFileIndex;
          VideoAudioFilesListBoxClick(AppForm);
          end;

  // Calculate Disk Space
  CalculateDiskSpace;
  end;


end;


procedure TAppForm.N2sec1Click(Sender: TObject);
begin
// UnCheck All
AppMenu.Items[2].Items[0].Items[0].Checked:=False;
AppMenu.Items[2].Items[0].Items[1].Checked:=False;
AppMenu.Items[2].Items[0].Items[2].Checked:=False;
AppMenu.Items[2].Items[0].Items[3].Checked:=False;
AppMenu.Items[2].Items[0].Items[4].Checked:=False;
AppMenu.Items[2].Items[0].Items[5].Checked:=False;
// Check Selected
AppMenu.Items[2].Items[0].Items[0].Checked:=True;
AVIScanTime:=2;
end;


procedure TAppForm.N3sec1Click(Sender: TObject);
begin
// UnCheck All
AppMenu.Items[2].Items[0].Items[0].Checked:=False;
AppMenu.Items[2].Items[0].Items[1].Checked:=False;
AppMenu.Items[2].Items[0].Items[2].Checked:=False;
AppMenu.Items[2].Items[0].Items[3].Checked:=False;
AppMenu.Items[2].Items[0].Items[4].Checked:=False;
AppMenu.Items[2].Items[0].Items[5].Checked:=False;
// Check Selected
AppMenu.Items[2].Items[0].Items[1].Checked:=True;
AVIScanTime:=3;
end;


procedure TAppForm.N5sec1Click(Sender: TObject);
begin
// UnCheck All
AppMenu.Items[2].Items[0].Items[0].Checked:=False;
AppMenu.Items[2].Items[0].Items[1].Checked:=False;
AppMenu.Items[2].Items[0].Items[2].Checked:=False;
AppMenu.Items[2].Items[0].Items[3].Checked:=False;
AppMenu.Items[2].Items[0].Items[4].Checked:=False;
AppMenu.Items[2].Items[0].Items[5].Checked:=False;
// Check Selected
AppMenu.Items[2].Items[0].Items[2].Checked:=True;
AVIScanTime:=5;
end;

procedure TAppForm.N7sec1Click(Sender: TObject);
begin
// UnCheck All
AppMenu.Items[2].Items[0].Items[0].Checked:=False;
AppMenu.Items[2].Items[0].Items[1].Checked:=False;
AppMenu.Items[2].Items[0].Items[2].Checked:=False;
AppMenu.Items[2].Items[0].Items[3].Checked:=False;
AppMenu.Items[2].Items[0].Items[4].Checked:=False;
AppMenu.Items[2].Items[0].Items[5].Checked:=False;
// Check Selected
AppMenu.Items[2].Items[0].Items[3].Checked:=True;
AVIScanTime:=7;
end;

procedure TAppForm.N10sec1Click(Sender: TObject);
begin
// UnCheck All
AppMenu.Items[2].Items[0].Items[0].Checked:=False;
AppMenu.Items[2].Items[0].Items[1].Checked:=False;
AppMenu.Items[2].Items[0].Items[2].Checked:=False;
AppMenu.Items[2].Items[0].Items[3].Checked:=False;
AppMenu.Items[2].Items[0].Items[4].Checked:=False;
AppMenu.Items[2].Items[0].Items[5].Checked:=False;
// Check Selected
AppMenu.Items[2].Items[0].Items[4].Checked:=True;
AVIScanTime:=10;
end;

procedure TAppForm.N15sec1Click(Sender: TObject);
begin
// UnCheck All
AppMenu.Items[2].Items[0].Items[0].Checked:=False;
AppMenu.Items[2].Items[0].Items[1].Checked:=False;
AppMenu.Items[2].Items[0].Items[2].Checked:=False;
AppMenu.Items[2].Items[0].Items[3].Checked:=False;
AppMenu.Items[2].Items[0].Items[4].Checked:=False;
AppMenu.Items[2].Items[0].Items[5].Checked:=False;
// Check Selected
AppMenu.Items[2].Items[0].Items[5].Checked:=True;
AVIScanTime:=15;
end;


procedure TAppForm.VideoAudioFilesListBoxClick(Sender: TObject);
begin
// Change File Info Text
FileInfoTextShow;

DisableVideoSettings4RemoveFromMediaList;
DisableAudioSettings4RemoveFromMediaList;

// Refresh Audio and Video Streams ListBoxes
ChangedMediaFilesPos:=VideoAudioFilesListBox.ItemIndex;
MediaUserNum:=RealPosition[ChangedMediaFilesPos+1];
CurrMediaFileInList:=ChangedMediaFilesPos+1;

// Audio
AudioStreamsCheckListBox.Clear;
If AudioStreamCount[MediaUserNum]>0 then
      begin
          for i:=1 to AudioStreamCount[MediaUserNum] do
            begin
            AudioStreamsCheckListBox.Items.Add(AudioStreamInfo[MediaUserNum,i]);
                if AudioStreamChecked[MediaUserNum,i]=True then
                AudioStreamsCheckListBox.Checked[i-1]:=True
                else
                AudioStreamsCheckListBox.Checked[i-1]:=False;
                end;
          // Select current Audio Stream
          AudioStreamsCheckListBox.ItemIndex:=CurrAudioStream[MediaUserNum]-1;
          // Audio - Refresh Audio Settings
          RefreshAudioSettings(MediaUserNum);
      end;

// Video
VideoStreamsCheckListBox.Clear;
if VideoStreamCount[MediaUserNum]>0 then
      begin
          for i:=1 to VideoStreamCount[MediaUserNum] do
            begin
            VideoStreamsCheckListBox.Items.Add(VideoStreamInfo[MediaUserNum,i]);
                if VideoStreamChecked[MediaUserNum,i]=True then
                VideoStreamsCheckListBox.Checked[i-1]:=True
                else
                VideoStreamsCheckListBox.Checked[i-1]:=False;
            end;
      // Select current Video Stream
      VideoStreamsCheckListBox.ItemIndex:=CurrVideoStream[MediaUserNum]-1;
      // Video - Refresh Video Settings
      RefreshVideoSettings(MediaUserNum);
      end;



end;

procedure TAppForm.AudioStreamsCheckListBoxClickCheck(Sender: TObject);
begin

WhatStreamToSelect:=2;
DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,AudioStreamNumber);
AudioStreamCheckedFlag:=False;

If (AudioStreamsCheckListBox.Checked[AudioStreamNumber-1]=True)
    and (AudioStreamCheckedFlag=False) then
        begin
        AudioStreamChecked[MediaUserNum,AudioStreamNumber]:=True;
        AudioStreamCheckedFlag:=True;
        end;

If (AudioStreamsCheckListBox.Checked[AudioStreamNumber-1]=False)
    and (AudioStreamCheckedFlag=False) then
        begin
        AudioStreamChecked[MediaUserNum,AudioStreamNumber]:=False;
        AudioStreamCheckedFlag:=True;
        end;

// Calculate Disk Space
CalculateDiskSpace;
end;

procedure TAppForm.VideoStreamsCheckListBoxClickCheck(Sender: TObject);
begin

WhatStreamToSelect:=1;
DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,VideoStreamNumber);
VideoStreamCheckedFlag:=False;

If (VideoStreamsCheckListBox.Checked[VideoStreamNumber-1]=True)
    and (VideoStreamCheckedFlag=False) then
        begin
        VideoStreamChecked[MediaUserNum,VideoStreamNumber]:=True;
        VideoStreamCheckedFlag:=True;
        end;

If (VideoStreamsCheckListBox.Checked[VideoStreamNumber-1]=False)
    and (VideoStreamCheckedFlag=False) then
        begin
        VideoStreamChecked[MediaUserNum,VideoStreamNumber]:=False;
        VideoStreamCheckedFlag:=True;
        end;


// Calculate Disk Space
CalculateDiskSpace;
end;

procedure TAppForm.RefreshVideoSettings(SelectedMediaFileNum:Integer);
begin
EnableAllVideoSettings;
CurrSV:=CurrVideoStream[SelectedMediaFileNum];
RefreshVideoBitrateChanged:=False;

      // Bitrate
      if VideoStreamBitrate[SelectedMediaFileNum,CurrSV]='1000' then
            begin
            VideoBitrateComboBox.ItemIndex:=0;
            RefreshVideoBitrateChanged:=True;
            end;
      if VideoStreamBitrate[SelectedMediaFileNum,CurrSV]='2000' then
            begin
            VideoBitrateComboBox.ItemIndex:=1;
            RefreshVideoBitrateChanged:=True;
            end;
      if VideoStreamBitrate[SelectedMediaFileNum,CurrSV]='3000' then
            begin
            VideoBitrateComboBox.ItemIndex:=2;
            RefreshVideoBitrateChanged:=True;
            end;
      if VideoStreamBitrate[SelectedMediaFileNum,CurrSV]='4000' then
            begin
            VideoBitrateComboBox.ItemIndex:=3;
            RefreshVideoBitrateChanged:=True;
            end;
      if VideoStreamBitrate[SelectedMediaFileNum,CurrSV]='5000' then
            begin
            VideoBitrateComboBox.ItemIndex:=4;
            RefreshVideoBitrateChanged:=True;
            end;
      if VideoStreamBitrate[SelectedMediaFileNum,CurrSV]='6000' then
            begin
            VideoBitrateComboBox.ItemIndex:=5;
            RefreshVideoBitrateChanged:=True;
            end;
      if VideoStreamBitrate[SelectedMediaFileNum,CurrSV]='7000' then
            begin
            VideoBitrateComboBox.ItemIndex:=6;
            RefreshVideoBitrateChanged:=True;
            end;
      if VideoStreamBitrate[SelectedMediaFileNum,CurrSV]='8000' then
            begin
            VideoBitrateComboBox.ItemIndex:=7;
            RefreshVideoBitrateChanged:=True;
            end;
      if VideoStreamBitrate[SelectedMediaFileNum,CurrSV]='9000' then
            begin
            VideoBitrateComboBox.ItemIndex:=8;
            RefreshVideoBitrateChanged:=True;
            end;
      if RefreshVideoBitrateChanged=True then
            begin
            CustomVideoBitrateEdit.Enabled:=False;
            CustomVideoBitrateEdit.Text:='';
            CustomVideoBitrateEdit.Color:=clScrollBar;
            // Objects states
            VideoBitrateComboBoxObjectState[SelectedMediaFileNum,CurrSV]:=True;
            CustomVideoBitrateEditObjectState[SelectedMediaFileNum,CurrSV]:=False;
            end;
      if RefreshVideoBitrateChanged=False then
            begin
            VideoBitrateComboBox.ItemIndex:=9;
            RefreshVideoBitrateChanged:=True;
            CustomVideoBitrateEdit.Text:=
            VideoStreamBitrate[SelectedMediaFileNum,CurrSV];
            CustomVideoBitrateEdit.Color:=clWindow;
            // Objects states
            VideoBitrateComboBoxObjectState[SelectedMediaFileNum,CurrSV]:=True;
            CustomVideoBitrateEditObjectState[SelectedMediaFileNum,CurrSV]:=True;
            end;


      // Video Stream Format

      if VideoStreamFormat[SelectedMediaFileNum,CurrSV]='NTSC Film' then
      begin
      VideoFormatComboBox.ItemIndex:=0;
      end;
      if VideoStreamFormat[SelectedMediaFileNum,CurrSV]='NTSC' then
      begin
      VideoFormatComboBox.ItemIndex:=1;
      end;
      if VideoStreamFormat[SelectedMediaFileNum,CurrSV]='PAL' then
      begin
      VideoFormatComboBox.ItemIndex:=2;
      end;

      // Change Video Format CheckBox
      
      if ChangeFormatChecked[SelectedMediaFileNum,CurrSV]=False then
            begin
            VideoFormatComboBox.Enabled:=False;
            ChangeVideoFormatCheckBox.Checked:=False;
            // Objects States
            VideoFormatComboBoxObjectState[SelectedMediaFileNum,CurrSV]:=False;
            ChangeVideoFormatCheckBoxObjectState[SelectedMediaFileNum,CurrSV]:=False;
            end
            else
            begin
            VideoFormatComboBox.Enabled:=True;
            ChangeVideoFormatCheckBox.Checked:=True;
            // Objects States
            VideoFormatComboBoxObjectState[SelectedMediaFileNum,CurrSV]:=True;
            ChangeVideoFormatCheckBoxObjectState[SelectedMediaFileNum,CurrSV]:=True;
            end;


      // Interlaced Enable
      If InterlacedEnabled[SelectedMediaFileNum,CurrSV]=False then
            begin
            InterlacedFlag.Enabled:=False;
            // Objects States
            InterlacedFlagObjectState[SelectedMediaFileNum,CurrSV]:=False;
            end
            else
            begin
            InterlacedFlag.Enabled:=True;
            // Objects States
            InterlacedFlagObjectState[SelectedMediaFileNum,CurrSV]:=True;
            end;

      // Interlaced
      If Interlaced[SelectedMediaFileNum,CurrSV]=False then
      InterlacedFlag.Checked:=False
      else
      InterlacedFlag.Checked:=True;

      // Source Aspect Ratio

      If VideoStreamSourceAR[SelectedMediaFileNum,CurrSV]='4:3' then
      VideoSourceAspectRatioComboBox.ItemIndex:=0;
      If VideoStreamSourceAR[SelectedMediaFileNum,CurrSV]='16:9' then
      VideoSourceAspectRatioComboBox.ItemIndex:=1;
      If VideoStreamSourceAR[SelectedMediaFileNum,CurrSV]='1:1' then
      VideoSourceAspectRatioComboBox.ItemIndex:=2;
      If VideoStreamSourceAR[SelectedMediaFileNum,CurrSV]='2.21:1' then
      VideoSourceAspectRatioComboBox.ItemIndex:=3;

      CustomVideoSourceAspectRatioEdit.Enabled:=False;
      VideoSourceAspectRatioComboBox.Enabled:=False;
      CustomVideoSourceAspectRatioEdit.Text:='';

      // Objects States
      VideoSourceAspectRatioComboBoxObjectState[SelectedMediaFileNum,CurrSV]:=False;
      CustomVideoSourceAspectRatioEditObjectState[SelectedMediaFileNum,CurrSV]:=False;

      If (VideoStreamSourceAR[SelectedMediaFileNum,CurrSV]<>'4:3') and
      (VideoStreamSourceAR[SelectedMediaFileNum,CurrSV]<>'16:9') and
      (VideoStreamSourceAR[SelectedMediaFileNum,CurrSV]<>'1:1') and
      (VideoStreamSourceAR[SelectedMediaFileNum,CurrSV]<>'2.21:1') then
            begin
            VideoSourceAspectRatioComboBox.ItemIndex:=4;
            CustomVideoSourceAspectRatioEdit.Text:=
            VideoStreamSourceAR[SelectedMediaFileNum,CurrSV];
            end;

      // Change Source Aspect Ratio CheckBox

      If ChangeSourceAspectRatioChecked[SelectedMediaFileNum,CurrSV]=True then
          begin
          ChangeSourceAspectRatioCheckBox.Checked:=True;
          VideoSourceAspectRatioComboBox.Enabled:=True;
          // Objects States
          ChangeSourceAspectRatioCheckBoxObjectState[SelectedMediaFileNum,CurrSV]:=True;
          VideoSourceAspectRatioComboBoxObjectState[SelectedMediaFileNum,CurrSV]:=True;
                // For custom Source Aspect ratio
                if  VideoSourceAspectRatioComboBox.ItemIndex=4 then
                      begin
                      CustomVideoSourceAspectRatioEdit.Enabled:=True;
                      CustomVideoSourceAspectRatioEdit.Color:=clWindow;
                      // Objects States
                      CustomVideoSourceAspectRatioEditObjectState[SelectedMediaFileNum,CurrSV]:=True;
                      end;
          end;

      If ChangeSourceAspectRatioChecked[SelectedMediaFileNum,CurrSV]=False then
          begin
          ChangeSourceAspectRatioCheckBox.Checked:=False;
          VideoSourceAspectRatioComboBox.Enabled:=False;
          // Objects States
          ChangeSourceAspectRatioCheckBoxObjectState[SelectedMediaFileNum,CurrSV]:=False;
          VideoSourceAspectRatioComboBoxObjectState[SelectedMediaFileNum,CurrSV]:=False;
                // For custom Source Aspect ratio
                if  VideoSourceAspectRatioComboBox.ItemIndex=4 then
                      begin
                      CustomVideoSourceAspectRatioEdit.Enabled:=False;
                      CustomVideoSourceAspectRatioEdit.Color:=clScrollBar;
                      // Objects States
                      CustomVideoSourceAspectRatioEditObjectState[SelectedMediaFileNum,CurrSV]:=False;
                      end;
          end;

      // Target Aspect Ratio

      If VideoStreamTargetAR[SelectedMediaFileNum,CurrSV]='4:3' then
      VideoTargetAspectRatioComboBox.ItemIndex:=0
      else
      VideoTargetAspectRatioComboBox.ItemIndex:=1;

      // 2-Pass Conversion

      If TwoPass[SelectedMediaFileNum,CurrSV]=True then
      TwoPassConversionCheckBox.Checked:=True
      else
      TwoPassConversionCheckBox.Checked:=False;

      // Half-D1 Frame Size

      If HalfD1[SelectedMediaFileNum,CurrSV]=True then
      HalfD1FrameSizeCheckBox.Checked:=True
      else
      HalfD1FrameSizeCheckBox.Checked:=False;


      // Copy Video Stream Enabled

      If CopyVideoStreamEnabled[SelectedMediaFileNum,CurrSV]=True then
      VideoCopyCheckBox.Enabled:=True
      else
      VideoCopyCheckBox.Enabled:=False;

      // Copy Video Stream CheckBox

      If CopyVideoStream[SelectedMediaFileNum,CurrSV]=True then
            begin
            VideoCopyCheckBox.Checked:=True;
            DisableVideoSettings4Copy;
            end
            else
            begin
            VideoCopyCheckBox.Checked:=False;
            end;


end;



procedure TAppForm.RefreshAudioSettings(SelectedMediaFileNum:Integer);
begin

ActiveAudioFormatProcedure:='RefreshAudioSettings';
EnableAllAudioSettings;
CurrSA:=CurrAudioStream[SelectedMediaFileNum];

      // AC3 Format
      If AC3Format[SelectedMediaFileNum,CurrSA]=True then
            begin
            ActiveAudioFormatProcedure:='RefreshAudioSettings+AC3FormatTrue';
            AC3AudioFormatCheckBox.Checked:=True;
            end
            else
            begin
            ActiveAudioFormatProcedure:='RefreshAudioSettings+AC3FormatFalse';
            AC3AudioFormatCheckBox.Checked:=False;
            end;

      // WAV Format
      If WAVFormat[SelectedMediaFileNum,CurrSA]=True then
            begin
            ActiveAudioFormatProcedure:='RefreshAudioSettings+WAVFormatTrue';
            WAVAudioFormatCheckBox.Checked:=True;
            // Disable Audio Bitrate CheckBoxes
            DisableAudioBitrateSettings;
            end
            else
            begin
            ActiveAudioFormatProcedure:='RefreshAudioSettings+WAVFormatFalse';
            WAVAudioFormatCheckBox.Checked:=False;
            end;

      // WAV Format Enabled
      If WAVFormatEnabled[SelectedMediaFileNum,CurrSA]=True then
      WAVAudioFormatCheckBox.Enabled:=True
      else
      WAVAudioFormatCheckBox.Enabled:=False;


      // Channels
      // Clear Checked Values
      UncheckAllAudioChannels;
      // Selecting
      if AudioStreamChannels[SelectedMediaFileNum,CurrSA]='mono' then
            begin
            AudioChannels1CheckBox.Checked:=True;
            end;
      if AudioStreamChannels[SelectedMediaFileNum,CurrSA]='stereo' then
            begin
            AudioChannels2CheckBox.Checked:=True;
            end;
      if (AudioStreamChannels[SelectedMediaFileNum,CurrSA]='5:1') or
      (AudioStreamChannels[SelectedMediaFileNum,CurrSA]='5 channels') or
      (AudioStreamChannels[SelectedMediaFileNum,CurrSA]='6 channels') then
            begin
            AudioChannels6CheckBox.Checked:=True;
            // Disable CheckBoxes for 6-channels audio
            AudioBitrate128CheckBox.Enabled:=False;
            AudioBitrate160CheckBox.Enabled:=False;
            AudioBitrate192CheckBox.Enabled:=False;
            AudioBitrate224CheckBox.Enabled:=False;
            AudioBitrate256CheckBox.Enabled:=False;
            AudioBitrate320CheckBox.Enabled:=False;
            // Disable AC3 CheckBox
            AC3AudioFormatCheckBox.Enabled:=False;
            end;

      AudioChannels1CheckBox.Enabled:=False;
      AudioChannels2CheckBox.Enabled:=False;
      AudioChannels6CheckBox.Enabled:=False;

      // Bitrate
      // 128k
      If AudioStreamBitrate[SelectedMediaFileNum,CurrSA]='128k' then
            begin
            ActiveAudioBitrateProcedure:='RefreshAudioSettings+128kTrue';
            AudioBitrate128CheckBox.Checked:=True;
            end
            else
            begin
            ActiveAudioBitrateProcedure:='RefreshAudioSettings+128kFalse';
            AudioBitrate128CheckBox.Checked:=False;
            end;
      // 160k
      If AudioStreamBitrate[SelectedMediaFileNum,CurrSA]='160k' then
            begin
            ActiveAudioBitrateProcedure:='RefreshAudioSettings+160kTrue';
            AudioBitrate160CheckBox.Checked:=True;
            end
            else
            begin
            ActiveAudioBitrateProcedure:='RefreshAudioSettings+160kFalse';
            AudioBitrate160CheckBox.Checked:=False;
            end;
      // 192k
      If AudioStreamBitrate[SelectedMediaFileNum,CurrSA]='192k' then
            begin
            ActiveAudioBitrateProcedure:='RefreshAudioSettings+192kTrue';
            AudioBitrate192CheckBox.Checked:=True;
            end
            else
            begin
            ActiveAudioBitrateProcedure:='RefreshAudioSettings+192kFalse';
            AudioBitrate192CheckBox.Checked:=False;
            end;
      // 224k
      If AudioStreamBitrate[SelectedMediaFileNum,CurrSA]='224k' then
            begin
            ActiveAudioBitrateProcedure:='RefreshAudioSettings+224kTrue';
            AudioBitrate224CheckBox.Checked:=True;
            end
            else
            begin
            ActiveAudioBitrateProcedure:='RefreshAudioSettings+224kFalse';
            AudioBitrate224CheckBox.Checked:=False;
            end;
      // 256k
      If AudioStreamBitrate[SelectedMediaFileNum,CurrSA]='256k' then
            begin
            ActiveAudioBitrateProcedure:='RefreshAudioSettings+256kTrue';
            AudioBitrate256CheckBox.Checked:=True;
            end
            else
            begin
            ActiveAudioBitrateProcedure:='RefreshAudioSettings+256kFalse';
            AudioBitrate256CheckBox.Checked:=False;
            end;
      // 320k
      If AudioStreamBitrate[SelectedMediaFileNum,CurrSA]='320k' then
            begin
            ActiveAudioBitrateProcedure:='RefreshAudioSettings+320kTrue';
            AudioBitrate320CheckBox.Checked:=True;
            end
            else
            begin
            ActiveAudioBitrateProcedure:='RefreshAudioSettings+320kFalse';
            AudioBitrate320CheckBox.Checked:=False;
            end;
      // 384k
      If AudioStreamBitrate[SelectedMediaFileNum,CurrSA]='384k' then
            begin
            ActiveAudioBitrateProcedure:='RefreshAudioSettings+384kTrue';
            AudioBitrate384CheckBox.Checked:=True;
            end
            else
            begin
            ActiveAudioBitrateProcedure:='RefreshAudioSettings+384kFalse';
            AudioBitrate384CheckBox.Checked:=False;
            end;
      // 448k
      If AudioStreamBitrate[SelectedMediaFileNum,CurrSA]='448k' then
            begin
            ActiveAudioBitrateProcedure:='RefreshAudioSettings+484kTrue';
            AudioBitrate448CheckBox.Checked:=True;
            end
            else
            begin
            ActiveAudioBitrateProcedure:='RefreshAudioSettings+484kFalse';
            AudioBitrate448CheckBox.Checked:=False;
            end;

      // Copy Audio Stream Enabled
      If CopyAudioStreamEnabled[SelectedMediaFileNum,CurrSA]=True then
      begin
      AudioCopyCheckBox.Enabled:=True
      end
      else
      begin
      AudioCopyCheckBox.Enabled:=False;
      end;

      // Copy Audio Stream CheckBox

      If CopyAudioStream[SelectedMediaFileNum,CurrSA]=True then
      begin
      AudioCopyCheckBox.Checked:=True;
      DisableAudioSettings4Copy;
      end
      else
      begin
      AudioCopyCheckBox.Checked:=False;
      end;
end;


procedure TAppForm.DefineCurrentVideoOrAudioStream(var WhatStream,CurrentMediaFile,CurrentStreamNum:Integer);
var
DefineChangedMediaFilesPos,ChangedStreamPos:Integer;
begin
DefineChangedMediaFilesPos:=VideoAudioFilesListBox.ItemIndex;
CurrentMediaFile:=RealPosition[DefineChangedMediaFilesPos+1];
      // Stream 1 - Video
      if WhatStream=1 then
            begin
            ChangedStreamPos:=VideoStreamsCheckListBox.ItemIndex;
            CurrVideoStream[CurrentMediaFile]:=ChangedStreamPos+1;
            CurrentStreamNum:=CurrVideoStream[CurrentMediaFile];
            end;
      // Stream 2 - Audio
      if WhatStream=2 then
            begin
            ChangedStreamPos:=AudioStreamsCheckListBox.ItemIndex;
            CurrAudioStream[CurrentMediaFile]:=ChangedStreamPos+1;
            CurrentStreamNum:=CurrAudioStream[CurrentMediaFile];
            end;

end;


procedure TAppForm.AudioStreamsCheckListBoxClick(Sender: TObject);
begin
// Define the audio stream
WhatStreamToSelect:=2;
DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,AudioStreamNumber);
RefreshAudioSettings(MediaUserNum);
end;

procedure TAppForm.VideoStreamsCheckListBoxClick(Sender: TObject);
begin
// Define the video stream
WhatStreamToSelect:=1;
DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,VideoStreamNumber);
RefreshVideoSettings(MediaUserNum);
end;

procedure TAppForm.VideoBitrateComboBoxChange(Sender: TObject);
begin
// Define the video stream
WhatStreamToSelect:=1;
DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,VideoStreamNumber);

// Block manual typing of non-standard values in ComboBox
If (VideoBitrateComboBox.Text<>'1000') and
(VideoBitrateComboBox.Text<>'2000') and
(VideoBitrateComboBox.Text<>'3000') and
(VideoBitrateComboBox.Text<>'4000') and
(VideoBitrateComboBox.Text<>'5000') and
(VideoBitrateComboBox.Text<>'6000') and
(VideoBitrateComboBox.Text<>'7000') and
(VideoBitrateComboBox.Text<>'8000') and
(VideoBitrateComboBox.Text<>'9000') and
(VideoBitrateComboBox.Text<>'Custom') then
      begin
      VideoBitrateComboBox.ItemIndex:=8;
      end;
// Video Bitrate Changing
VideoBitrateSelectedIndex:=VideoBitrateComboBox.ItemIndex;
if VideoBitrateSelectedIndex<=8 then
      begin
      VideoStreamBitrate[MediaUserNum,CurrVideoStream[MediaUserNum]]:=
      inttostr(Round((VideoBitrateSelectedIndex+1)*1000));
      CustomVideoBitrateEdit.Text:='';
      CustomVideoBitrateEdit.Enabled:=False;
      CustomVideoBitrateEdit.Color:=clScrollBar;
      // Objects States
      CustomVideoBitrateEditObjectState[MediaUserNum,VideoStreamNumber]:=False;
      end
      else
      begin
      CustomVideoBitrateEdit.Enabled:=True;
      CustomVideoBitrateEdit.Color:=clWindow;
      // Objects States
      CustomVideoBitrateEditObjectState[MediaUserNum,VideoStreamNumber]:=True;

      end;

// Calculate Disk Space
CalculateDiskSpace;


end;

procedure TAppForm.CustomVideoBitrateEditChange(Sender: TObject);
var ClearBitrateTextValue,BitrateSymbol:string;
begin
ClearBitrateTextValue:='';
If (VideoBitrateComboBox.ItemIndex=9) and
(Length(CustomVideoBitrateEdit.Text)>0) then
      begin
      SwapText:=CustomVideoBitrateEdit.Text;
      // Clear Bitrate Text Value
      for i:=1 to Length(SwapText) do
            begin
            BitrateSymbol:=SwapText[i];
            if (BitrateSymbol='1') or
            (BitrateSymbol='2') or
            (BitrateSymbol='3') or
            (BitrateSymbol='4') or
            (BitrateSymbol='5') or
            (BitrateSymbol='6') or
            (BitrateSymbol='7') or
            (BitrateSymbol='8') or
            (BitrateSymbol='9') or
            (BitrateSymbol='0') then
            ClearBitrateTextValue:=ClearBitrateTextValue+BitrateSymbol;
            end;

      // Define the video stream
      WhatStreamToSelect:=1;
      DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,VideoStreamNumber);
      // Video Bitrate Changing
      VideoStreamBitrate[MediaUserNum,CurrVideoStream[MediaUserNum]]:=
      ClearBitrateTextValue;
      CustomVideoBitrateEdit.Text:=ClearBitrateTextValue;
      end;

// Calculate Disk Space
CalculateDiskSpace;

end;

procedure TAppForm.ChangeVideoFormatCheckBoxClick(Sender: TObject);
begin
// Define the video stream
WhatStreamToSelect:=1;
DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,VideoStreamNumber);
      if ChangeVideoFormatCheckBox.Checked=True then
            begin
            ChangeFormatChecked[MediaUserNum,VideoStreamNumber]:=True;
            VideoFormatComboBox.Enabled:=True;
            // Objects States
            ChangeVideoFormatCheckBoxObjectState[MediaUserNum,VideoStreamNumber]:=True;
            end
            else
            begin
            ChangeFormatChecked[MediaUserNum,VideoStreamNumber]:=False;
            VideoFormatComboBox.Enabled:=False;
            // Objects States
            ChangeVideoFormatCheckBoxObjectState[MediaUserNum,VideoStreamNumber]:=False;
            end;
end;

procedure TAppForm.VideoFormatComboBoxChange(Sender: TObject);
begin
// Define the video stream
WhatStreamToSelect:=1;
DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,VideoStreamNumber);
// Block manual typing of non-standard formats
If (VideoFormatComboBox.Text<>'NTSC Film') and
(VideoFormatComboBox.Text<>'NTSC') and
(VideoFormatComboBox.Text<>'PAL') then
VideoFormatComboBox.ItemIndex:=1;
// Change Video Format
VideoStreamFormat[MediaUserNum,VideoStreamNumber]:=VideoFormatComboBox.Text;
end;

procedure TAppForm.InterlacedFlagClick(Sender: TObject);
begin
// Define the video stream
WhatStreamToSelect:=1;
DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,VideoStreamNumber);
If InterlacedFlag.Checked=True then
Interlaced[MediaUserNum,VideoStreamNumber]:=True
else
Interlaced[MediaUserNum,VideoStreamNumber]:=False;
end;

procedure TAppForm.ChangeSourceAspectRatioCheckBoxClick(Sender: TObject);
begin
// Define the video stream
WhatStreamToSelect:=1;
DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,VideoStreamNumber);
If ChangeSourceAspectRatioCheckBox.Checked=True then
      begin
      ChangeSourceAspectRatioChecked[MediaUserNum,VideoStreamNumber]:=True;
      VideoSourceAspectRatioComboBox.Enabled:=True;
      // Objects States
      VideoSourceAspectRatioComboBoxObjectState[MediaUserNum,VideoStreamNumber]:=True;
      // For custom Source Aspect ratio
      if  VideoSourceAspectRatioComboBox.ItemIndex=4 then
            begin
            CustomVideoSourceAspectRatioEdit.Enabled:=True;
            CustomVideoSourceAspectRatioEdit.Color:=clWindow;
            // Objects States
            CustomVideoSourceAspectRatioEditObjectState[MediaUserNum,VideoStreamNumber]:=True;
            end;
      end
      else
      begin
      ChangeSourceAspectRatioChecked[MediaUserNum,VideoStreamNumber]:=False;
      VideoSourceAspectRatioComboBox.Enabled:=False;
      // Objects States
      VideoSourceAspectRatioComboBoxObjectState[MediaUserNum,VideoStreamNumber]:=False;
      // For custom Source Aspect ratio
      if  VideoSourceAspectRatioComboBox.ItemIndex=4 then
            begin
            CustomVideoSourceAspectRatioEdit.Enabled:=False;
            CustomVideoSourceAspectRatioEdit.Color:=clScrollBar;
            // Objects States
            CustomVideoSourceAspectRatioEditObjectState[MediaUserNum,VideoStreamNumber]:=False;
            end;
      end;
end;

procedure TAppForm.VideoSourceAspectRatioComboBoxChange(Sender: TObject);
begin
// Define the video stream
WhatStreamToSelect:=1;
DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,VideoStreamNumber);
// Block non-standard Aspect ratios from manual typing
If (VideoSourceAspectRatioComboBox.Text<>'4:3') and
(VideoSourceAspectRatioComboBox.Text<>'16:9') and
(VideoSourceAspectRatioComboBox.Text<>'1:1') and
(VideoSourceAspectRatioComboBox.Text<>'2.21:1') and
(VideoSourceAspectRatioComboBox.Text<>'Custom') then
VideoSourceAspectRatioComboBox.ItemIndex:=0;
// Change Video Source Aspect ratio
if (VideoSourceAspectRatioComboBox.ItemIndex<=3) then
      begin
      VideoStreamSourceAR[MediaUserNum,VideoStreamNumber]:=
      VideoSourceAspectRatioComboBox.Items.Strings[VideoSourceAspectRatioComboBox.ItemIndex];
      CustomVideoSourceAspectRatioEdit.Text:='';
      CustomVideoSourceAspectRatioEdit.Enabled:=False;
      CustomVideoSourceAspectRatioEdit.Color:=clScrollBar;
      // Objects States
      CustomVideoSourceAspectRatioEditObjectState[MediaUserNum,VideoStreamNumber]:=False;
      end
      else
      begin
      CustomVideoSourceAspectRatioEdit.Enabled:=True;
      CustomVideoSourceAspectRatioEdit.Color:=clWindow;
      // Objects States
      CustomVideoSourceAspectRatioEditObjectState[MediaUserNum,VideoStreamNumber]:=True;
      end;

end;

procedure TAppForm.CustomVideoSourceAspectRatioEditChange(Sender: TObject);
var
ClearSourceAspectRatioTextValue,SourceAspectRatioSymbol:string;
FirstPoint,FirstDoublePoint,SourceARSymbolUsed:boolean;
begin
// Define the video stream
WhatStreamToSelect:=1;
DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,VideoStreamNumber);
// Block non-useful symbols from Source Aspect ratio value
ClearSourceAspectRatioTextValue:='';
FirstPoint:=False;
FirstDoublePoint:=False;
SwapText:=CustomVideoSourceAspectRatioEdit.Text;
if Length(SwapText)>0 then
      begin
            for i:=1 to Length(SwapText) do
                  begin
                  SourceARSymbolUsed:=False;
                  SourceAspectRatioSymbol:=SwapText[i];
                  if (SourceAspectRatioSymbol='.') and
                  (FirstPoint=False) and
                  (i>1) then
                  begin
                  SourceARSymbolUsed:=True;
                  FirstPoint:=True;
                  ClearSourceAspectRatioTextValue:=ClearSourceAspectRatioTextValue+
                  SourceAspectRatioSymbol;
                  end;
                  if (SourceAspectRatioSymbol=':') and
                  (FirstDoublePoint=False) and
                  (i>1) then
                  begin
                  SourceARSymbolUsed:=True;
                  FirstDoublePoint:=True;
                  ClearSourceAspectRatioTextValue:=ClearSourceAspectRatioTextValue+
                  SourceAspectRatioSymbol;
                  end;
                  if (SourceAspectRatioSymbol='1') or
                  (SourceAspectRatioSymbol='2') or
                  (SourceAspectRatioSymbol='3') or
                  (SourceAspectRatioSymbol='4') or
                  (SourceAspectRatioSymbol='5') or
                  (SourceAspectRatioSymbol='6') or
                  (SourceAspectRatioSymbol='7') or
                  (SourceAspectRatioSymbol='8') or
                  (SourceAspectRatioSymbol='9') or
                  (SourceAspectRatioSymbol='0') then
                  begin
                  SourceARSymbolUsed:=True;
                  ClearSourceAspectRatioTextValue:=ClearSourceAspectRatioTextValue+
                  SourceAspectRatioSymbol;
                  end;
                  end;
      CustomVideoSourceAspectRatioEdit.Text:=
      ClearSourceAspectRatioTextValue;
      VideoStreamSourceAR[MediaUserNum,VideoStreamNumber]:=
      ClearSourceAspectRatioTextValue;
      end;
end;

procedure TAppForm.VideoTargetAspectRatioComboBoxChange(Sender: TObject);
begin
// Define the video stream
WhatStreamToSelect:=1;
DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,VideoStreamNumber);
// Block non-standard Aspect ratios from manual typing
If (VideoTargetAspectRatioComboBox.Text<>'4:3') and
(VideoTargetAspectRatioComboBox.Text<>'16:9') then
VideoTargetAspectRatioComboBox.ItemIndex:=0;
// Change Target Aspect ratio
VideoStreamTargetAR[MediaUserNum,VideoStreamNumber]:=
VideoTargetAspectRatioComboBox.Items.Strings[VideoTargetAspectRatioComboBox.ItemIndex];
end;

procedure TAppForm.TwoPassConversionCheckBoxClick(Sender: TObject);
var TwoPassConversionChanged:boolean;
begin
// Define the video stream
WhatStreamToSelect:=1;
DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,VideoStreamNumber);
TwoPassConversionChanged:=False;

if (TwoPassConversionCheckBox.Checked=True) and
(TwoPassConversionChanged=False) then
      begin
      TwoPassConversionChanged:=True;
      TwoPass[MediaUserNum,VideoStreamNumber]:=True;
      end;
if (TwoPassConversionCheckBox.Checked=False) and
(TwoPassConversionChanged=False) then
      begin
      TwoPassConversionChanged:=True;
      TwoPass[MediaUserNum,VideoStreamNumber]:=False;
      end;


end;

procedure TAppForm.HalfD1FrameSizeCheckBoxClick(Sender: TObject);
var HalfD1Changed:boolean;
begin
// Define the video stream
WhatStreamToSelect:=1;
DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,VideoStreamNumber);
HalfD1Changed:=False;

if (HalfD1FrameSizeCheckBox.Checked=True) and
(HalfD1Changed=False) then
      begin
      HalfD1Changed:=True;
      HalfD1[MediaUserNum,VideoStreamNumber]:=True;
      end;
if (HalfD1FrameSizeCheckBox.Checked=False) and
(HalfD1Changed=False) then
      begin
      HalfD1Changed:=True;
      HalfD1[MediaUserNum,VideoStreamNumber]:=False;
      end;


end;

procedure TAppForm.VideoCopyCheckBoxClick(Sender: TObject);
var VideoCopyChanged:boolean;
begin

if MediaListFilesQ>0 then
      begin
      // Define the video stream
      WhatStreamToSelect:=1;
      DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,VideoStreamNumber);
      VideoCopyChanged:=False;

      if (VideoCopyCheckBox.Checked=True) and
      (VideoCopyChanged=False) then
            begin
            VideoCopyChanged:=True;
            CopyVideoStream[MediaUserNum,VideoStreamNumber]:=True;
            DisableVideoSettings4Copy;
            end;
      if (VideoCopyCheckBox.Checked=False) and
      (VideoCopyChanged=False) then
            begin
            VideoCopyChanged:=True;
            CopyVideoStream[MediaUserNum,VideoStreamNumber]:=False;
            EnableVideoSettings4Copy(MediaUserNum,VideoStreamNumber);
            end;
      end;

// Calculate Disk Space
CalculateDiskSpace;
end;

procedure TAppForm.DisableVideoSettings4Copy();
begin
ChangeSourceAspectRatioCheckBox.Enabled:=False;
ChangeVideoFormatCheckBox.Enabled:=False;
CustomVideoBitrateEdit.Enabled:=False;
CustomVideoBitrateEdit.Color:=clScrollBar;
CustomVideoSourceAspectRatioEdit.Enabled:=False;
CustomVideoSourceAspectRatioEdit.Color:=clScrollBar;
InterlacedFlag.Enabled:=False;
HalfD1FrameSizeCheckBox.Enabled:=False;
TwoPassConversionCheckBox.Enabled:=False;
VideoBitrateComboBox.Enabled:=False;
VideoBitrateLabel.Enabled:=False;
VideoFormatComboBox.Enabled:=False;
VideoFormatLabel.Enabled:=False;
VideoSourceAspectRatio.Enabled:=False;
VideoSourceAspectRatioComboBox.Enabled:=False;
VideoTargetAspectRatioComboBox.Enabled:=False;
VideoTargetAspectRatioLabel.Enabled:=False;
end;

procedure TAppForm.EnableVideoSettings4Copy(InputMediaFile,InputVideoStreamNumber:Integer);
begin
// Bitrate
VideoBitrateLabel.Enabled:=True;
if VideoBitrateComboBoxObjectState[InputMediaFile,InputVideoStreamNumber]=True then
VideoBitrateComboBox.Enabled:=True
else
VideoBitrateComboBox.Enabled:=False;

if CustomVideoBitrateEditObjectState[InputMediaFile,InputVideoStreamNumber]=True then
begin
CustomVideoBitrateEdit.Enabled:=True;
CustomVideoBitrateEdit.Color:=clWindow;
end
else
begin
CustomVideoBitrateEdit.Enabled:=False;
CustomVideoBitrateEdit.Color:=clScrollBar;
end;

// Format
VideoFormatLabel.Enabled:=True;
if VideoFormatComboBoxObjectState[InputMediaFile,InputVideoStreamNumber]=True then
VideoFormatComboBox.Enabled:=True
else
VideoFormatComboBox.Enabled:=False;

// Change Format
ChangeVideoFormatCheckBox.Enabled:=True;

if ChangeVideoFormatCheckBoxObjectState[InputMediaFile,InputVideoStreamNumber]=True then
VideoFormatComboBox.Enabled:=True
else
VideoFormatComboBox.Enabled:=False;


// Interlaced
if InterlacedFlagObjectState[InputMediaFile,InputVideoStreamNumber]=True then
InterlacedFlag.Enabled:=True
else
InterlacedFlag.Enabled:=False;

// Source Aspect Ratio
VideoSourceAspectRatio.Enabled:=True;
if VideoSourceAspectRatioComboBoxObjectState[InputMediaFile,InputVideoStreamNumber]=True then
VideoSourceAspectRatioComboBox.Enabled:=True
else
VideoSourceAspectRatioComboBox.Enabled:=False;

if CustomVideoSourceAspectRatioEditObjectState[InputMediaFile,InputVideoStreamNumber]=True then
begin
CustomVideoSourceAspectRatioEdit.Enabled:=True;
CustomVideoSourceAspectRatioEdit.Color:=clWindow;
end
else
begin
CustomVideoSourceAspectRatioEdit.Enabled:=False;
CustomVideoSourceAspectRatioEdit.Color:=clScrollBar;
end;

// Change Source Aspect Ratio
ChangeSourceAspectRatioCheckBox.Enabled:=True;

// Video Target Aspect Ratio
VideoTargetAspectRatioLabel.Enabled:=True;
VideoTargetAspectRatioComboBox.Enabled:=True;

// 2-pass
TwoPassConversionCheckBox.Enabled:=True;

// Half-D1
HalfD1FrameSizeCheckBox.Enabled:=True;


end;

procedure TAppForm.DisableVideoSettings4RemoveFromMediaList();
begin

ChangeSourceAspectRatioCheckBox.Enabled:=False;
ChangeVideoFormatCheckBox.Enabled:=False;
CustomVideoBitrateEdit.Enabled:=False;
CustomVideoBitrateEdit.Color:=clScrollBar;
CustomVideoSourceAspectRatioEdit.Enabled:=False;
CustomVideoSourceAspectRatioEdit.Color:=clScrollBar;
InterlacedFlag.Enabled:=False;
HalfD1FrameSizeCheckBox.Enabled:=False;
TwoPassConversionCheckBox.Enabled:=False;
VideoBitrateComboBox.Enabled:=False;
VideoBitrateLabel.Enabled:=False;
VideoCopyCheckBox.Enabled:=False;
VideoFormatComboBox.Enabled:=False;
VideoFormatLabel.Enabled:=False;
VideoSourceAspectRatio.Enabled:=False;
VideoSourceAspectRatioComboBox.Enabled:=False;
VideoTargetAspectRatioComboBox.Enabled:=False;
VideoTargetAspectRatioLabel.Enabled:=False;

end;


procedure TAppForm.DisableAudioSettings4RemoveFromMediaList();
begin
AC3AudioFormatCheckBox.Enabled:=False;
AudioBitrate128CheckBox.Enabled:=False;
AudioBitrate160CheckBox.Enabled:=False;
AudioBitrate192CheckBox.Enabled:=False;
AudioBitrate224CheckBox.Enabled:=False;
AudioBitrate256CheckBox.Enabled:=False;
AudioBitrate320CheckBox.Enabled:=False;
AudioBitrate384CheckBox.Enabled:=False;
AudioBitrate448CheckBox.Enabled:=False;
AudioBitrateLabel.Enabled:=False;
AudioChannels1CheckBox.Enabled:=False;
AudioChannels2CheckBox.Enabled:=False;
AudioChannels6CheckBox.Enabled:=False;
AudioChannelsLabel.Enabled:=False;
AudioCopyCheckBox.Enabled:=False;
AudioFormatLabel.Enabled:=False;
WAVAudioFormatCheckBox.Enabled:=False;

end;

procedure TAppForm.UncheckAllAudioChannels();
begin
AudioChannels1CheckBox.Checked:=False;
AudioChannels2CheckBox.Checked:=False;
AudioChannels6CheckBox.Checked:=False;
end;

procedure TAppForm.AC3AudioFormatCheckBoxClick(Sender: TObject);
var AC3CheckBoxChanged:Boolean;
begin
AC3CheckBoxChanged:=False;
// Define the audio stream
WhatStreamToSelect:=2;
DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,AudioStreamNumber);

if  (ActiveAudioFormatProcedure<>'RefreshAudioSettings+AC3FormatTrue') then
          begin
          // Change to WAV Format If possible - Uncheck AC3 CheckBox
          if  (WAVFormatEnabled[MediaUserNum,AudioStreamNumber]=True) and
              (AC3AudioFormatCheckBox.Checked=False) and
              (AC3CheckBoxChanged=False) then
                    begin
                    AC3CheckBoxChanged:=True;
                    AC3Format[MediaUserNum,AudioStreamNumber]:=False;
                    WAVFormat[MediaUserNum,AudioStreamNumber]:=True;
                    ActiveAudioFormatProcedure:='AC3AudioFormatCheckBoxClick+ChangeToWAVFormat';
                    WAVAudioFormatCheckBox.Checked:=True;
                    // Disable Audio Bitrate CheckBoxes
                    DisableAudioBitrateSettings;
                    end;
          // Change from WAV Format If possible - Check AC3 CheckBox
          if  (WAVFormatEnabled[MediaUserNum,AudioStreamNumber]=True) and
              (AC3AudioFormatCheckBox.Checked=True) and
              (AC3CheckBoxChanged=False) then
                    begin
                    AC3CheckBoxChanged:=True;
                    AC3Format[MediaUserNum,AudioStreamNumber]:=True;
                    WAVFormat[MediaUserNum,AudioStreamNumber]:=False;
                    ActiveAudioFormatProcedure:='AC3AudioFormatCheckBoxClick+ChangeFromWAVFormat';
                    WAVAudioFormatCheckBox.Checked:=False;
                    // Enable Audio Bitrate CheckBoxes
                    EnableAudioBitrateSettings;
                    // Disable CheckBoxes for 6-channels audio
                          if  (AudioStreamChannels[MediaUserNum,AudioStreamNumber]='5:1') or
                              (AudioStreamChannels[MediaUserNum,AudioStreamNumber]='5 channels') or
                              (AudioStreamChannels[MediaUserNum,AudioStreamNumber]='6 channels') then
                                    begin
                                    AudioBitrate128CheckBox.Enabled:=False;
                                    AudioBitrate160CheckBox.Enabled:=False;
                                    AudioBitrate192CheckBox.Enabled:=False;
                                    AudioBitrate224CheckBox.Enabled:=False;
                                    AudioBitrate256CheckBox.Enabled:=False;
                                    AudioBitrate320CheckBox.Enabled:=False;
                                    end;                    
                    end;



          end;


// Change ActiveAudioFormatProcedure
ActiveAudioFormatProcedure:='AC3AudioFormatCheckBoxClick';

// Calculate Disk Space
CalculateDiskSpace;
end;

procedure TAppForm.WAVAudioFormatCheckBoxClick(Sender: TObject);
var WAVCheckBoxChanged:Boolean;
begin
WAVCheckBoxChanged:=False;
// Define the audio stream
WhatStreamToSelect:=2;
DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,AudioStreamNumber);

// Change to AC3 Format - Uncheck WAV CheckBox
If  (WAVAudioFormatCheckBox.Checked=False) and
    (WAVCheckBoxChanged=False) then
                    begin
                    WAVCheckBoxChanged:=True;
                    AC3Format[MediaUserNum,AudioStreamNumber]:=True;
                    WAVFormat[MediaUserNum,AudioStreamNumber]:=False;
                    ActiveAudioFormatProcedure:='WAVAudioFormatCheckBoxClick+ChangeToAC3Format';
                    AC3AudioFormatCheckBox.Checked:=True;
                    // Enable Audio Bitrate CheckBoxes
                    EnableAudioBitrateSettings;
                    // Disable CheckBoxes for 6-channels audio
                          if  (AudioStreamChannels[MediaUserNum,AudioStreamNumber]='5:1') or
                              (AudioStreamChannels[MediaUserNum,AudioStreamNumber]='5 channels') or
                              (AudioStreamChannels[MediaUserNum,AudioStreamNumber]='6 channels') then
                                    begin
                                    AudioBitrate128CheckBox.Enabled:=False;
                                    AudioBitrate160CheckBox.Enabled:=False;
                                    AudioBitrate192CheckBox.Enabled:=False;
                                    AudioBitrate224CheckBox.Enabled:=False;
                                    AudioBitrate256CheckBox.Enabled:=False;
                                    AudioBitrate320CheckBox.Enabled:=False;
                                    end;
                    end;
          // Change from AC3 Format If possible - Check WAV CheckBox
          if  (WAVFormatEnabled[MediaUserNum,AudioStreamNumber]=True) and
              (WAVAudioFormatCheckBox.Checked=True) and
              (WAVCheckBoxChanged=False) then
                    begin
                    WAVCheckBoxChanged:=True;
                    AC3Format[MediaUserNum,AudioStreamNumber]:=False;
                    WAVFormat[MediaUserNum,AudioStreamNumber]:=True;
                    ActiveAudioFormatProcedure:='WAVAudioFormatCheckBoxClick+ChangeFromAC3Format';
                    AC3AudioFormatCheckBox.Checked:=False;
                    // Disable Audio Bitrate CheckBoxes
                    DisableAudioBitrateSettings;
                    end;

// Change ActiveAudioFormatProcedure
ActiveAudioFormatProcedure:='WAVAudioFormatCheckBoxClick';

// Calculate Disk Space
CalculateDiskSpace;

end;

procedure TAppForm.DisableAudioBitrateSettings();
begin
AudioBitrateLabel.Enabled:=False;
AudioBitrate128CheckBox.Enabled:=False;
AudioBitrate160CheckBox.Enabled:=False;
AudioBitrate192CheckBox.Enabled:=False;
AudioBitrate224CheckBox.Enabled:=False;
AudioBitrate256CheckBox.Enabled:=False;
AudioBitrate320CheckBox.Enabled:=False;
AudioBitrate384CheckBox.Enabled:=False;
AudioBitrate448CheckBox.Enabled:=False;
end;

procedure TAppForm.EnableAudioBitrateSettings();
begin
AudioBitrateLabel.Enabled:=True;
AudioBitrate128CheckBox.Enabled:=True;
AudioBitrate160CheckBox.Enabled:=True;
AudioBitrate192CheckBox.Enabled:=True;
AudioBitrate224CheckBox.Enabled:=True;
AudioBitrate256CheckBox.Enabled:=True;
AudioBitrate320CheckBox.Enabled:=True;
AudioBitrate384CheckBox.Enabled:=True;
AudioBitrate448CheckBox.Enabled:=True;
end;

procedure TAppForm.UncheckAudioBitrate();
begin
ActiveAudioBitrateProcedure:='UncheckAudioBitrate';
AudioBitrate128CheckBox.Checked:=False;
AudioBitrate160CheckBox.Checked:=False;
AudioBitrate192CheckBox.Checked:=False;
AudioBitrate224CheckBox.Checked:=False;
AudioBitrate256CheckBox.Checked:=False;
AudioBitrate320CheckBox.Checked:=False;
AudioBitrate384CheckBox.Checked:=False;
AudioBitrate448CheckBox.Checked:=False;
end;


procedure TAppForm.AudioBitrate128CheckBoxClick(Sender: TObject);
var AudioBitrate128CheckBoxChanged:Boolean;
begin
AudioBitrate128CheckBoxChanged:=False;
// Define the audio stream
WhatStreamToSelect:=2;
DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,AudioStreamNumber);

// Uncheck operations
if  (ActiveAudioBitrateProcedure='UncheckAudioBitrate') and
    (AudioBitrate128CheckBoxChanged=False) then
          begin
          AudioBitrate128CheckBoxChanged:=True;
          end;

// Change to 128k from any other bitrate
if  (AudioBitrate128CheckBox.Checked=True) and
    (AudioBitrate128CheckBoxChanged=False) and
    (AudioStreamBitrate[MediaUserNum,AudioStreamNumber]<>'128k') then
          begin
          AudioBitrate128CheckBoxChanged:=True;
          UncheckAudioBitrate;
          ActiveAudioBitrateProcedure:='AudioBitrateChanged128k';
          AudioStreamBitrate[MediaUserNum,AudioStreamNumber]:='128k';
          AudioBitrate128CheckBox.Checked:=True;
          end;
// Recheck to 128k if this bitrate
if  (AudioBitrate128CheckBox.Checked=False) and
    (AudioBitrate128CheckBoxChanged=False) and
    (AudioStreamBitrate[MediaUserNum,AudioStreamNumber]='128k') then
          begin
          ActiveAudioBitrateProcedure:='RecheckBitrate128k';
          AudioBitrate128CheckBoxChanged:=True;
          AudioStreamBitrate[MediaUserNum,AudioStreamNumber]:='128k';
          AudioBitrate128CheckBox.Checked:=True;
          end;

// Calculate Disk Space
CalculateDiskSpace;

end;

procedure TAppForm.AudioBitrate160CheckBoxClick(Sender: TObject);
var AudioBitrate160CheckBoxChanged:Boolean;
begin
AudioBitrate160CheckBoxChanged:=False;
// Define the audio stream
WhatStreamToSelect:=2;
DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,AudioStreamNumber);

// Uncheck operations
if  (ActiveAudioBitrateProcedure='UncheckAudioBitrate') and
    (AudioBitrate160CheckBoxChanged=False) then
          begin
          AudioBitrate160CheckBoxChanged:=True;
          end;

// Change to 160k from any other bitrate
if  (AudioBitrate160CheckBox.Checked=True) and
    (AudioBitrate160CheckBoxChanged=False) and
    (AudioStreamBitrate[MediaUserNum,AudioStreamNumber]<>'160k') then
          begin
          AudioBitrate160CheckBoxChanged:=True;
          UncheckAudioBitrate;
          ActiveAudioBitrateProcedure:='AudioBitrateChanged160k';
          AudioStreamBitrate[MediaUserNum,AudioStreamNumber]:='160k';
          AudioBitrate160CheckBox.Checked:=True;
          end;
// Recheck to 160k if this bitrate
if  (AudioBitrate160CheckBox.Checked=False) and
    (AudioBitrate160CheckBoxChanged=False) and
    (AudioStreamBitrate[MediaUserNum,AudioStreamNumber]='160k') then
          begin
          ActiveAudioBitrateProcedure:='RecheckBitrate160k';
          AudioBitrate160CheckBoxChanged:=True;
          AudioStreamBitrate[MediaUserNum,AudioStreamNumber]:='160k';
          AudioBitrate160CheckBox.Checked:=True;
          end;

// Calculate Disk Space
CalculateDiskSpace;

end;

procedure TAppForm.AudioBitrate192CheckBoxClick(Sender: TObject);
var AudioBitrate192CheckBoxChanged:Boolean;
begin
AudioBitrate192CheckBoxChanged:=False;
// Define the audio stream
WhatStreamToSelect:=2;
DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,AudioStreamNumber);

// Uncheck operations
if  (ActiveAudioBitrateProcedure='UncheckAudioBitrate') and
    (AudioBitrate192CheckBoxChanged=False) then
          begin
          AudioBitrate192CheckBoxChanged:=True;
          end;

// Change to 192k from any other bitrate
if  (AudioBitrate192CheckBox.Checked=True) and
    (AudioBitrate192CheckBoxChanged=False) and
    (AudioStreamBitrate[MediaUserNum,AudioStreamNumber]<>'192k') then
          begin
          AudioBitrate192CheckBoxChanged:=True;
          UncheckAudioBitrate;
          ActiveAudioBitrateProcedure:='AudioBitrateChanged192k';
          AudioStreamBitrate[MediaUserNum,AudioStreamNumber]:='192k';
          AudioBitrate192CheckBox.Checked:=True;
          end;
// Recheck to 192k if this bitrate
if  (AudioBitrate192CheckBox.Checked=False) and
    (AudioBitrate192CheckBoxChanged=False) and
    (AudioStreamBitrate[MediaUserNum,AudioStreamNumber]='192k') then
          begin
          ActiveAudioBitrateProcedure:='RecheckBitrate192k';
          AudioBitrate192CheckBoxChanged:=True;
          AudioStreamBitrate[MediaUserNum,AudioStreamNumber]:='192k';
          AudioBitrate192CheckBox.Checked:=True;
          end;

// Calculate Disk Space
CalculateDiskSpace;

end;

procedure TAppForm.AudioBitrate224CheckBoxClick(Sender: TObject);
var AudioBitrate224CheckBoxChanged:Boolean;
begin
AudioBitrate224CheckBoxChanged:=False;
// Define the audio stream
WhatStreamToSelect:=2;
DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,AudioStreamNumber);

// Uncheck operations
if  (ActiveAudioBitrateProcedure='UncheckAudioBitrate') and
    (AudioBitrate224CheckBoxChanged=False) then
          begin
          AudioBitrate224CheckBoxChanged:=True;
          end;

// Change to 224k from any other bitrate
if  (AudioBitrate224CheckBox.Checked=True) and
    (AudioBitrate224CheckBoxChanged=False) and
    (AudioStreamBitrate[MediaUserNum,AudioStreamNumber]<>'224k') then
          begin
          AudioBitrate224CheckBoxChanged:=True;
          UncheckAudioBitrate;
          ActiveAudioBitrateProcedure:='AudioBitrateChanged224k';
          AudioStreamBitrate[MediaUserNum,AudioStreamNumber]:='224k';
          AudioBitrate224CheckBox.Checked:=True;
          end;
// Recheck to 224k if this bitrate
if  (AudioBitrate224CheckBox.Checked=False) and
    (AudioBitrate224CheckBoxChanged=False) and
    (AudioStreamBitrate[MediaUserNum,AudioStreamNumber]='224k') then
          begin
          ActiveAudioBitrateProcedure:='RecheckBitrate224k';
          AudioBitrate224CheckBoxChanged:=True;
          AudioStreamBitrate[MediaUserNum,AudioStreamNumber]:='224k';
          AudioBitrate224CheckBox.Checked:=True;
          end;

// Calculate Disk Space
CalculateDiskSpace;

end;

procedure TAppForm.AudioBitrate256CheckBoxClick(Sender: TObject);
var AudioBitrate256CheckBoxChanged:Boolean;
begin
AudioBitrate256CheckBoxChanged:=False;
// Define the audio stream
WhatStreamToSelect:=2;
DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,AudioStreamNumber);

// Uncheck operations
if  (ActiveAudioBitrateProcedure='UncheckAudioBitrate') and
    (AudioBitrate256CheckBoxChanged=False) then
          begin
          AudioBitrate256CheckBoxChanged:=True;
          end;

// Change to 256k from any other bitrate
if  (AudioBitrate256CheckBox.Checked=True) and
    (AudioBitrate256CheckBoxChanged=False) and
    (AudioStreamBitrate[MediaUserNum,AudioStreamNumber]<>'256k') then
          begin
          AudioBitrate256CheckBoxChanged:=True;
          UncheckAudioBitrate;
          ActiveAudioBitrateProcedure:='AudioBitrateChanged256k';
          AudioStreamBitrate[MediaUserNum,AudioStreamNumber]:='256k';
          AudioBitrate256CheckBox.Checked:=True;
          end;
// Recheck to 256k if this bitrate
if  (AudioBitrate256CheckBox.Checked=False) and
    (AudioBitrate256CheckBoxChanged=False) and
    (AudioStreamBitrate[MediaUserNum,AudioStreamNumber]='256k') then
          begin
          ActiveAudioBitrateProcedure:='RecheckBitrate256k';
          AudioBitrate256CheckBoxChanged:=True;
          AudioStreamBitrate[MediaUserNum,AudioStreamNumber]:='256k';
          AudioBitrate256CheckBox.Checked:=True;
          end;

// Calculate Disk Space
CalculateDiskSpace;

end;

procedure TAppForm.AudioBitrate320CheckBoxClick(Sender: TObject);
var AudioBitrate320CheckBoxChanged:Boolean;
begin
AudioBitrate320CheckBoxChanged:=False;
// Define the audio stream
WhatStreamToSelect:=2;
DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,AudioStreamNumber);

// Uncheck operations
if  (ActiveAudioBitrateProcedure='UncheckAudioBitrate') and
    (AudioBitrate320CheckBoxChanged=False) then
          begin
          AudioBitrate320CheckBoxChanged:=True;
          end;

// Change to 320k from any other bitrate
if  (AudioBitrate320CheckBox.Checked=True) and
    (AudioBitrate320CheckBoxChanged=False) and
    (AudioStreamBitrate[MediaUserNum,AudioStreamNumber]<>'320k') then
          begin
          AudioBitrate320CheckBoxChanged:=True;
          UncheckAudioBitrate;
          ActiveAudioBitrateProcedure:='AudioBitrateChanged320k';
          AudioStreamBitrate[MediaUserNum,AudioStreamNumber]:='320k';
          AudioBitrate320CheckBox.Checked:=True;
          end;
// Recheck to 320k if this bitrate
if  (AudioBitrate320CheckBox.Checked=False) and
    (AudioBitrate320CheckBoxChanged=False) and
    (AudioStreamBitrate[MediaUserNum,AudioStreamNumber]='320k') then
          begin
          ActiveAudioBitrateProcedure:='RecheckBitrate320k';
          AudioBitrate320CheckBoxChanged:=True;
          AudioStreamBitrate[MediaUserNum,AudioStreamNumber]:='320k';
          AudioBitrate320CheckBox.Checked:=True;
          end;

// Calculate Disk Space
CalculateDiskSpace;

end;

procedure TAppForm.AudioBitrate384CheckBoxClick(Sender: TObject);
var AudioBitrate384CheckBoxChanged:Boolean;
begin
AudioBitrate384CheckBoxChanged:=False;
// Define the audio stream
WhatStreamToSelect:=2;
DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,AudioStreamNumber);

// Uncheck operations
if  (ActiveAudioBitrateProcedure='UncheckAudioBitrate') and
    (AudioBitrate384CheckBoxChanged=False) then
          begin
          AudioBitrate384CheckBoxChanged:=True;
          end;

// Change to 384k from any other bitrate
if  (AudioBitrate384CheckBox.Checked=True) and
    (AudioBitrate384CheckBoxChanged=False) and
    (AudioStreamBitrate[MediaUserNum,AudioStreamNumber]<>'384k') then
          begin
          AudioBitrate384CheckBoxChanged:=True;
          UncheckAudioBitrate;
          ActiveAudioBitrateProcedure:='AudioBitrateChanged384k';
          AudioStreamBitrate[MediaUserNum,AudioStreamNumber]:='384k';
          AudioBitrate384CheckBox.Checked:=True;
          end;
// Recheck to 384k if this bitrate
if  (AudioBitrate384CheckBox.Checked=False) and
    (AudioBitrate384CheckBoxChanged=False) and
    (AudioStreamBitrate[MediaUserNum,AudioStreamNumber]='384k') then
          begin
          ActiveAudioBitrateProcedure:='RecheckBitrate384k';
          AudioBitrate384CheckBoxChanged:=True;
          AudioStreamBitrate[MediaUserNum,AudioStreamNumber]:='384k';
          AudioBitrate384CheckBox.Checked:=True;
          end;

// Calculate Disk Space
CalculateDiskSpace;

end;

procedure TAppForm.AudioBitrate448CheckBoxClick(Sender: TObject);
var AudioBitrate448CheckBoxChanged:Boolean;
begin
AudioBitrate448CheckBoxChanged:=False;
// Define the audio stream
WhatStreamToSelect:=2;
DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,AudioStreamNumber);

// Uncheck operations
if  (ActiveAudioBitrateProcedure='UncheckAudioBitrate') and
    (AudioBitrate448CheckBoxChanged=False) then
          begin
          AudioBitrate448CheckBoxChanged:=True;
          end;

// Change to 448k from any other bitrate
if  (AudioBitrate448CheckBox.Checked=True) and
    (AudioBitrate448CheckBoxChanged=False) and
    (AudioStreamBitrate[MediaUserNum,AudioStreamNumber]<>'448k') then
          begin
          AudioBitrate448CheckBoxChanged:=True;
          UncheckAudioBitrate;
          ActiveAudioBitrateProcedure:='AudioBitrateChanged448k';
          AudioStreamBitrate[MediaUserNum,AudioStreamNumber]:='448k';
          AudioBitrate448CheckBox.Checked:=True;
          end;
// Recheck to 448k if this bitrate
if  (AudioBitrate448CheckBox.Checked=False) and
    (AudioBitrate448CheckBoxChanged=False) and
    (AudioStreamBitrate[MediaUserNum,AudioStreamNumber]='448k') then
          begin
          ActiveAudioBitrateProcedure:='RecheckBitrate448k';
          AudioBitrate448CheckBoxChanged:=True;
          AudioStreamBitrate[MediaUserNum,AudioStreamNumber]:='448k';
          AudioBitrate448CheckBox.Checked:=True;
          end;

// Calculate Disk Space
CalculateDiskSpace;

end;

procedure TAppForm.AudioCopyCheckBoxClick(Sender: TObject);
var AudioCopyChanged:boolean;
begin

if MediaListFilesQ>0 then
      begin
      // Define the audio stream
      WhatStreamToSelect:=2;
      DefineCurrentVideoOrAudioStream(WhatStreamToSelect,MediaUserNum,AudioStreamNumber);
      AudioCopyChanged:=False;

      if (AudioCopyCheckBox.Checked=True) and
      (AudioCopyChanged=False) then
            begin
            AudioCopyChanged:=True;
            CopyAudioStream[MediaUserNum,AudioStreamNumber]:=True;
            DisableAudioSettings4Copy;
            end;
      if (AudioCopyCheckBox.Checked=False) and
      (AudioCopyChanged=False) then
            begin
            AudioCopyChanged:=True;
            CopyAudioStream[MediaUserNum,AudioStreamNumber]:=False;
            EnableAudioSettings4Copy(MediaUserNum,AudioStreamNumber);
            end;
      end;


// Calculate Disk Space
CalculateDiskSpace;
end;

procedure TAppForm.DisableAudioSettings4Copy();
begin
// Audio Format
AudioFormatLabel.Enabled:=False;
AC3AudioFormatCheckBox.Enabled:=False;
WAVAudioFormatCheckBox.Enabled:=False;
// Audio bitrate
DisableAudioBitrateSettings;
// Audio Channels
AudioChannelsLabel.Enabled:=False;
end;

procedure TAppForm.EnableAudioSettings4Copy(InputMediaFile,InputAudioStreamNumber:Integer);
begin
// Audio Format Label
AudioFormatLabel.Enabled:=True;

// AC3 Format
AC3AudioFormatCheckBox.Enabled:=True;

// Enable Audio Bitrate Settings
EnableAudioBitrateSettings;

// WAV Format
if WAVFormat[InputMediaFile,InputAudioStreamNumber]=True then
DisableAudioBitrateSettings;

// WAV Format Enabled
If WAVFormatEnabled[InputMediaFile,InputAudioStreamNumber]=True then
WAVAudioFormatCheckBox.Enabled:=True
else
WAVAudioFormatCheckBox.Enabled:=False;

// Channels
AudioChannelsLabel.Enabled:=True;


if (AudioStreamChannels[InputMediaFile,InputAudioStreamNumber]='5:1') or
(AudioStreamChannels[InputMediaFile,InputAudioStreamNumber]='5 channels') or
(AudioStreamChannels[InputMediaFile,InputAudioStreamNumber]='6 channels') then
      begin
      // Disable CheckBoxes for 6-channels audio
      AudioBitrate128CheckBox.Enabled:=False;
      AudioBitrate160CheckBox.Enabled:=False;
      AudioBitrate192CheckBox.Enabled:=False;
      AudioBitrate224CheckBox.Enabled:=False;
      AudioBitrate256CheckBox.Enabled:=False;
      AudioBitrate320CheckBox.Enabled:=False;
      // Disable AC3 CheckBox
      AC3AudioFormatCheckBox.Enabled:=False;
      end;

// Disable Audio Channels CheckBoxes
AudioChannels1CheckBox.Enabled:=False;
AudioChannels2CheckBox.Enabled:=False;
AudioChannels6CheckBox.Enabled:=False;

end;

procedure TAppForm.CalculateDiskSpace();
var
SummaryAudioBitrate,SummaryVideoBitrate,DVDSizePercent,DiskDrivePercent:Integer;
FreeDriveSpaceString,DiskSpaceBytesText:string;
begin
DiskSpaceBytes:=0;
AudioSpaceSegment:=0;
VideoSpaceSegment:=0;
if MediaListFilesQ>0 then
      begin
            for i:=1 to MediaListFilesQ do
                  begin
                  MediaUserNum4DiskSpace:=RealPosition[i];
                  MediaFileName4DiskSpace:=VideoAudioFilesListBox.Items[i-1];
                  FindFirst(MediaFileName4DiskSpace,faAnyFile,DiskSpaceTS);
                  MediaFileSize4DiskSpace:=DiskSpaceTS.FindData.nFileSizeHigh*4294967296+DiskSpaceTS.FindData.nFileSizeLow;
                  FindClose(DiskSpaceTS);

                  // Audio Streams
                  SummaryAudioBitrate:=0;
                  if AudioStreamCount[MediaUserNum4DiskSpace]>0 then
                        begin
                              for j:=1 to AudioStreamCount[MediaUserNum4DiskSpace] do
                                    begin
                                    SummaryAudioBitrate:=
                                    SummaryAudioBitrate+
                                    AudioStreamInputBitrate[MediaUserNum4DiskSpace,j];
                                    if AudioStreamChecked[MediaUserNum4DiskSpace,j]=True then
                                          begin
                                          if CopyAudioStream[MediaUserNum4DiskSpace,j]=True then
                                                begin
                                                // Copy Audio Stream
                                                AudioSpaceFromTime:=
                                                Round(Abs(AudioStreamInputBitrate[MediaUserNum4DiskSpace,j]*0.125*
                                                MediaFileDuration[MediaUserNum4DiskSpace]));
                                                AudioSpaceSegment:=AudioSpaceSegment+AudioSpaceFromTime;
                                                end
                                                else
                                                begin
                                                // Use Conversion Settings
                                                // WAV Audio Mono
                                                if  (WAVFormat[MediaUserNum4DiskSpace,j]=True) and
                                                    (AudioStreamChannels[MediaUserNum4DiskSpace,j]='mono') then
                                                          begin
                                                          AudioSpaceFromTime:=
                                                          Round(Abs(768*0.125*MediaFileDuration[MediaUserNum4DiskSpace]));
                                                          AudioSpaceSegment:=AudioSpaceSegment+AudioSpaceFromTime;
                                                          end;
                                                // WAV Audio Stereo
                                                if  (WAVFormat[MediaUserNum4DiskSpace,j]=True) and
                                                    (AudioStreamChannels[MediaUserNum4DiskSpace,j]='stereo') then
                                                          begin
                                                          AudioSpaceFromTime:=
                                                          Round(Abs(1536*0.125*MediaFileDuration[MediaUserNum4DiskSpace]));
                                                          AudioSpaceSegment:=AudioSpaceSegment+AudioSpaceFromTime;
                                                          end;
                                                // AC3 Audio
                                                if AC3Format[MediaUserNum4DiskSpace,j]=True then
                                                      begin
                                                      SwapText:=Copy(AudioStreamBitrate[MediaUserNum4DiskSpace,j],1,
                                                      Pos('k',AudioStreamBitrate[MediaUserNum4DiskSpace,j])-1);
                                                      val(SwapText,AudioStreamBitrateValue,AudioStreamBitrateValueErrCode);
                                                      AudioSpaceFromTime:=
                                                      Round(Abs(AudioStreamBitrateValue*0.125*MediaFileDuration[MediaUserNum4DiskSpace]));
                                                      AudioSpaceSegment:=AudioSpaceSegment+AudioSpaceFromTime;
                                                      end;
                                                end;


                                          end;
                                    end;


                        end;



                  // Video Streams
                  SummaryVideoBitrate:=0;
                  if VideoStreamCount[MediaUserNum4DiskSpace]>0 then
                        begin
                              for j:=1 to VideoStreamCount[MediaUserNum4DiskSpace] do
                                    begin
                                    If VideoStreamChecked[MediaUserNum4DiskSpace,j]=True then
                                          begin
                                          if CopyVideoStream[MediaUserNum4DiskSpace,j]=True then
                                                begin
                                                // Copy Video Stream
                                                SummaryVideoBitrate:=Round(
                                                (MediaFileSize4DiskSpace*8/
                                                MediaFileDuration[MediaUserNum4DiskSpace])-
                                                SummaryAudioBitrate);
                                                VideoSpaceFromTime:=
                                                Round(Abs(SummaryVideoBitrate*0.125*MediaFileDuration[MediaUserNum4DiskSpace]));
                                                VideoSpaceSegment:=VideoSpaceSegment+VideoSpaceFromTime;
                                                end
                                                else
                                                begin
                                                // Use Conversion Settings
                                                SwapText:=VideoStreamBitrate[MediaUserNum4DiskSpace,j];
                                                val(SwapText,VideoStreamBitrateValue,VideoStreamBitrateValueErrCode);
                                                VideoSpaceFromTime:=Round(Abs(VideoStreamBitrateValue*0.125*MediaFileDuration[MediaUserNum4DiskSpace]));
                                                VideoSpaceSegment:=VideoSpaceSegment+VideoSpaceFromTime;
                                                end;

                                          end;
                                    end;


                        end;







                  end;
      DiskSpaceBytes:=AudioSpaceSegment+VideoSpaceSegment;

      // Change DVD Size Progress Bar
      If DVDSizeComboBox.ItemIndex=0 then
            begin
            DVDSizePercent:=Round(100*DiskSpaceBytes/4300000000);
            if DVDSizePercent>100 then
                  begin
                  // DVDProgressBar.Brush.Color:=clRed;
                  DVDProgressBar.Position:=100;
                  DVDSizeLabel.Caption:=inttostr(DVDSizePercent)+' %';
                  end
                  else
                  begin
                  // DVDProgressBar.Brush.Color:=clBlue;
                  DVDProgressBar.Position:=DVDSizePercent;
                  DVDSizeLabel.Caption:=inttostr(DVDSizePercent)+' %';
                  end;

            end;
      If DVDSizeComboBox.ItemIndex=1 then
            begin
            DVDSizePercent:=Round(100*DiskSpaceBytes/8103000000);
            if DVDSizePercent>100 then
                  begin
                  // DVDProgressBar.Brush.Color:=clRed;
                  DVDProgressBar.Position:=100;
                  DVDSizeLabel.Caption:=inttostr(DVDSizePercent)+' %';
                  end
                  else
                  begin
                  // DVDProgressBar.Brush.Color:=clBlue;
                  DVDProgressBar.Position:=DVDSizePercent;
                  DVDSizeLabel.Caption:=inttostr(DVDSizePercent)+' %';
                  end;
            end;

      end
      else
      begin
      // No files in list
      DiskSpaceBytes:=0;
      DVDSizePercent:=0;
      DVDProgressBar.Position:=DVDSizePercent;
      DVDSizeLabel.Caption:=inttostr(DVDSizePercent)+' %';
      end;

// Define Free Space on Hard Drive
If CurrentDriveCode<>255 then
      begin
      FreeDriveSpace:=DiskFree(CurrentDriveCode);
      DiskDrivePercent:=Round(Abs(DiskSpaceBytes/FreeDriveSpace)*100);
      FreeHDDSpaceProgressBar.Position:=DiskDrivePercent;
      FreeDriveSpaceString:=inttostr(Round(FreeDriveSpace/(1024*1024)));
      DiskSpaceBytesText:=inttostr(Round(DiskSpaceBytes/(1024*1024)));
      // HDD Label
      HDDNameLabel.Caption:=inttostr(DiskDrivePercent)+'%'+' of free '+
      FreeDriveSpaceString+' MB on '+Copy(OutputPath,1,2);

      if MediaListFilesQ=1 then
      HDDNameLabel.Caption:=HDDNameLabel.Caption+' Total for '+
      inttostr(MediaListFilesQ)+' file:'+DiskSpaceBytesText+' MBytes';
      if MediaListFilesQ>1 then
      HDDNameLabel.Caption:=HDDNameLabel.Caption+' Total for '+
      inttostr(MediaListFilesQ)+' files:'+DiskSpaceBytesText+' MBytes';
      end;

end;

procedure TAppForm.DVDSizeComboBoxChange(Sender: TObject);
begin
// Calculate Disk Space
CalculateDiskSpace;
end;

procedure TAppForm.RunButtonClick(Sender: TObject);
begin
// Conversion Modes
if MessageDlg('Are you sure to start conversion?',
mtConfirmation, [mbYes, mbCancel], 0) = mrCancel then
      begin
      Exit;
      end
      else
      begin
      // OutputPath Exists?
      if DirectoryExists(OutputPath)=False then
            begin
            ShowMessage('Error! Output Folder does not exist!');
            Exit;
            end
            else
            begin
            // Directory Exists
            
            // Disable All Panels
            // Media Files Listing
            AddFileButton.Enabled:=False;
            RemoveButton.Enabled:=False;
            VideoAudioFilesListBox.Enabled:=False;
            // Video Streams Listing
            VideoStreamsCheckListBox.Enabled:=False;
            // Audio Streams Listing
            AudioStreamsCheckListBox.Enabled:=False;
            // Video Settings
            ChangeSourceAspectRatioCheckBox.Enabled:=False;
            ChangeVideoFormatCheckBox.Enabled:=False;
            CustomVideoBitrateEdit.Enabled:=False;
            CustomVideoBitrateEdit.Color:=clScrollBar;
            CustomVideoSourceAspectRatioEdit.Enabled:=False;
            CustomVideoSourceAspectRatioEdit.Color:=clScrollBar;
            InterlacedFlag.Enabled:=False;
            HalfD1FrameSizeCheckBox.Enabled:=False;
            TwoPassConversionCheckBox.Enabled:=False;
            VideoBitrateComboBox.Enabled:=False;
            VideoBitrateLabel.Enabled:=False;
            VideoCopyCheckBox.Enabled:=False;
            VideoFormatComboBox.Enabled:=False;
            VideoFormatLabel.Enabled:=False;
            VideoSourceAspectRatio.Enabled:=False;
            VideoSourceAspectRatioComboBox.Enabled:=False;
            VideoTargetAspectRatioComboBox.Enabled:=False;
            VideoTargetAspectRatioLabel.Enabled:=False;
            // Audio Settings
            DisableAllAudioSettings;
            // Output Folder GroupBox
            ChangeButton.Enabled:=False;
            CreateFolderCheckBox.Enabled:=False;
            OutputFolderEdit.Enabled:=False;
            // DVD-Disk Size Combo Box
            DVDSizeComboBox.Enabled:=False;
            // Run Button Disabled
            RunButton.Enabled:=False;
            // Cancel Button Enabled
            CancelConversionButton.Enabled:=True;
            // Run Conversion Timer
            CurrentMediaConversionNum:=0;
            CurrentVideoConversionNum:=0;
            CurrentAudioConversionNum:=0;
            CurrentVideoConversionPassNum:=0;
            CopyProgress:=False;
            ConversionProgress:=False;
            AudioConversionProcess:=False;
            VideoConversionProcess:=False;
            NeedToBeRenamed:=False;
            PulldownNeeded:=False;
            Pulldown23_98:=False;
            Pulldown24_00:=False;
            AudioStreamsFinished:=False;
            VideoStreamsFinished:=False;
            ProcRunState:=0;
            ConversionTimePercent:=0;
            CopyVideoStream4PulldownFileName:='';

            // AppLog.txt file - Create
            AssignFile(AppLogTextFile,OutputPath+'AppLog.txt');
            Rewrite(AppLogTextFile);
            AppLogDateTime:=Time;
            AppLogTimeString:=TimeToStr(AppLogDateTime);
            Writeln(AppLogTextFile,AppLogTimeString+' *** '+AppForm.Caption+' Version: '+AppVersion+' ***');
            Writeln(AppLogTextFile,AppLogTimeString+' http://beginwithsoftware.com/videoguides/batchdvdstreamsconverter.html');
            Writeln(AppLogTextFile,'');
            Writeln(AppLogTextFile,AppLogTimeString+' *** Processing started ***');

            AppLogFileClosed:=False;

            // Start Conversion Timer
            ConversionTimer.Enabled:=True;

            // End of -> if DirectoryExists(OutputPath)=False
            end;



      // End of -> MessageDlg('Are you sure to start conversion?',
      end;
end;

procedure TAppForm.CancelConversionButtonClick(Sender: TObject);
begin
// Cancel Conversion Process
if MessageDlg('Are you sure to cancel conversion?',
mtWarning, [mbNo, mbYes], 0) = mrNo then
      begin
      Exit;
      end
      else
      begin
      // Conversion Timer Terminating
      ConversionTimer.Enabled:=False;
      // EXE Terminating
      if hProc<>0 then
      begin
      TerminateProcess(hProc,0);
      FreeConsole;
      end;
      // Activating Panels
      // Media Files Listing
      AddFileButton.Enabled:=True;
      RemoveButton.Enabled:=True;
      VideoAudioFilesListBox.Enabled:=True;
      // Video Streams Listing
      VideoStreamsCheckListBox.Enabled:=True;
      // Audio Streams Listing
      AudioStreamsCheckListBox.Enabled:=True;
      // Detecting Selected Media File
      ChangedMediaFilesPos:=VideoAudioFilesListBox.ItemIndex;
      VideoAudioFilesListBox.ItemIndex:=ChangedMediaFilesPos;
      VideoAudioFilesListBox.Selected[ChangedMediaFilesPos]:=True;
      VideoAudioFilesListBoxClick(AppForm);
      // Output Folder GroupBox
      ChangeButton.Enabled:=True;
      CreateFolderCheckBox.Enabled:=True;
      OutputFolderEdit.Enabled:=True;
      // DVD-Disk Size Combo Box
      DVDSizeComboBox.Enabled:=True;
      // Cancel button Disabled
      CancelConversionButton.Enabled:=False;
      // Calculate Disk Space
      CalculateDiskSpace;
      // AppLog.txt file - Close
      if AppLogFileClosed=False then
            begin
            Writeln(AppLogTextFile,'');
            AppLogTimeString:=TimeToStr(AppLogDateTime);
            Writeln(AppLogTextFile,AppLogTimeString+' *** Cancelled processing ***');
            CloseFile(AppLogTextFile);
            AppLogFileClosed:=True;
            end;
      // Run Button Enabled
      RunButton.Enabled:=True;
      end;


end;

procedure TAppForm.ConversionTimerTimer(Sender: TObject);
var
FindingWindowRep,AudioFirstChecked,ProcRunState,DeleteCount,
ConversionTimePos,TimeErrorCode,Int_Videosize_Calculated,FindFileCount:Integer;
CopyCMD,ConversionCMD,PassCMD,ARTest,Search4RenameFile,Ext4RenameFile,Ext4CopyFile,
ConversionFullString,ConversionTimeString,
ConversionProgressGroupBoxText,CopyProgressFullFileName:string;
RenameRes,DG_VideoSize_Calculated:boolean;
WaitPulldown:DWORD;
ConversionTimeReal:Real;
CopyProgressCurrentFileSize,CopyProgressVideoSize:Int64;
begin
// Both modes in this timer
// Check the process running state
ProcRunState:=WaitForSingleObject(hProc,10);


      // No active process
      if ProcRunState<=0 then
            begin

                  // Prepare for the next media file
                  if  (AudioStreamsFinished=True) and
                      (VideoStreamsFinished=True) then
                            begin

                            // Rename resulting files
                            if NeedToBeRenamed=True then
                                  begin
                                  // Rename Video Streams
                                  for i:=1 to VideoStreamCount[RealConversionMediaNum] do
                                        begin
                                        // Search Video Streams Files
                                        if VideoStreamsRename[i]<>'' then
                                              begin
                                              // AppLog.txt file - Rename video stream
                                              AppLogDateTime:=Time;
                                              AppLogTimeString:=TimeToStr(AppLogDateTime);
                                              Writeln(AppLogTextFile,AppLogTimeString+' '+'Renaming File '+inttostr(CurrentMediaConversionNum)+', Video Stream '+inttostr(i));
                                              // Search start
                                              If FindFirst(CurrentConversionOutputPath+VideoStreamsRename[i]+'.demuxed.*', faAnyFile, DeleteRenameSearch)=0 then
                                                    begin
                                                    Search4RenameFile:=DeleteRenameSearch.Name;
                                                    Ext4RenameFile:=ExtractFileExt(Search4RenameFile);
                                                    FindFileCount:=0;

                                                    // Find the next file if the previous with '.d2v' extension
                                                    if Ext4RenameFile='.d2v' then
                                                    repeat
                                                    inc(FindFileCount);
                                                    if FindFileCount>700 then break;
                                                    FindNext(DeleteRenameSearch);
                                                    Search4RenameFile:=DeleteRenameSearch.Name;
                                                    Ext4RenameFile:=ExtractFileExt(Search4RenameFile);
                                                    sleep(10);
                                                    until (Ext4RenameFile<>'.d2v');

                                                    // AppLog.txt file - Log old video stream file name
                                                    AppLogDateTime:=Time;
                                                    AppLogTimeString:=TimeToStr(AppLogDateTime);
                                                    Writeln(AppLogTextFile,AppLogTimeString+' '+'Temporary Video Stream '+inttostr(i)+' File Name:');
                                                    Writeln(AppLogTextFile,AppLogTimeString+' '+Search4RenameFile);

                                                    RenameRes:=RenameFile(CurrentConversionOutputPath+Search4RenameFile,
                                                    CurrentConversionOutputPath+VideoStreamsRename[i]+Ext4RenameFile);

                                                    If RenameRes=False then
                                                          begin
                                                          // Delete old copy of the target video file
                                                          DeleteCount:=0;
                                                          repeat
                                                          Sleep(10);
                                                          inc(DeleteCount);
                                                          If DeleteCount>300 then Break;
                                                          DelRes:=DeleteFile(CurrentConversionOutputPath+VideoStreamsRename[i]+Ext4RenameFile);
                                                          until (DelRes<>False);

                                                          // AppLog.txt file - Log old video stream file name to erase
                                                          AppLogDateTime:=Time;
                                                          AppLogTimeString:=TimeToStr(AppLogDateTime);
                                                          Writeln(AppLogTextFile,AppLogTimeString+' '+'Erased Old Video Stream '+inttostr(i)+' File Name:');
                                                          Writeln(AppLogTextFile,AppLogTimeString+' '+VideoStreamsRename[i]+Ext4RenameFile);
                                                          
                                                          // Second attempt to rename
                                                          RenameRes:=RenameFile(CurrentConversionOutputPath+Search4RenameFile,
                                                          CurrentConversionOutputPath+VideoStreamsRename[i]+Ext4RenameFile);

                                                          end;

                                                    // Copy Video Stream 4 Pulldown File Name
                                                    CopyVideoStream4PulldownFileName:=
                                                    CurrentConversionOutputPath+VideoStreamsRename[i]+Ext4RenameFile;

                                                    end;
                                                    FindClose(DeleteRenameSearch);

                                                    // AppLog.txt file - Log new video stream file name
                                                    AppLogDateTime:=Time;
                                                    AppLogTimeString:=TimeToStr(AppLogDateTime);
                                                    Writeln(AppLogTextFile,AppLogTimeString+' '+'Final Video Stream '+inttostr(i)+' File Name:');
                                                    Writeln(AppLogTextFile,AppLogTimeString+' '+VideoStreamsRename[i]+Ext4RenameFile);

                                                    // Delete M2V file from video DGINDEX copying
                                                    DeleteCount:=0;
                                                    repeat
                                                    Sleep(10);
                                                    inc(DeleteCount);
                                                    If DeleteCount>300 then Break;
                                                    DelRes:=DeleteFile(CurrentConversionOutputPath+
                                                    VideoStreamsRename[i]+'.d2v');
                                                    until (DelRes<>False);

                                              end;

                                        end;


                                  // Rename Audio Streams
                                  for i:=1 to AudioStreamCount[RealConversionMediaNum] do
                                        begin
                                        if AudioStreamsRename[i]<>'' then
                                              begin
                                              // AppLog.txt file - Rename video stream
                                              AppLogDateTime:=Time;
                                              AppLogTimeString:=TimeToStr(AppLogDateTime);
                                              Writeln(AppLogTextFile,AppLogTimeString+' '+'Renaming File '+inttostr(CurrentMediaConversionNum)+', Audio Stream '+inttostr(i));
                                              // Search Audio Streams Files
                                              If FindFirst(CurrentConversionOutputPath+AudioStreamsRename[i]+'*.*', faAnyFile, DeleteRenameSearch)=0 then
                                                    begin
                                                    Search4RenameFile:=DeleteRenameSearch.Name;
                                                    Ext4RenameFile:=ExtractFileExt(Search4RenameFile);
                                                    FindFileCount:=0;

                                                    // Find the next file if the previous with '.d2v' extension
                                                    if Ext4RenameFile='.d2v' then
                                                    repeat
                                                    inc(FindFileCount);
                                                    if FindFileCount>700 then break;
                                                    FindNext(DeleteRenameSearch);
                                                    Search4RenameFile:=DeleteRenameSearch.Name;
                                                    Ext4RenameFile:=ExtractFileExt(Search4RenameFile);
                                                    sleep(10);
                                                    until (Ext4RenameFile<>'.d2v');

                                                    // AppLog.txt file - Log old audio stream file name
                                                    AppLogDateTime:=Time;
                                                    AppLogTimeString:=TimeToStr(AppLogDateTime);
                                                    Writeln(AppLogTextFile,AppLogTimeString+' '+'Temporary Audio Stream '+inttostr(i)+' File Name:');
                                                    Writeln(AppLogTextFile,AppLogTimeString+' '+Search4RenameFile);

                                                    // Rename File

                                                    RenameRes:=RenameFile(CurrentConversionOutputPath+Search4RenameFile,
                                                    CurrentConversionOutputPath+AudioStreamsRename[i]+Ext4RenameFile);

                                                    If RenameRes=False then
                                                          begin
                                                          // Delete old copy of the target audio file
                                                          DeleteCount:=0;
                                                          repeat
                                                          Sleep(10);
                                                          inc(DeleteCount);
                                                          If DeleteCount>300 then Break;
                                                          DelRes:=DeleteFile(CurrentConversionOutputPath+AudioStreamsRename[i]+Ext4RenameFile);
                                                          until (DelRes<>False);

                                                          // AppLog.txt file - Log old audio stream file name to erase
                                                          AppLogDateTime:=Time;
                                                          AppLogTimeString:=TimeToStr(AppLogDateTime);
                                                          Writeln(AppLogTextFile,AppLogTimeString+' '+'Erased Old Audio Stream '+inttostr(i)+' File Name:');
                                                          Writeln(AppLogTextFile,AppLogTimeString+' '+AudioStreamsRename[i]+Ext4RenameFile);

                                                          // Second attempt to rename
                                                          RenameRes:=RenameFile(CurrentConversionOutputPath+Search4RenameFile,
                                                          CurrentConversionOutputPath+AudioStreamsRename[i]+Ext4RenameFile);

                                                          end;

                                                    // AppLog.txt file - Log new audio stream file name
                                                    AppLogDateTime:=Time;
                                                    AppLogTimeString:=TimeToStr(AppLogDateTime);
                                                    Writeln(AppLogTextFile,AppLogTimeString+' '+'Final Audio Stream '+inttostr(i)+' File Name:');
                                                    Writeln(AppLogTextFile,AppLogTimeString+' '+AudioStreamsRename[i]+Ext4RenameFile);
                                                    
                                                    end;
                                                    FindClose(DeleteRenameSearch);

                                                    // Delete M2V file from audio DGINDEX copying
                                                    DeleteCount:=0;
                                                    repeat
                                                    Sleep(10);
                                                    inc(DeleteCount);
                                                    If DeleteCount>300 then Break;
                                                    DelRes:=DeleteFile(CurrentConversionOutputPath+
                                                    AudioStreamsRename[i]+'.d2v');
                                                    until (DelRes<>False);

                                              end;

                                        end;


                                  // Reset NeedToBeRenamed
                                  NeedToBeRenamed:=False;

                                  // End of -> Rename resulting file
                                  end;


                            // Delete 2-Pass log file
                            if FileExists(CurrentConversionOutputPath+'passlog.txt-0.log')=True then
                            DeleteFile(CurrentConversionOutputPath+'passlog.txt-0.log');


                            // Pulldown 23,976 and 24,000 fps for converted video streams
                            if (PulldownNeeded=True) and (SkipPulldown=False) then
                                  begin
                                  for i:=1 to VideoStreamCount[RealConversionMediaNum] do
                                        begin
                                        if  (VideoStreamFormat[RealConversionMediaNum,i]='NTSC Film') then
                                                    begin
                                                    if (VideoStreamFrameRate[RealConversionMediaNum,i]='29.97') and
                                                    (Interlaced[RealConversionMediaNum,i]=False) then
                                                          begin
                                                          // Pulldown 23_98 Activate
                                                          Pulldown23_98:=True;
                                                          end;
                                                    if  (VideoStreamFrameRate[RealConversionMediaNum,i]='23.97') or
                                                    (VideoStreamFrameRate[RealConversionMediaNum,i]='23.98') then
                                                          begin
                                                          // Pulldown 23_98 Activate
                                                          Pulldown23_98:=True;
                                                          end;
                                                    if  (VideoStreamFrameRate[RealConversionMediaNum,i]='24.00') then
                                                          begin
                                                          // Pulldown 24_00 Activate
                                                          Pulldown24_00:=True;
                                                          end;
                                                    if  (VideoStreamFrameRate[RealConversionMediaNum,i]='25.00') then
                                                          begin
                                                          // Pulldown 23_98 Activate
                                                          Pulldown23_98:=True;
                                                          end;
                                                    // Run pulldown process
                                                    if (Pulldown23_98=True) or (Pulldown24_00=True) then
                                                          begin
                                                          
                                                          // AppLog.txt file - Log Pulldown for NTSC Film video stream
                                                          AppLogDateTime:=Time;
                                                          AppLogTimeString:=TimeToStr(AppLogDateTime);
                                                          Writeln(AppLogTextFile,AppLogTimeString+' '+'Pulldown File '+inttostr(CurrentMediaConversionNum)+', Video Stream '+inttostr(i));

                                                          // ConversionProgress GroupBox Message about Pulldown
                                                          ConversionProgressGroupBox.Caption:=' Conversion: File '+
                                                          inttostr(CurrentMediaConversionNum)+', '+
                                                          ExtractFileName(CurrentConversionMediaFile)+', Pulldown, Video Stream '+
                                                          inttostr(i);

                                                          ConversionSA.nLength := SizeOf(ConversionSA);
                                                          ConversionSA.bInheritHandle := True;
                                                          ConversionSA.lpSecurityDescriptor := nil;
                                                          FillChar(ConversionStartupInfo, SizeOf(ConversionStartupInfo),0);
                                                          ConversionStartupInfo.cb := SizeOf(ConversionStartupInfo);
                                                          ConversionStartupInfo.dwFlags:=STARTF_USESHOWWINDOW;
                                                          ConversionStartupInfo.wShowWindow:=SW_SHOWNORMAL;

                                                          // Command line for Pulldown

                                                          ConversionCMD:=AppPath+'DGPULLDOWN\DGPulldown.exe "'+
                                                          CurrentConversionOutputPath+
                                                          FileFolderText(CurrentMediaConversionNum)+'_'+
                                                          ExtractFileNameNoExt(CurrentConversionMediaFile)+
                                                          '_videostream_'+inttostr(i)+'.m2v" -o -srcfps ';

                                                          // 23_98 fps
                                                          if Pulldown23_98=True then
                                                                begin
                                                                ConversionCMD:=ConversionCMD+'24000/1001 ';
                                                                // AppLog.txt file - Log Pulldown 23,976 fps to 29,97 fps
                                                                AppLogDateTime:=Time;
                                                                AppLogTimeString:=TimeToStr(AppLogDateTime);
                                                                Writeln(AppLogTextFile,AppLogTimeString+' '+'Processing: 23,976 fps to 29,97 fps');
                                                                end;

                                                          // 24_00 fps
                                                          if Pulldown24_00=True then
                                                                begin
                                                                ConversionCMD:=ConversionCMD+'24 ';
                                                                // AppLog.txt file - Log Pulldown 24 fps to 29,97 fps
                                                                AppLogDateTime:=Time;
                                                                AppLogTimeString:=TimeToStr(AppLogDateTime);
                                                                Writeln(AppLogTextFile,AppLogTimeString+' '+'Processing: 24 fps to 29,97 fps');
                                                                end;

                                                          ConversionCMD:=ConversionCMD+'-destfps 29.97 -bff -start 00 00 00 00 -nodf -inplace';

                                                          CreateProcess(nil,
                                                          PChar(ConversionCMD),
                                                          nil,nil,False,0,nil,nil,
                                                          ConversionStartupInfo,
                                                          ConversionProcessInfo);
                                                          CloseHandle(ConversionProcessInfo.hThread);
                                                          PulldownhProc:=ConversionProcessInfo.hProcess;

                                                          // Wait for pulldown process
                                                          repeat
                                                          WaitPulldown:=WaitForSingleObject(PulldownhProc,10);
                                                          until (WaitPulldown=0);

                                                          // AppLog.txt file - Log Pulldown finished
                                                          AppLogDateTime:=Time;
                                                          AppLogTimeString:=TimeToStr(AppLogDateTime);
                                                          Writeln(AppLogTextFile,AppLogTimeString+' '+'Pulldown finished');

                                                          end;

                                                    end;


                                        end;


                                  // Reset Pulldown23_98
                                  Pulldown23_98:=False;

                                  // Reset Pulldown24_00
                                  Pulldown24_00:=False;

                                  // Reset PulldownNeeded
                                  PulldownNeeded:=False;
                                  end;


                            // If Pulldown is skipped

                            if (PulldownNeeded=True) and (SkipPulldown=True) then
                                  begin

                                  // AppLog.txt file - Log Pulldown was disabled for converted video streams
                                  AppLogDateTime:=Time;
                                  AppLogTimeString:=TimeToStr(AppLogDateTime);
                                  Writeln(AppLogTextFile,AppLogTimeString+' '+'Warning! Pulldown was disabled for converted video streams!');

                                  // Reset Pulldown23_98
                                  Pulldown23_98:=False;

                                  // Reset Pulldown24_00
                                  Pulldown24_00:=False;

                                  // Reset PulldownNeeded
                                  PulldownNeeded:=False;

                                  end;
                            



                            // Start pulldown process for copied streams

                            for i:=1 to VideoStreamCount[RealConversionMediaNum] do
                                  begin
                                  if  (CopyVideoStreamPulldownMode[RealConversionMediaNum,i]<>'') and
                                      (CopyVideoStream[RealConversionMediaNum,i]=True) then
                                            begin
                                            if SkipPulldown=False then
                                                  begin
                                                  
                                                  // AppLog.txt file - Log Pulldown for NTSC Film video stream
                                                  AppLogDateTime:=Time;
                                                  AppLogTimeString:=TimeToStr(AppLogDateTime);
                                                  Writeln(AppLogTextFile,AppLogTimeString+' '+'Pulldown File '+inttostr(CurrentMediaConversionNum)+', Video Stream '+inttostr(i));

                                                  // ConversionProgress GroupBox Message about Pulldown
                                                  ConversionProgressGroupBox.Caption:=' Copying: File '+
                                                  inttostr(CurrentMediaConversionNum)+', '+
                                                  ExtractFileName(CurrentConversionMediaFile)+', Pulldown, Video Stream '+
                                                  inttostr(i);

                                                  ConversionSA.nLength := SizeOf(ConversionSA);
                                                  ConversionSA.bInheritHandle := True;
                                                  ConversionSA.lpSecurityDescriptor := nil;
                                                  FillChar(ConversionStartupInfo, SizeOf(ConversionStartupInfo),0);
                                                  ConversionStartupInfo.cb := SizeOf(ConversionStartupInfo);
                                                  ConversionStartupInfo.dwFlags:=STARTF_USESHOWWINDOW;
                                                  ConversionStartupInfo.wShowWindow:=SW_SHOWNORMAL;

                                                  // Command line for Pulldown

                                                  ConversionCMD:=AppPath+'DGPULLDOWN\DGPulldown.exe "'+
                                                  CopyVideoStream4PulldownFileName+
                                                  '" -o -srcfps ';

                                                  // 23_98 fps
                                                  if CopyVideoStreamPulldownMode[RealConversionMediaNum,i]='23.98' then
                                                        begin
                                                        ConversionCMD:=ConversionCMD+'24000/1001 ';
                                                        // AppLog.txt file - Log Pulldown 23,976 fps to 29,97 fps
                                                        AppLogDateTime:=Time;
                                                        AppLogTimeString:=TimeToStr(AppLogDateTime);
                                                        Writeln(AppLogTextFile,AppLogTimeString+' '+'Processing: 23,976 fps to 29,97 fps');
                                                        end;

                                                  // 24_00 fps
                                                  if CopyVideoStreamPulldownMode[RealConversionMediaNum,i]='24.00' then
                                                        begin
                                                        ConversionCMD:=ConversionCMD+'24 ';
                                                        // AppLog.txt file - Log Pulldown 24 fps to 29,97 fps
                                                        AppLogDateTime:=Time;
                                                        AppLogTimeString:=TimeToStr(AppLogDateTime);
                                                        Writeln(AppLogTextFile,AppLogTimeString+' '+'Processing: 24 fps to 29,97 fps');
                                                        end;

                                                  ConversionCMD:=ConversionCMD+'-destfps 29.97 -bff -start 00 00 00 00 -nodf -inplace';

                                                  CreateProcess(nil,
                                                  PChar(ConversionCMD),
                                                  nil,nil,False,0,nil,nil,
                                                  ConversionStartupInfo,
                                                  ConversionProcessInfo);
                                                  CloseHandle(ConversionProcessInfo.hThread);
                                                  PulldownhProc:=ConversionProcessInfo.hProcess;

                                                  // Wait for pulldown process
                                                  repeat
                                                  WaitPulldown:=WaitForSingleObject(PulldownhProc,10);
                                                  until (WaitPulldown=0);

                                                  // AppLog.txt file - Log Pulldown finished
                                                  AppLogDateTime:=Time;
                                                  AppLogTimeString:=TimeToStr(AppLogDateTime);
                                                  Writeln(AppLogTextFile,AppLogTimeString+' '+'Pulldown finished');

                                                  end
                                                  else
                                                  begin

                                                  // AppLog.txt file - Log Pulldown was disabled for copied video stream
                                                  AppLogDateTime:=Time;
                                                  AppLogTimeString:=TimeToStr(AppLogDateTime);
                                                  Writeln(AppLogTextFile,AppLogTimeString+' '+'Warning! Pulldown was disabled for copied video stream:');
                                                  Writeln(AppLogTextFile,AppLogTimeString+' '+CopyVideoStream4PulldownFileName);


                                                  end;



                                        end;


                                  end;



                                  // Reset CopyVideoStream4PulldownFileName
                                  CopyVideoStream4PulldownFileName:='';

                            // Get the next media file for conversion

                            // Progress Percent Label Re-Jump
                            ProgressPercentLabel.Caption:='100 % Done';
                            // Conversion ProgressBar
                            ConversionProgressBar.Position:=100;

                            // VideoStreamsFinished
                            VideoStreamsFinished:=False;

                            // AudioStreamsFinished
                            AudioStreamsFinished:=False;

                            // Reset Audio and Video Streams Counters
                            CurrentVideoConversionNum:=0;
                            CurrentAudioConversionNum:=0;

                            // Video Pass
                            CurrentVideoConversionPassNum:=0;

                            // Conversion Time Percent
                            ConversionTimePercent:=0;

                            // Increase Media File Counter
                            inc(CurrentMediaConversionNum);

                            if CurrentMediaConversionNum>MediaListFilesQ then
                                  begin
                                  // All files were converted
                                  ConversionFinished;
                                  Exit;
                                  end
                                  else
                                  begin
                                  // Next media file exists in list
                                  RealConversionMediaNum:=RealPosition[CurrentMediaConversionNum];
                                  // Create or Not Folder
                                  CreateOrNotFolder;
                                  // Clear Video and Audio Streams Rename
                                  ClearVideoAudioStreamsRename;

                                  // AppLog.txt file - Log New Media File Processing Started
                                  AppLogDateTime:=Time;
                                  AppLogTimeString:=TimeToStr(AppLogDateTime);
                                  Writeln(AppLogTextFile,'');
                                  Writeln(AppLogTextFile,AppLogTimeString+' '+'Media File '+inttostr(CurrentMediaConversionNum)+' Processing');
                                  Writeln(AppLogTextFile,AppLogTimeString+' '+MediaFullInfo[RealConversionMediaNum]);
                                  end;

                            
                            // End of -> Prepare for the next media file
                            end;



                  // Increase media file number on start of conversion
                  if CurrentMediaConversionNum=0 then
                        begin
                        inc(CurrentMediaConversionNum);
                        RealConversionMediaNum:=RealPosition[CurrentMediaConversionNum];
                        // Create or Not Folder
                        CreateOrNotFolder;
                        // Clear Video and Audio Streams Rename
                        ClearVideoAudioStreamsRename;

                        // AppLog.txt file - Log New Media File Processing Started
                        AppLogDateTime:=Time;
                        AppLogTimeString:=TimeToStr(AppLogDateTime);
                        Writeln(AppLogTextFile,'');
                        Writeln(AppLogTextFile,AppLogTimeString+' '+'Media File '+inttostr(CurrentMediaConversionNum)+' Processing');
                        Writeln(AppLogTextFile,AppLogTimeString+' '+MediaFullInfo[RealConversionMediaNum]);

                        end;

                  // Current Conversion Media File
                  CurrentConversionMediaFile:=VideoAudioFilesListBox.Items[CurrentMediaConversionNum-1];

                  // Video Streams
                  if  (VideoStreamCount[RealConversionMediaNum]>0) and
                      (CurrentVideoConversionNum<=VideoStreamCount[RealConversionMediaNum]) then
                              // Work with the video stream
                              begin
                              // Check - if any 2-pass process running
                              if (CurrentVideoConversionPassNum=0) or
                              (CurrentVideoConversionPassNum=2) then
                              inc(CurrentVideoConversionNum);
                                    // Stop with non-existing video stream number
                                    if CurrentVideoConversionNum>VideoStreamCount[RealConversionMediaNum] then
                                    Exit;

                              // Copy Video Stream
                                    if  (CopyVideoStream[RealConversionMediaNum,CurrentVideoConversionNum]=True) and
                                        (VideoStreamChecked[RealConversionMediaNum,CurrentVideoConversionNum]=True) then
                                              begin
                                              ZeroMemory(@DGsi, sizeof(DGsi));
                                              DGsi.cb := sizeof(DGsi);
                                              DGsi.dwFlags:=STARTF_USESHOWWINDOW;
                                              DGsi.wShowWindow:=SW_HIDE;
                                              VideoCopyCMD(CurrentConversionMediaFile,
                                              CurrentVideoConversionNum,CopyCMD);

                                              // AppLog.txt file - Log Copy Video Stream
                                              AppLogDateTime:=Time;
                                              AppLogTimeString:=TimeToStr(AppLogDateTime);
                                              Writeln(AppLogTextFile,AppLogTimeString+' '+'Media File '+inttostr(CurrentMediaConversionNum)+', Video Stream '+inttostr(CurrentVideoConversionNum)+' Copying');
                                              Writeln(AppLogTextFile,AppLogTimeString+' '+CopyCMD);

                                              CreateProcess(nil,PChar(CopyCMD)
                                              ,nil, nil, false, 0, nil, nil, DGsi, DGpi);
                                              hProc:= DGpi.hProcess;
                                              CloseHandle(DGpi.hThread);
                                              DG_VideoSize_Calculated:=False;
                                              Int_Videosize_Calculated:=0;
                                              CopyProgress:=True;
                                              ConversionProgress:=False;
                                              NeedToBeRenamed:=True;
                                              end;
                                    // FFMPEG Conversion Launch
                                    if  (CopyVideoStream[RealConversionMediaNum,CurrentVideoConversionNum]=False) and
                                        (VideoStreamChecked[RealConversionMediaNum,CurrentVideoConversionNum]=True) then
                                              begin
                                              // Video Pass Variable
                                              PassCMD:='';
                                              If TwoPass[RealConversionMediaNum,CurrentVideoConversionNum]=True then
                                                    begin
                                                    inc(CurrentVideoConversionPassNum);
                                                    if CurrentVideoConversionPassNum=3 then CurrentVideoConversionPassNum:=1;
                                                    PassCMD:=inttostr(CurrentVideoConversionPassNum);
                                                    end;
                                              // Conversion Command Line
                                              VideoConvertCMD(CurrentConversionMediaFile,
                                              RealConversionMediaNum,CurrentVideoConversionNum,
                                              PassCMD,ConversionCMD);

                                              // AppLog.txt file - Log Convert Video Stream
                                              AppLogDateTime:=Time;
                                              AppLogTimeString:=TimeToStr(AppLogDateTime);
                                              if PassCMD<>'' then
                                                    begin
                                                    Writeln(AppLogTextFile,AppLogTimeString+' '+'Media File '+inttostr(CurrentMediaConversionNum)+', Video Stream '+inttostr(CurrentVideoConversionNum)+' Conversion, Pass '+PassCMD);
                                                    end
                                                    else
                                                    begin
                                                    Writeln(AppLogTextFile,AppLogTimeString+' '+'Media File '+inttostr(CurrentMediaConversionNum)+', Video Stream '+inttostr(CurrentVideoConversionNum)+' Conversion');
                                                    end;
                                              Writeln(AppLogTextFile,AppLogTimeString+' '+ConversionCMD);

                                              ConversionSA.nLength := SizeOf(ConversionSA);
                                              ConversionSA.bInheritHandle := True;
                                              ConversionSA.lpSecurityDescriptor := nil;
                                              FillChar(ConversionStartupInfo, SizeOf(ConversionStartupInfo),0);
                                              ConversionStartupInfo.cb := SizeOf(ConversionStartupInfo);
                                              ConversionStartupInfo.dwFlags:=STARTF_USESHOWWINDOW;
                                              ConversionStartupInfo.wShowWindow:=SW_SHOWNORMAL;
                                              AllocConsole;
                                              SetConsoleTitle(PChar('BatchDVDStreamsConverterProcess'));
                                              CreateProcess(nil,
                                              PChar(ConversionCMD),
                                              nil,nil,False,0,nil,nil,
                                              ConversionStartupInfo,
                                              ConversionProcessInfo);
                                              CloseHandle(ConversionProcessInfo.hThread);
                                              hProc:=ConversionProcessInfo.hProcess;
                                              FindingWindowRep:=0;
                                              repeat
                                              inc(FindingWindowRep);
                                              ConversionhWnd:= FindWindow(nil,'BatchDVDStreamsConverterProcess');
                                              Sleep(10);
                                              if FindingWindowRep>700 then break;
                                              until (ConversionhWnd<>0);
                                              ShowWindow(ConversionhWnd,SW_HIDE);

                                              ConversionProgress:=True;
                                              CopyProgress:=False;
                                              
                                              end;

                              end
                              else
                              // No video stream
                              begin
                              VideoStreamsFinished:=True;
                              end;

                  // Audio Streams
                  if    (AudioStreamCount[RealConversionMediaNum]>0) and
                        (CurrentAudioConversionNum<AudioStreamCount[RealConversionMediaNum]) then
                              // Work with the audio stream
                              begin
                              if VideoStreamsFinished=True then
                                    begin
                                    inc(CurrentAudioConversionNum);
                                    if AudioStreamChecked[RealConversionMediaNum,CurrentAudioConversionNum]=True then
                                          begin
                                          // Audio Stream is checked - go on
                                                      // Copy Audio Stream Using DGIndex

                                                      If (MediaFileType[RealConversionMediaNum]='mpeg') and
                                                      (AudioStreamInputFrequency[RealConversionMediaNum,CurrentAudioConversionNum]='48000') and
                                                      (CopyAudioStream[RealConversionMediaNum,CurrentAudioConversionNum]=True) then
                                                            begin

                                                            ZeroMemory(@DGsi, sizeof(DGsi));
                                                            DGsi.cb := sizeof(DGsi);
                                                            DGsi.dwFlags:=STARTF_USESHOWWINDOW;
                                                            DGsi.wShowWindow:=SW_HIDE;
                                                            AudioCopyCMD(CurrentConversionMediaFile,
                                                            CurrentAudioConversionNum,CopyCMD);

                                                            // AppLog.txt file - Log Copy Audio Stream using DGINDEX
                                                            AppLogDateTime:=Time;
                                                            AppLogTimeString:=TimeToStr(AppLogDateTime);
                                                            Writeln(AppLogTextFile,AppLogTimeString+' '+'Media File '+inttostr(CurrentMediaConversionNum)+', Audio Stream '+inttostr(CurrentAudioConversionNum)+' Copying');
                                                            Writeln(AppLogTextFile,AppLogTimeString+' '+CopyCMD);

                                                            CreateProcess(nil,PChar(CopyCMD),
                                                            nil, nil, false, 0, nil, nil, DGsi, DGpi);
                                                            hProc:= DGpi.hProcess;
                                                            CloseHandle(DGpi.hThread);
                                                            CopyProgress:=True;
                                                            ConversionProgress:=False;
                                                            NeedToBeRenamed:=True;
                                                            end;

                                                      // Copy Audio Stream Using FFMPEG

                                                      If (MediaFileType[RealConversionMediaNum]<>'mpeg') and
                                                      (AudioStreamInputFrequency[RealConversionMediaNum,CurrentAudioConversionNum]='48000') and
                                                      (CopyAudioStream[RealConversionMediaNum,CurrentAudioConversionNum]=True) then
                                                            begin
                                                            AudioCopyFFMPEGCMD(CurrentConversionMediaFile,
                                                            RealConversionMediaNum,CurrentAudioConversionNum,
                                                            ConversionCMD);

                                                            // AppLog.txt file - Log Copy Audio Stream using FFMPEG
                                                            AppLogDateTime:=Time;
                                                            AppLogTimeString:=TimeToStr(AppLogDateTime);
                                                            Writeln(AppLogTextFile,AppLogTimeString+' '+'Media File '+inttostr(CurrentMediaConversionNum)+', Audio Stream '+inttostr(CurrentAudioConversionNum)+' Copying');
                                                            Writeln(AppLogTextFile,AppLogTimeString+' '+ConversionCMD);

                                                            ConversionSA.nLength := SizeOf(ConversionSA);
                                                            ConversionSA.bInheritHandle := True;
                                                            ConversionSA.lpSecurityDescriptor := nil;
                                                            FillChar(ConversionStartupInfo, SizeOf(ConversionStartupInfo),0);
                                                            ConversionStartupInfo.cb := SizeOf(ConversionStartupInfo);
                                                            ConversionStartupInfo.dwFlags:=STARTF_USESHOWWINDOW;
                                                            ConversionStartupInfo.wShowWindow:=SW_SHOWNORMAL;
                                                            AllocConsole;
                                                            SetConsoleTitle(PChar('BatchDVDStreamsConverterProcess'));
                                                            CreateProcess(nil,
                                                            PChar(ConversionCMD),
                                                            nil,nil,False,0,nil,nil,
                                                            ConversionStartupInfo,
                                                            ConversionProcessInfo);
                                                            CloseHandle(ConversionProcessInfo.hThread);
                                                            hProc:=ConversionProcessInfo.hProcess;
                                                            FindingWindowRep:=0;
                                                            repeat
                                                            inc(FindingWindowRep);
                                                            ConversionhWnd:= FindWindow(nil,'BatchDVDStreamsConverterProcess');
                                                            Sleep(10);
                                                            if FindingWindowRep>700 then break;
                                                            until (ConversionhWnd<>0);
                                                            ShowWindow(ConversionhWnd,SW_HIDE);
                                                            ConversionProgress:=True;
                                                            CopyProgress:=False;
                                                            
                                                            end;

                                                      // Convert Audio Stream Using FFMPEG

                                                      if CopyAudioStream[RealConversionMediaNum,CurrentAudioConversionNum]=False then
                                                            begin
                                                            AudioConvertFFMPEGCMD(CurrentConversionMediaFile,
                                                            RealConversionMediaNum,CurrentAudioConversionNum,
                                                            ConversionCMD);

                                                            // AppLog.txt file - Log Convert Audio Stream using FFMPEG
                                                            AppLogDateTime:=Time;
                                                            AppLogTimeString:=TimeToStr(AppLogDateTime);
                                                            Writeln(AppLogTextFile,AppLogTimeString+' '+'Media File '+inttostr(CurrentMediaConversionNum)+', Audio Stream '+inttostr(CurrentAudioConversionNum)+' Conversion');
                                                            Writeln(AppLogTextFile,AppLogTimeString+' '+ConversionCMD);

                                                            ConversionSA.nLength := SizeOf(ConversionSA);
                                                            ConversionSA.bInheritHandle := True;
                                                            ConversionSA.lpSecurityDescriptor := nil;
                                                            FillChar(ConversionStartupInfo, SizeOf(ConversionStartupInfo),0);
                                                            ConversionStartupInfo.cb := SizeOf(ConversionStartupInfo);
                                                            ConversionStartupInfo.dwFlags:=STARTF_USESHOWWINDOW;
                                                            ConversionStartupInfo.wShowWindow:=SW_SHOWNORMAL;
                                                            AllocConsole;
                                                            SetConsoleTitle(PChar('BatchDVDStreamsConverterProcess'));
                                                            CreateProcess(nil,
                                                            PChar(ConversionCMD),
                                                            nil,nil,False,0,nil,nil,
                                                            ConversionStartupInfo,
                                                            ConversionProcessInfo);
                                                            CloseHandle(ConversionProcessInfo.hThread);
                                                            hProc:=ConversionProcessInfo.hProcess;
                                                            FindingWindowRep:=0;
                                                            repeat
                                                            inc(FindingWindowRep);
                                                            ConversionhWnd:= FindWindow(nil,'BatchDVDStreamsConverterProcess');
                                                            Sleep(10);
                                                            if FindingWindowRep>700 then break;
                                                            until (ConversionhWnd<>0);
                                                            ShowWindow(ConversionhWnd,SW_HIDE);
                                                            ConversionProgress:=True;
                                                            CopyProgress:=False;

                                                            end;

                                          end;


                                    end;
                              end
                              else
                              // No audio Stream
                              begin
                              AudioStreamsFinished:=True;
                              end;


            // End of -> No active process
            end;



      // Process in Progress
      if ProcRunState<>0 then
            begin
            // Conversion in progress
            if ConversionProgress=True then
                  begin
                  ConversionFullString:=ReadConversionData();
                  ConversionTimeString:='';
                  ConversionTimePos:=Pos(TextReverse('time='),TextReverse(ConversionFullString));
                  if ConversionTimePos>0 then
                        begin
                        ConversionTimePos:=Length(ConversionFullString)-ConversionTimePos+2;
                        ConversionTimeString:=Copy(ConversionFullString,ConversionTimePos,25);
                        // Extract to the first space
                        ConversionTimeString:=Copy(ConversionTimeString,1,Pos(' ',ConversionTimeString)-1);
                        val(ConversionTimeString,ConversionTimeReal,TimeErrorCode);
                        if TimeErrorCode=0 then
                              begin
                              if (MediaFileDuration[RealConversionMediaNum]=0) or (ConversionTimeReal=0) then
                              ConversionTimePercent:=100;
                              if (MediaFileDuration[RealConversionMediaNum]>0) and (ConversionTimeReal>0) then
                              ConversionTimePercent:=Round(Abs(ConversionTimeReal*100000/MediaFileDuration[RealConversionMediaNum]));
                              if ConversionTimePercent>100 then ConversionTimePercent:=100;
                              // ConversionProgress GroupBox Caption
                              ConversionProgressGroupBoxText:=' Conversion: File '+
                              inttostr(CurrentMediaConversionNum)+', '+
                              ExtractFileName(CurrentConversionMediaFile)+', ';
                              // Video Streams
                              if  (VideoStreamsFinished=False) then
                                        begin
                                        ConversionProgressGroupBoxText:=
                                        ConversionProgressGroupBoxText+'Video Stream '+
                                        inttostr(CurrentVideoConversionNum);
                                        // Video Pass
                                        if  (CurrentVideoConversionPassNum=1) or
                                            (CurrentVideoConversionPassNum=2) then
                                                  begin
                                                  ConversionProgressGroupBoxText:=
                                                  ConversionProgressGroupBoxText+', Pass '+
                                                  inttostr(CurrentVideoConversionPassNum)+' ';
                                                  end;

                                        end;
                              // Audio Streams
                              if  (VideoStreamsFinished=True) and
                                  (AudioStreamsFinished=False) then
                                        begin
                                        ConversionProgressGroupBoxText:=
                                        ConversionProgressGroupBoxText+'Audio Stream '+
                                        inttostr(CurrentAudioConversionNum)+' ';
                                        end;

                              ConversionProgressGroupBox.Caption:=ConversionProgressGroupBoxText;

                              // Progress Percent Label Caption
                              ProgressPercentLabel.Caption:=inttostr(ConversionTimePercent)+' % Done';
                              // Conversion ProgressBar
                              ConversionProgressBar.Position:=ConversionTimePercent;


                              end;



                        end;


                  end;


            // Copying in progress
            if CopyProgress=True then
                  begin
                  // Video Streams
                  if  (VideoStreamsFinished=False) then
                            begin

                            If FindFirst(CurrentConversionOutputPath+VideoStreamsRename[CurrentVideoConversionNum]+'.demuxed.*', faAnyFile, CopyProgressTS)=0 then
                                  begin
                                  CopyProgressFullFileName:=CurrentConversionOutputPath+CopyProgressTS.Name;

                                  // Calculate Video Stream Bitrate

                                  if (Int_VideoSize_Calculated=0) then
                                        begin
                                        DGAudioSpaceSegment:=0;
                                        DGVideoSpaceSegment:=0;
                                        // Source File Size
                                        FindFirst(CurrentConversionMediaFile,faAnyFile,DiskSpaceTS);
                                        DGMPEGFileSize:=DiskSpaceTS.FindData.nFileSizeHigh*4294967296+DiskSpaceTS.FindData.nFileSizeLow;
                                        FindClose(DiskSpaceTS);

                                        for j:=1 to AudioStreamCount[RealConversionMediaNum] do
                                              begin
                                              DGAudioSpaceSegment:=DGAudioSpaceSegment+
                                              Round(AudioStreamInputBitrate[RealConversionMediaNum,j]*0.125*MediaFileDuration[RealConversionMediaNum]);
                                              end;

                                        DGVideoSpaceSegment:=DGMPEGFileSize-DGAudioSpaceSegment;
                                        CopyProgressVideoSize:=DGVideoSpaceSegment;
                                        Int_VideoSize_Calculated:=1;
                                        end;


                                  // Percents
                                  FindFirst(CopyProgressFullFileName,faAnyFile,DiskSpaceTS);
                                  CopyProgressCurrentFileSize:=DiskSpaceTS.FindData.nFileSizeHigh*4294967296+DiskSpaceTS.FindData.nFileSizeLow;

                                  ConversionTimePercent:=Round(100*CopyProgressCurrentFileSize/CopyProgressVideoSize);
                                  if ConversionTimePercent>100 then ConversionTimePercent:=100;

                                  // ConversionProgress GroupBox Caption
                                  ConversionProgressGroupBoxText:=' Copying: File '+
                                  inttostr(CurrentMediaConversionNum)+', '+
                                  ExtractFileName(CurrentConversionMediaFile)+', Video Stream '+
                                  inttostr(CurrentVideoConversionNum)+' ';

                                  ConversionProgressGroupBox.Caption:=ConversionProgressGroupBoxText;

                                  // Progress Percent Label Caption
                                  ProgressPercentLabel.Caption:=inttostr(ConversionTimePercent)+' % Done';
                                  // Conversion ProgressBar
                                  ConversionProgressBar.Position:=ConversionTimePercent;                                                                    

                                  end;
                                  FindClose(CopyProgressTS);
                                  FindClose(DiskSpaceTS);


                             // End of -> Video Streams
                            end;

                  // Audio Streams
                  if  (VideoStreamsFinished=True) and
                      (AudioStreamsFinished=False) then
                            begin

                            If FindFirst(CurrentConversionOutputPath+AudioStreamsRename[CurrentAudioConversionNum]+'*.*', faAnyFile, CopyProgressTS)=0 then
                                  begin
                                  CopyProgressFullFileName:=CurrentConversionOutputPath+CopyProgressTS.Name;
                                  Ext4CopyFile:=ExtractFileExt(CopyProgressFullFileName);
                                  FindFileCount:=0;

                                  // Find the next file if the previous with '.d2v' extension
                                  if Ext4CopyFile='.d2v' then
                                  repeat
                                  inc(FindFileCount);
                                  if FindFileCount>700 then break;
                                  FindNext(CopyProgressTS);
                                  CopyProgressFullFileName:=CurrentConversionOutputPath+CopyProgressTS.Name;
                                  Ext4CopyFile:=ExtractFileExt(CopyProgressFullFileName);
                                  sleep(10);
                                  until (Ext4CopyFile<>'.d2v');
                                  FindClose(CopyProgressTS);

                                  // Audio Stream Size
                                  DGAudioSpaceSegment:=
                                  Round(AudioStreamInputBitrate[RealConversionMediaNum,CurrentAudioConversionNum]*0.125*MediaFileDuration[RealConversionMediaNum]);

                                  // Percents
                                  FindFirst(CopyProgressFullFileName,faAnyFile,DiskSpaceTS);
                                  CopyProgressCurrentFileSize:=DiskSpaceTS.FindData.nFileSizeHigh*4294967296+DiskSpaceTS.FindData.nFileSizeLow;

                                  ConversionTimePercent:=Round(100*CopyProgressCurrentFileSize/DGAudioSpaceSegment);
                                  if ConversionTimePercent>100 then ConversionTimePercent:=100;

                                  // ConversionProgress GroupBox Caption
                                  ConversionProgressGroupBoxText:=' Copying: File '+
                                  inttostr(CurrentMediaConversionNum)+', '+
                                  ExtractFileName(CurrentConversionMediaFile)+', Audio Stream '+
                                  inttostr(CurrentAudioConversionNum)+' ';

                                  ConversionProgressGroupBox.Caption:=ConversionProgressGroupBoxText;

                                  // Progress Percent Label Caption
                                  ProgressPercentLabel.Caption:=inttostr(ConversionTimePercent)+' % Done';
                                  // Conversion ProgressBar
                                  ConversionProgressBar.Position:=ConversionTimePercent;                                                                    

                                  end;
                                  FindClose(DiskSpaceTS);


                             // End of -> Audio Streams
                            end;



                  end;


            // End of -> Process in Progress
            end;

end;

procedure TAppForm.FormResize(Sender: TObject);
var
BorderPlus:Integer;
begin
// Resize AppForm Window
If AppForm.Width>1000 then
      begin
      BorderPlus:=Round(Abs((AppForm.Width-1000)/2));
      end
      else
      begin
      BorderPlus:=0;
      end;
      VideoAudioFilesGroupBox.Left:=4+BorderPlus;
      VideoAudioFilesListBox.Left:=8+BorderPlus;
      VideoStreamsGroupBox.Left:=4+BorderPlus;
      AudioStreamsGroupBox.Left:=396+BorderPlus;
      OutputFolderGroupBox.Left:=4+BorderPlus;
      ConversionProgressGroupBox.Left:=4+BorderPlus;
      FileInfoGroupBox.Left:=784+BorderPlus;
      VideoSettingsGroupBox.Left:=784+BorderPlus;
      AudioSettingsGroupBox.Left:=784+BorderPlus;
      CommandGroupBox.Left:=784+BorderPlus;
end;



procedure TAppForm.VideoCopyCMD(var MediaFileVideoCopyCMD:string; var VideoStreamCopyCMD: Integer; var ResultVideoCopyCMD:string);
var CleanVideoCopyName:string;
begin
CleanVideoCopyName:='';
// Make CMD Line to Copy Video Stream Using DGIndex
ResultVideoCopyCMD:=
AppPath+'DGINDEX\DGIndex.exe -IF=['+
MediaFileVideoCopyCMD+
'] -OM=0 -OFD=['+
CurrentConversionOutputPath+
FileFolderText(CurrentMediaConversionNum)+'_'+
ExtractFileNameNoExt(MediaFileVideoCopyCMD)+
'_videocopy_stream_'+inttostr(VideoStreamCopyCMD)+
'] -HIDE -EXIT';

CleanVideoCopyName:=FileFolderText(CurrentMediaConversionNum)+'_'+
ExtractFileNameNoExt(MediaFileVideoCopyCMD)+
'_videocopy_stream_'+inttostr(VideoStreamCopyCMD);

// Video Streams Rename
VideoStreamsRename[VideoStreamCopyCMD]:=CleanVideoCopyName;

end;

procedure TAppForm.AudioCopyCMD(var MediaFileAudioCopyCMD:string; var AudioStreamCopyCMD: Integer; var ResultAudioCopyCMD:string);
var CleanAudioCopyName:string;
begin
CleanAudioCopyName:='';
// Make CMD Line to Copy Audio Stream Using DGIndex
ResultAudioCopyCMD:=
AppPath+'DGINDEX\DGIndex.exe -IF=['+
MediaFileAudioCopyCMD+
'] -TN='+inttostr(AudioStream_DG_Copy_Index[RealConversionMediaNum,AudioStreamCopyCMD])+
' -OM=1 -OF=['+
CurrentConversionOutputPath+
FileFolderText(CurrentMediaConversionNum)+'_'+
ExtractFileNameNoExt(MediaFileAudioCopyCMD)+
'_audiocopy_stream_'+inttostr(AudioStreamCopyCMD);

CleanAudioCopyName:=
FileFolderText(CurrentMediaConversionNum)+'_'+
ExtractFileNameNoExt(MediaFileAudioCopyCMD)+
'_audiocopy_stream_'+inttostr(AudioStreamCopyCMD);

// Audio Delay
if AudioStreamDelay[RealConversionMediaNum,AudioStreamCopyCMD]<>'' then
      begin
      ResultAudioCopyCMD:=
      ResultAudioCopyCMD+'_delay_'+
      AudioStreamDelay[RealConversionMediaNum,AudioStreamCopyCMD];

      CleanAudioCopyName:=CleanAudioCopyName+'_delay_'+
      AudioStreamDelay[RealConversionMediaNum,AudioStreamCopyCMD];
      end;

ResultAudioCopyCMD:=
ResultAudioCopyCMD+'] -HIDE -EXIT';

// Audio Streams Rename
AudioStreamsRename[AudioStreamCopyCMD]:=CleanAudioCopyName;

end;

procedure TAppForm.VideoConvertCMD(var MediaFileVideoConvertCMD: string; var MediaFileVideoConvertRealNum, VideoStreamConvertCMD: Integer; var PassVideoConvertCMD, ResultVideoConvertCMD:string);
var
SourceARValue,XSizePix,YSizePix,XSizeCoeff:Real;
YSizeInt,Pad,YSizeIntFromText:Integer;
YSizeText:string;
begin
// Make CMD Line to Convert Video Stream Using FFMPEG
ResultVideoConvertCMD:=FFMPEGPath+' -i "'+
MediaFileVideoConvertCMD+'" -vcodec mpeg2video -an -b '+
VideoStreamBitrate[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]+'k '+
'-minrate '+
VideoStreamBitrate[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]+'k '+
'-maxrate '+
VideoStreamBitrate[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]+'k '+
'-bufsize 1835008 -packetsize 2048 -muxrate 10080000 -mbd rd -cmp 2 -preme 1 -precmp 2 -subcmp 8 -mbcmp 8 -sws_flags spline -sc_threshold -9000 -bf 1 -fflags genpts -strict very -f mpeg2video '+
'-aspect '+
VideoStreamTargetAR[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]+' -r ';
// Frame Rate
If VideoStreamFormat[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]='NTSC Film' then
      begin
            if (VideoStreamFrameRate[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]='29.97') and
            (Interlaced[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]=True) then
                  begin
                  ResultVideoConvertCMD:=ResultVideoConvertCMD+'29.97 ';
                  end;
            if (VideoStreamFrameRate[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]='29.97') and
            (Interlaced[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]=False) then
                  begin
                  ResultVideoConvertCMD:=ResultVideoConvertCMD+'23.98 '+'-top 0 ';
                  // Pulldown Needed
                  PulldownNeeded:=True;
                  end;
            if  (VideoStreamFrameRate[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]='23.97') or
                (VideoStreamFrameRate[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]='23.98') then
                  begin
                  ResultVideoConvertCMD:=ResultVideoConvertCMD+'23.98 '+'-top 0 ';
                  // Pulldown Needed
                  PulldownNeeded:=True;
                  end;
            if  (VideoStreamFrameRate[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]='24.00') then
                  begin
                  ResultVideoConvertCMD:=ResultVideoConvertCMD+'24.00 '+'-top 0 ';
                  // Pulldown Needed
                  PulldownNeeded:=True;
                  end;
            if  (VideoStreamFrameRate[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]='25.00') then
                  begin
                  ResultVideoConvertCMD:=ResultVideoConvertCMD+'23.98 '+'-top 0 ';
                  // Pulldown Needed
                  PulldownNeeded:=True;
                  end;
      end;
If VideoStreamFormat[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]='NTSC' then
      begin
      ResultVideoConvertCMD:=ResultVideoConvertCMD+'29.97 ';
      end;
If VideoStreamFormat[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]='PAL' then
      begin
      ResultVideoConvertCMD:=ResultVideoConvertCMD+'25.00 ';
      end;

// Frame Size
If HalfD1[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]=False then
      begin
      // PAL Full-D1
      If VideoStreamFormat[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]='PAL' then
            begin
            // 4:3 Target AR
            if VideoStreamTargetAR[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]='4:3' then
                  begin
                  SourceARValue:=AspectRatioRealValue(VideoStreamSourceAR[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]);
                  If SourceARValue<>1 then
                        begin
                        // Not 1:1 Source AR
                        YSizePix:=VideoStreamFrameSizeY[MediaFileVideoConvertRealNum,VideoStreamConvertCMD];
                        XSizePix:=SourceARValue*YSizePix;
                        XSizeCoeff:=768/XSizePix;
                        YSizeInt:=Round(Abs(YSizePix*XSizeCoeff));
                        YSizeInt:=NearestTo4(YSizeInt,576);
                        If (576-YSizeInt)<=4 then
                              begin
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 720x576 ';
                              end
                              else
                              begin
                              Pad:=Round(Abs((576-YSizeInt)/2));
                              YSizeText:=inttostr(576-Round(Abs(Pad*2)));
                              YSizeIntFromText:=576-Round(Abs(Pad*2));
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 720x'+
                              YSizeText+' -padtop '+inttostr(Pad)+' -padbottom '+inttostr(Pad)+' ';
                              end;
                        end
                        else
                        begin
                        // Source AR 1:1
                        YSizePix:=VideoStreamFrameSizeY[MediaFileVideoConvertRealNum,VideoStreamConvertCMD];
                        XSizePix:=VideoStreamFrameSizeX[MediaFileVideoConvertRealNum,VideoStreamConvertCMD];
                        XSizeCoeff:=768/XSizePix;
                        YSizeInt:=Round(Abs(YSizePix*XSizeCoeff));
                        YSizeInt:=NearestTo4(YSizeInt,576);
                        If (576-YSizeInt)<=4 then
                              begin
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 720x576 ';
                              end
                              else
                              begin
                              Pad:=Round(Abs((576-YSizeInt)/2));
                              YSizeText:=inttostr(576-Round(Abs(Pad*2)));
                              YSizeIntFromText:=576-Round(Abs(Pad*2));
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 720x'+
                              YSizeText+' -padtop '+inttostr(Pad)+' -padbottom '+inttostr(Pad)+' ';
                              end;
                        end;
                  // <- End Of 4:3
                  end;
            // 16:9 Target AR
            if VideoStreamTargetAR[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]='16:9' then
                  begin
                  SourceARValue:=AspectRatioRealValue(VideoStreamSourceAR[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]);
                  If SourceARValue<>1 then
                        begin
                        // Not 1:1 Source AR
                        YSizePix:=VideoStreamFrameSizeY[MediaFileVideoConvertRealNum,VideoStreamConvertCMD];
                        XSizePix:=SourceARValue*YSizePix;
                        XSizeCoeff:=1024/XSizePix;
                        YSizeInt:=Round(Abs(YSizePix*XSizeCoeff));
                        YSizeInt:=NearestTo4(YSizeInt,576);
                        If (576-YSizeInt)<=4 then
                              begin
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 720x576 ';
                              end
                              else
                              begin
                              Pad:=Round(Abs((576-YSizeInt)/2));
                              YSizeText:=inttostr(576-Round(Abs(Pad*2)));
                              YSizeIntFromText:=576-Round(Abs(Pad*2));
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 720x'+
                              YSizeText+' -padtop '+inttostr(Pad)+' -padbottom '+inttostr(Pad)+' ';
                              end;
                        end
                        else
                        begin
                        // Source AR 1:1
                        YSizePix:=VideoStreamFrameSizeY[MediaFileVideoConvertRealNum,VideoStreamConvertCMD];
                        XSizePix:=VideoStreamFrameSizeX[MediaFileVideoConvertRealNum,VideoStreamConvertCMD];
                        XSizeCoeff:=1024/XSizePix;
                        YSizeInt:=Round(Abs(YSizePix*XSizeCoeff));
                        YSizeInt:=NearestTo4(YSizeInt,576);
                        If (576-YSizeInt)<=4 then
                              begin
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 720x576 ';
                              end
                              else
                              begin
                              Pad:=Round(Abs((576-YSizeInt)/2));
                              YSizeText:=inttostr(576-Round(Abs(Pad*2)));
                              YSizeIntFromText:=576-Round(Abs(Pad*2));
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 720x'+
                              YSizeText+' -padtop '+inttostr(Pad)+' -padbottom '+inttostr(Pad)+' ';
                              end;
                        end;
                  // <- End Of 16:9
                  end;
            // <- End of PAL Full-D1
            end;
      // NTSC Full-D1
      If (VideoStreamFormat[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]='NTSC') or
      (VideoStreamFormat[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]='NTSC Film') then
            begin
            // 4:3 Target AR
            if VideoStreamTargetAR[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]='4:3' then
                  begin
                  SourceARValue:=AspectRatioRealValue(VideoStreamSourceAR[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]);
                  If SourceARValue<>1 then
                        begin
                        // Not 1:1 Source AR
                        YSizePix:=VideoStreamFrameSizeY[MediaFileVideoConvertRealNum,VideoStreamConvertCMD];
                        XSizePix:=SourceARValue*YSizePix;
                        XSizeCoeff:=640/XSizePix;
                        YSizeInt:=Round(Abs(YSizePix*XSizeCoeff));
                        YSizeInt:=NearestTo4(YSizeInt,480);
                        If (480-YSizeInt)<=4 then
                              begin
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 720x480 ';
                              end
                              else
                              begin
                              Pad:=Round(Abs((480-YSizeInt)/2));
                              YSizeText:=inttostr(480-Round(Abs(Pad*2)));
                              YSizeIntFromText:=480-Round(Abs(Pad*2));
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 720x'+
                              YSizeText+' -padtop '+inttostr(Pad)+' -padbottom '+inttostr(Pad)+' ';
                              end;
                        end
                        else
                        begin
                        // Source AR 1:1
                        YSizePix:=VideoStreamFrameSizeY[MediaFileVideoConvertRealNum,VideoStreamConvertCMD];
                        XSizePix:=VideoStreamFrameSizeX[MediaFileVideoConvertRealNum,VideoStreamConvertCMD];
                        XSizeCoeff:=640/XSizePix;
                        YSizeInt:=Round(Abs(YSizePix*XSizeCoeff));
                        YSizeInt:=NearestTo4(YSizeInt,480);
                        If (480-YSizeInt)<=4 then
                              begin
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 720x480 ';
                              end
                              else
                              begin
                              Pad:=Round(Abs((480-YSizeInt)/2));
                              YSizeText:=inttostr(480-Round(Abs(Pad*2)));
                              YSizeIntFromText:=480-Round(Abs(Pad*2));
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 720x'+
                              YSizeText+' -padtop '+inttostr(Pad)+' -padbottom '+inttostr(Pad)+' ';
                              end;
                        end;
                  // <- End Of 4:3
                  end;
            // 16:9 Target AR
            if VideoStreamTargetAR[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]='16:9' then
                  begin
                  SourceARValue:=AspectRatioRealValue(VideoStreamSourceAR[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]);
                  If SourceARValue<>1 then
                        begin
                        // Not 1:1 Source AR
                        YSizePix:=VideoStreamFrameSizeY[MediaFileVideoConvertRealNum,VideoStreamConvertCMD];
                        XSizePix:=SourceARValue*YSizePix;
                        XSizeCoeff:=852/XSizePix;
                        YSizeInt:=Round(Abs(YSizePix*XSizeCoeff));
                        YSizeInt:=NearestTo4(YSizeInt,480);
                        If (480-YSizeInt)<=4 then
                              begin
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 720x480 ';
                              end
                              else
                              begin
                              Pad:=Round(Abs((480-YSizeInt)/2));
                              YSizeText:=inttostr(480-Round(Abs(Pad*2)));
                              YSizeIntFromText:=480-Round(Abs(Pad*2));
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 720x'+
                              YSizeText+' -padtop '+inttostr(Pad)+' -padbottom '+inttostr(Pad)+' ';
                              end;
                        end
                        else
                        begin
                        // Source AR 1:1
                        YSizePix:=VideoStreamFrameSizeY[MediaFileVideoConvertRealNum,VideoStreamConvertCMD];
                        XSizePix:=VideoStreamFrameSizeX[MediaFileVideoConvertRealNum,VideoStreamConvertCMD];
                        XSizeCoeff:=852/XSizePix;
                        YSizeInt:=Round(Abs(YSizePix*XSizeCoeff));
                        YSizeInt:=NearestTo4(YSizeInt,480);
                        If (480-YSizeInt)<=4 then
                              begin
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 720x480 ';
                              end
                              else
                              begin
                              Pad:=Round(Abs((480-YSizeInt)/2));
                              YSizeText:=inttostr(480-Round(Abs(Pad*2)));
                              YSizeIntFromText:=480-Round(Abs(Pad*2));
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 720x'+
                              YSizeText+' -padtop '+inttostr(Pad)+' -padbottom '+inttostr(Pad)+' ';
                              end;
                        end;
                  // <- End Of 16:9
                  end;
            // <- End Of NTSC Full-D1
            end;
      // <- End Of Full-D1
      end;

If HalfD1[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]=True then
      begin
      // PAL Half-D1
      If VideoStreamFormat[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]='PAL' then
            begin
            // 4:3 Target AR
            if VideoStreamTargetAR[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]='4:3' then
                  begin
                  SourceARValue:=AspectRatioRealValue(VideoStreamSourceAR[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]);
                  If SourceARValue<>1 then
                        begin
                        // Not 1:1 Source AR
                        YSizePix:=VideoStreamFrameSizeY[MediaFileVideoConvertRealNum,VideoStreamConvertCMD];
                        XSizePix:=SourceARValue*YSizePix;
                        XSizeCoeff:=768/XSizePix;
                        YSizeInt:=Round(Abs(YSizePix*XSizeCoeff));
                        YSizeInt:=NearestTo4(YSizeInt,576);
                        If (576-YSizeInt)<=4 then
                              begin
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 352x576 ';
                              end
                              else
                              begin
                              Pad:=Round(Abs((576-YSizeInt)/2));
                              YSizeText:=inttostr(576-Round(Abs(Pad*2)));
                              YSizeIntFromText:=576-Round(Abs(Pad*2));
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 352x'+
                              YSizeText+' -padtop '+inttostr(Pad)+' -padbottom '+inttostr(Pad)+' ';
                              end;
                        end
                        else
                        begin
                        // Source AR 1:1
                        YSizePix:=VideoStreamFrameSizeY[MediaFileVideoConvertRealNum,VideoStreamConvertCMD];
                        XSizePix:=VideoStreamFrameSizeX[MediaFileVideoConvertRealNum,VideoStreamConvertCMD];
                        XSizeCoeff:=768/XSizePix;
                        YSizeInt:=Round(Abs(YSizePix*XSizeCoeff));
                        YSizeInt:=NearestTo4(YSizeInt,576);
                        If (576-YSizeInt)<=4 then
                              begin
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 352x576 ';
                              end
                              else
                              begin
                              Pad:=Round(Abs((576-YSizeInt)/2));
                              YSizeText:=inttostr(576-Round(Abs(Pad*2)));
                              YSizeIntFromText:=576-Round(Abs(Pad*2));
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 352x'+
                              YSizeText+' -padtop '+inttostr(Pad)+' -padbottom '+inttostr(Pad)+' ';
                              end;
                        end;
                  // <- End Of 4:3
                  end;
            // 16:9 Target AR
            if VideoStreamTargetAR[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]='16:9' then
                  begin
                  SourceARValue:=AspectRatioRealValue(VideoStreamSourceAR[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]);
                  If SourceARValue<>1 then
                        begin
                        // Not 1:1 Source AR
                        YSizePix:=VideoStreamFrameSizeY[MediaFileVideoConvertRealNum,VideoStreamConvertCMD];
                        XSizePix:=SourceARValue*YSizePix;
                        XSizeCoeff:=1024/XSizePix;
                        YSizeInt:=Round(Abs(YSizePix*XSizeCoeff));
                        YSizeInt:=NearestTo4(YSizeInt,576);
                        If (576-YSizeInt)<=4 then
                              begin
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 352x576 ';
                              end
                              else
                              begin
                              Pad:=Round(Abs((576-YSizeInt)/2));
                              YSizeText:=inttostr(576-Round(Abs(Pad*2)));
                              YSizeIntFromText:=576-Round(Abs(Pad*2));
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 352x'+
                              YSizeText+' -padtop '+inttostr(Pad)+' -padbottom '+inttostr(Pad)+' ';
                              end;
                        end
                        else
                        begin
                        // Source AR 1:1
                        YSizePix:=VideoStreamFrameSizeY[MediaFileVideoConvertRealNum,VideoStreamConvertCMD];
                        XSizePix:=VideoStreamFrameSizeX[MediaFileVideoConvertRealNum,VideoStreamConvertCMD];
                        XSizeCoeff:=1024/XSizePix;
                        YSizeInt:=Round(Abs(YSizePix*XSizeCoeff));
                        YSizeInt:=NearestTo4(YSizeInt,576);
                        If (576-YSizeInt)<=4 then
                              begin
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 352x576 ';
                              end
                              else
                              begin
                              Pad:=Round(Abs((576-YSizeInt)/2));
                              YSizeText:=inttostr(576-Round(Abs(Pad*2)));
                              YSizeIntFromText:=576-Round(Abs(Pad*2));
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 352x'+
                              YSizeText+' -padtop '+inttostr(Pad)+' -padbottom '+inttostr(Pad)+' ';
                              end;
                        end;
                  // <- End Of 16:9
                  end;
            // <- End of PAL Half-D1
            end;
      // NTSC Half-D1
      If (VideoStreamFormat[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]='NTSC') or
      (VideoStreamFormat[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]='NTSC Film') then
            begin
            // 4:3 Target AR
            if VideoStreamTargetAR[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]='4:3' then
                  begin
                  SourceARValue:=AspectRatioRealValue(VideoStreamSourceAR[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]);
                  If SourceARValue<>1 then
                        begin
                        // Not 1:1 Source AR
                        YSizePix:=VideoStreamFrameSizeY[MediaFileVideoConvertRealNum,VideoStreamConvertCMD];
                        XSizePix:=SourceARValue*YSizePix;
                        XSizeCoeff:=640/XSizePix;
                        YSizeInt:=Round(Abs(YSizePix*XSizeCoeff));
                        YSizeInt:=NearestTo4(YSizeInt,480);
                        If (480-YSizeInt)<=4 then
                              begin
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 352x480 ';
                              end
                              else
                              begin
                              Pad:=Round(Abs((480-YSizeInt)/2));
                              YSizeText:=inttostr(480-Round(Abs(Pad*2)));
                              YSizeIntFromText:=480-Round(Abs(Pad*2));
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 352x'+
                              YSizeText+' -padtop '+inttostr(Pad)+' -padbottom '+inttostr(Pad)+' ';
                              end;
                        end
                        else
                        begin
                        // Source AR 1:1
                        YSizePix:=VideoStreamFrameSizeY[MediaFileVideoConvertRealNum,VideoStreamConvertCMD];
                        XSizePix:=VideoStreamFrameSizeX[MediaFileVideoConvertRealNum,VideoStreamConvertCMD];
                        XSizeCoeff:=640/XSizePix;
                        YSizeInt:=Round(Abs(YSizePix*XSizeCoeff));
                        YSizeInt:=NearestTo4(YSizeInt,480);
                        If (480-YSizeInt)<=4 then
                              begin
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 352x480 ';
                              end
                              else
                              begin
                              Pad:=Round(Abs((480-YSizeInt)/2));
                              YSizeText:=inttostr(480-Round(Abs(Pad*2)));
                              YSizeIntFromText:=480-Round(Abs(Pad*2));
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 352x'+
                              YSizeText+' -padtop '+inttostr(Pad)+' -padbottom '+inttostr(Pad)+' ';
                              end;
                        end;
                  // <- End Of 4:3
                  end;
            // 16:9 Target AR
            if VideoStreamTargetAR[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]='16:9' then
                  begin
                  SourceARValue:=AspectRatioRealValue(VideoStreamSourceAR[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]);
                  If SourceARValue<>1 then
                        begin
                        // Not 1:1 Source AR
                        YSizePix:=VideoStreamFrameSizeY[MediaFileVideoConvertRealNum,VideoStreamConvertCMD];
                        XSizePix:=SourceARValue*YSizePix;
                        XSizeCoeff:=852/XSizePix;
                        YSizeInt:=Round(Abs(YSizePix*XSizeCoeff));
                        YSizeInt:=NearestTo4(YSizeInt,480);
                        If (480-YSizeInt)<=4 then
                              begin
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 352x480 ';
                              end
                              else
                              begin
                              Pad:=Round(Abs((480-YSizeInt)/2));
                              YSizeText:=inttostr(480-Round(Abs(Pad*2)));
                              YSizeIntFromText:=480-Round(Abs(Pad*2));
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 352x'+
                              YSizeText+' -padtop '+inttostr(Pad)+' -padbottom '+inttostr(Pad)+' ';
                              end;
                        end
                        else
                        begin
                        // Source AR 1:1
                        YSizePix:=VideoStreamFrameSizeY[MediaFileVideoConvertRealNum,VideoStreamConvertCMD];
                        XSizePix:=VideoStreamFrameSizeX[MediaFileVideoConvertRealNum,VideoStreamConvertCMD];
                        XSizeCoeff:=852/XSizePix;
                        YSizeInt:=Round(Abs(YSizePix*XSizeCoeff));
                        YSizeInt:=NearestTo4(YSizeInt,480);
                        If (480-YSizeInt)<=4 then
                              begin
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 352x480 ';
                              end
                              else
                              begin
                              Pad:=Round(Abs((480-YSizeInt)/2));
                              YSizeText:=inttostr(480-Round(Abs(Pad*2)));
                              YSizeIntFromText:=480-Round(Abs(Pad*2));
                              ResultVideoConvertCMD:=ResultVideoConvertCMD+'-s 352x'+
                              YSizeText+' -padtop '+inttostr(Pad)+' -padbottom '+inttostr(Pad)+' ';
                              end;
                        end;
                  // <- End Of 16:9
                  end;
            // <- End of NTSC Half-D1
            end;
      // <- End Of Half-D1
      end;

// Stream Map
ResultVideoConvertCMD:=ResultVideoConvertCMD+'-map '+
VideoStreamMap[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]+' ';

// Video n-th Pass
If PassVideoConvertCMD<>'' then
ResultVideoConvertCMD:=ResultVideoConvertCMD+'-pass '+
PassVideoConvertCMD+' -passlogfile "'+
CurrentConversionOutputPath+'passlog.txt" ';

// Interlaced
If Interlaced[MediaFileVideoConvertRealNum,VideoStreamConvertCMD]=True then
ResultVideoConvertCMD:=ResultVideoConvertCMD+'-ilme -o -y '
else
ResultVideoConvertCMD:=ResultVideoConvertCMD+'-y ';

// Output path
ResultVideoConvertCMD:=ResultVideoConvertCMD+'"'+
CurrentConversionOutputPath+
FileFolderText(CurrentMediaConversionNum)+'_'+
ExtractFileNameNoExt(MediaFileVideoConvertCMD)+
'_videostream_'+inttostr(VideoStreamConvertCMD)+'.m2v"';

end;


procedure TAppForm.AudioCopyFFMPEGCMD(var MediaFileAudioCopyFFMPEGCMD: string;
 var MediaFileAudioCopyFFMPEGRealNum, AudioStreamCopyFFMPEGCMD: Integer;
  var ResultAudioCopyFFMPEGCMD:string);
begin
// Copy Audio Stream Using FFMPEG
//  - for PCM and AC3 streams inside other than MPEG containers
ResultAudioCopyFFMPEGCMD:=FFMPEGPath+' -i "'+
MediaFileAudioCopyFFMPEGCMD+'" -acodec ';

// AC3 Copying
if AudioStreamType[MediaFileAudioCopyFFMPEGRealNum,AudioStreamCopyFFMPEGCMD]='ac3' then
      begin
      ResultAudioCopyFFMPEGCMD:=
      ResultAudioCopyFFMPEGCMD+'copy '+
      '-map '+
      AudioStreamMap[MediaFileAudioCopyFFMPEGRealNum,AudioStreamCopyFFMPEGCMD]+' -y "'+
      CurrentConversionOutputPath+
      FileFolderText(CurrentMediaConversionNum)+'_'+
      ExtractFileNameNoExt(MediaFileAudioCopyFFMPEGCMD)+
      '_audiostream_'+inttostr(AudioStreamCopyFFMPEGCMD);
            if AudioStreamDelay[MediaFileAudioCopyFFMPEGRealNum,AudioStreamCopyFFMPEGCMD]<>'' then
            ResultAudioCopyFFMPEGCMD:=
            ResultAudioCopyFFMPEGCMD+'_delay_'+
            AudioStreamDelay[MediaFileAudioCopyFFMPEGRealNum,AudioStreamCopyFFMPEGCMD];
      ResultAudioCopyFFMPEGCMD:=
      ResultAudioCopyFFMPEGCMD+'.ac3"';
      end;



// PCM Copying
if AudioStreamType[MediaFileAudioCopyFFMPEGRealNum,AudioStreamCopyFFMPEGCMD]='pcm_s16le' then
      begin
      ResultAudioCopyFFMPEGCMD:=
      ResultAudioCopyFFMPEGCMD+'pcm_s16le '+
      '-map '+
      AudioStreamMap[MediaFileAudioCopyFFMPEGRealNum,AudioStreamCopyFFMPEGCMD]+' -y "'+
      CurrentConversionOutputPath+
      FileFolderText(CurrentMediaConversionNum)+'_'+
      ExtractFileNameNoExt(MediaFileAudioCopyFFMPEGCMD)+
      '_audiostream_'+inttostr(AudioStreamCopyFFMPEGCMD);
            if AudioStreamDelay[MediaFileAudioCopyFFMPEGRealNum,AudioStreamCopyFFMPEGCMD]<>'' then
            ResultAudioCopyFFMPEGCMD:=
            ResultAudioCopyFFMPEGCMD+'_delay_'+
            AudioStreamDelay[MediaFileAudioCopyFFMPEGRealNum,AudioStreamCopyFFMPEGCMD];
      ResultAudioCopyFFMPEGCMD:=
      ResultAudioCopyFFMPEGCMD+'.wav"';
      end;




end;

procedure TAppForm.AudioConvertFFMPEGCMD(var MediaFileAudioConvertCMD: string;
 var MediaFileAudioConvertRealNum, AudioStreamConvertCMD: Integer;
  var ResultAudioConvertCMD:string);
var OutAudioFileExtension:string;
begin
// Convert audio stream using FFMPEG
// Clear Audio File Extension
OutAudioFileExtension:='';
ResultAudioConvertCMD:=FFMPEGPath+' -i "'+
MediaFileAudioConvertCMD+'" -acodec ';

// AC3 Format
if AC3Format[MediaFileAudioConvertRealNum, AudioStreamConvertCMD]=True then
      begin
      ResultAudioConvertCMD:=
      ResultAudioConvertCMD+'ac3 -ab '+
      AudioStreamBitrate[MediaFileAudioConvertRealNum, AudioStreamConvertCMD]+' ';
      OutAudioFileExtension:='.ac3';
      end;

// WAV Format
if WAVFormat[MediaFileAudioConvertRealNum, AudioStreamConvertCMD]=True then
      begin
      ResultAudioConvertCMD:=
      ResultAudioConvertCMD+'pcm_s16le ';
      OutAudioFileExtension:='.wav';
      end;

// Number of channels
// Mono
if AudioStreamChannels[MediaFileAudioConvertRealNum, AudioStreamConvertCMD]='mono' then
ResultAudioConvertCMD:=
ResultAudioConvertCMD+'-ac 1 ';
// Stereo
if AudioStreamChannels[MediaFileAudioConvertRealNum, AudioStreamConvertCMD]='stereo' then
ResultAudioConvertCMD:=
ResultAudioConvertCMD+'-ac 2 ';
// 6 Channels
if (AudioStreamChannels[MediaFileAudioConvertRealNum, AudioStreamConvertCMD]<>'mono')
and (AudioStreamChannels[MediaFileAudioConvertRealNum, AudioStreamConvertCMD]<>'stereo') then
ResultAudioConvertCMD:=
ResultAudioConvertCMD+'-ac 6 ';

// Audio Frequency Rate
ResultAudioConvertCMD:=
ResultAudioConvertCMD+'-ar 48000 ';

// Map audio stream
ResultAudioConvertCMD:=
ResultAudioConvertCMD+'-map '+
AudioStreamMap[MediaFileAudioConvertRealNum, AudioStreamConvertCMD]+' ';

// Output file
ResultAudioConvertCMD:=
ResultAudioConvertCMD+'-y "'+
CurrentConversionOutputPath+
FileFolderText(CurrentMediaConversionNum)+'_'+
ExtractFileNameNoExt(MediaFileAudioConvertCMD)+
'_audiostream_'+inttostr(AudioStreamConvertCMD);
      if AudioStreamDelay[MediaFileAudioConvertRealNum, AudioStreamConvertCMD]<>'' then
      ResultAudioConvertCMD:=
      ResultAudioConvertCMD+'_delay_'+
      AudioStreamDelay[MediaFileAudioConvertRealNum, AudioStreamConvertCMD];
ResultAudioConvertCMD:=
ResultAudioConvertCMD+
OutAudioFileExtension+'"';

end;

procedure TAppForm.CreateOrNotFolder();
begin
if CreateFolderCheckBox.Checked=True then
      begin
      CurrentConversionOutputPath:=OutputPath+FileFolderText(CurrentMediaConversionNum)+'\';
      CreateDirectory(PChar(CurrentConversionOutputPath),nil);
      end
      else
      begin
      CurrentConversionOutputPath:=OutputPath;
      end;
end;

procedure TAppForm.ConversionFinished();
var FinishedText:string;
begin
// Change program states when all media files are converted
ConversionTimer.Enabled:=False;
// Finished Captions
FinishedText:=' Finished. ';
if MediaListFilesQ=1 then
FinishedText:=FinishedText+'1 file processed. '
else
FinishedText:=FinishedText+inttostr(MediaListFilesQ)+' files processed. ';
ConversionProgressGroupBox.Caption:=FinishedText;

// EXE Terminating
if hProc<>0 then
begin
TerminateProcess(hProc,0);
FreeConsole;
end;
// Activating Panels
// Media Files Listing
AddFileButton.Enabled:=True;
RemoveButton.Enabled:=True;
VideoAudioFilesListBox.Enabled:=True;
// Video Streams Listing
VideoStreamsCheckListBox.Enabled:=True;
// Audio Streams Listing
AudioStreamsCheckListBox.Enabled:=True;
// Detecting Selected Media File
ChangedMediaFilesPos:=VideoAudioFilesListBox.ItemIndex;
VideoAudioFilesListBox.ItemIndex:=ChangedMediaFilesPos;
VideoAudioFilesListBox.Selected[ChangedMediaFilesPos]:=True;
VideoAudioFilesListBoxClick(AppForm);
// Output Folder GroupBox
ChangeButton.Enabled:=True;
CreateFolderCheckBox.Enabled:=True;
OutputFolderEdit.Enabled:=True;
// DVD-Disk Size Combo Box
DVDSizeComboBox.Enabled:=True;
// Cancel button Disabled
CancelConversionButton.Enabled:=False;
// Calculate Disk Space
CalculateDiskSpace;
// AppLog.txt file - Close
if AppLogFileClosed=False then
      begin
      AppLogDateTime:=Time;
      AppLogTimeString:=TimeToStr(AppLogDateTime);
      Writeln(AppLogTextFile,'');
      Writeln(AppLogTextFile,AppLogTimeString+' *** Finished ***');
      CloseFile(AppLogTextFile);
      AppLogFileClosed:=True;
      end;

// Run Button Enabled
RunButton.Enabled:=True;



// Shutdown PC if option is checked
if (AppMenu.Items[2].Items[2].Checked=True) then
      begin
      MyExitWindows(EWX_POWEROFF or EWX_FORCE);
      end;

end;

procedure TAppForm.ClearVideoAudioStreamsRename();
begin
for i:=1 to 20 do
      begin
      // Clear VideoStreamsRename
      VideoStreamsRename[i]:='';
      // Clear AudioStreamsRename
      AudioStreamsRename[i]:='';
      end;
end;

procedure TAppForm.ShutdownPCwhenfinishedClick(Sender: TObject);
var ShutDownChanged:boolean;
begin
ShutDownChanged:=False;
if (AppMenu.Items[2].Items[2].Checked=False) and (ShutDownChanged=False) then
      begin
      AppMenu.Items[2].Items[2].Checked:=True;
      ShutDownChanged:=True;
      end;
if (AppMenu.Items[2].Items[2].Checked=True) and (ShutDownChanged=False) then
      begin
      AppMenu.Items[2].Items[2].Checked:=False;
      ShutDownChanged:=True;
      end;
end;


procedure TAppForm.ClearDGStaticBufer();
var DGBufferClearIndex:integer;
begin
for DGBufferClearIndex:=0 to 255 do
      begin
      DGStaticBuffer[DGBufferClearIndex]:=Chr(0);
      end;
end;

procedure TAppForm.SkipPulldownMenuClick(Sender: TObject);
var PullDownChangedClick:boolean;
begin
PullDownChangedClick:=False;
if (AppMenu.Items[2].Items[1].Checked=False) and (PullDownChangedClick=False) then
      begin
      AppMenu.Items[2].Items[1].Checked:=True;
      PullDownChangedClick:=True;
      SkipPulldown:=True;
      end;
if (AppMenu.Items[2].Items[1].Checked=True) and (PullDownChangedClick=False) then
      begin
      AppMenu.Items[2].Items[1].Checked:=False;
      PullDownChangedClick:=True;
      SkipPulldown:=False;
      end;
end;

end.
